* Example how to display very large fonts in GUI at specific position
*
* For FlagShip 5 and 6
* Copyright (c) 2002 by multisoft GmbH, Munich, Germany 
* You may freely modify this source according to your needs and/or
* re-use any parts of it in your source code.
* Release $Date: 2005/11/21 13:35:35 $
*--------------------------------------------------------------------------
* Compile: FlagShip bigfont.prg ; ./a.out 
*
* MS-Windows: FlagShip bigfont.prg [-io-a|g] 
* Run:        bigfont  

#include "set.fh"

local cFont, nFontSize, lFontBold, lColorOn

local cName := space(30)
local nSize := 0
local cNameTrim, iRowPix, iColPix 

cFont     := Set(_SET_FONTNAME)
nFontSize := Set(_SET_FONTSIZE)
lFontBold := Set(_SET_FONTBOLD)
lColorOn  := Set(_SET_GUICOLORS)

SET FONT TO "Courier", 12     // my default font used to cursor position

SET GUICOLOR ON

@ 20,78 say " "               // ensure to have paint buffer space
setpos(1,4)                   // set display position accord.to default font

// SET FONT "Helvetica", 90 bold  
SET FONT "Helvetica", 140 bold  
set color to ("R+")           // == "R+/W"
?? "Welcome to"
?
// SET FONT "courier", 12 normal
// @ 20,80 say "x"
// setpos(7,4)                   // set new position accord.to default font

// SET FONT "Helveica" size 120 bold
// SET FONT "Helveica" size 90 bold
SET FONT "Helvetica" size 140 bold  
set color to ("B")
?? "FlagShip"

SET FONT "courier", 12 normal
setpos(18,0)                     // position of "Press any key..."

Set(_SET_FONTNAME, cFont    )    // restore font name
Set(_SET_FONTSIZE, nFontSize)    // restore font size
Set(_SET_FONTBOLD, lFontBold)    // restore font pitch
Set(_SET_GUICOLORS,lColorOn )    // SET GUICOLOR OFF

wait

SET GUICOLOR ON
@ 20,78 say " "                  // ensure to have paint buffer space

while .T.
   CLS
   SET FONT TO "Courier", 12     // my default font used to cursor position

   @ 1,0 say "Font name (or ESC)" get cName PICT "@K"
   @ 1, col() +3 say "size"       get nSize
   READ
   
   if lastkey() == K_ESC .or. empty(cName) .or. nSize <= 0
      exit
   endif
   
   setpos(3,5)       // line 3 of Courier/12
   iRowPix := row(.T.)
   iColPix := col(.T.)
   
   cNameTrim := alltrim(cName)
   SET FONT (cNameTrim), (nSize) bold  
   
   set color to ("R+")           // == "R+/W"
   ?? "Hello" + " / " + ;
      ltrim(m->oApplic:Font:SizePoint())
   
   // same font as selected, but 16pt bold
   setpos(iRowPix + row2pixel(1) +10, iColPix, .T.)  // add 1 row of selected font  
   iRowPix := row(.T.)

   SET COLOR TO "B+"
   SET FONT (cNameTrim), 16 bold  
   ?? m->oApplic:Font:FontFamily() + " / " + ;
      ltrim(m->oApplic:Font:SizePoint())

   // same font as selected, but 10pt normal
   setpos(iRowPix + row2pixel(1) +10, iColPix, .T.)  // add 1 row of selected font  
   iRowPix := row(.T.)

   SET COLOR TO 
   SET FONT (cNameTrim), 10  
   ?? m->oApplic:Font:FontFamily() + " / " + ;
      ltrim(m->oApplic:Font:SizePoint())

   SET FONT TO "Courier", 12     // my default font used to cursor position
   ?
   wait
   if lastkey() == K_ESC
      exit
   endif
enddo      

