// This example demonstrates different options of the @..BOX command
// applicable for both Terminal and GUI i/o in FlagShip 6.x
//
// You may freely modify this source according to your needs and/or
// re-use any parts of it in your source code.
// 
// Release $Date: 2005/11/21 13:36:16 $
//
// Compile: FlagShip boxcommand.prg 
// Execute: ./a.out  (or boxcommand.exe)  in GUI mode
//          boxcommand -io=t              for Terminal i/o in MS-Windows
//          newfswin ./a.out -io=t        Terminal i/o on Unix

#include "box.fh"

/* Enable to draw boxes and lines in GUI mode too
 */
SET GUITRANSL BOX ON       // display @..BOX lines also in GUI
SET GUITRANSL LINES ON     // display @..TO  lines also in GUI
SET GUITRANSL TEXT ON      // draw CHR(178..218) as PC8 graphic in GUI

// set font "courier", 12

setColorBackground("n/#f4edbe") // set light yellow background for GUI
cls

/* -------------- page 1 --------------
 * standard @..BOX invocation
 */
setColorBackground("N/W") 
@ 1,1 clear to 6,20
@ 1,1, 6, 20 box                             // GUI + terminal i/o
@ 3,5 say "standard"

@ 1,25, 6,29 gui box                         // GUI mode only   
@ 1,31, 6,35 gui box PLAIN LINE 1            // GUI mode only

// setColorBackground(255,255,255)           // same as W+ background
setColorBackground("N/W+")                   // for GUI i/o
set color to "N/W+"                          // for Terminal i/o
@ 1,41 clear to 6,60
@ 1,41, 6, 60 box B_PLAIN color "N/W+"       // GUI + terminal i/o
@ 3,45 say "white"

@ 1,65, 6,69 gui box PLAIN guicolor "N/W+"   // GUI mode only

@ 1,71 DRAW TO 1,75                          // @..DRAW in GUI mode only
@ 1,71 DRAW TO 6,73
@ 1,75 DRAW TO 6,77
@ 6,73 DRAW TO 6,77
@ 1,71 DRAW TO 6,77 COLOR "R+"
@ 1,75 DRAW TO 6,73 COLOR "B+"

setColorBackground(128,128,128)              // for GUI i/o
set color to "N/N+"                          // for terminal i/o
@ 8,1 clear to 14,20
@ 8,1, 14, 20 box B_DOUBLE color "N/N+"      // GUI + terminal i/o
@ 10,5 say "dark gray"
*
@ 8,25,14,35 gui box LINE 3 guicolor "N/N+"  // GUI mode only

setColorBackground("N/G+")                   // for GUI i/o
set color to "R+/G+"                         // for terminal i/o
@ 8,41 clear to 14,60
@ 8,41, 14, 60 box                           // GUI + terminal i/o
@ 10,45 say "red/green" guicolor "r+/#00FF80"

@ 8,65,14,75 gui box plain LINEWI 1 guicolor "N/G+" // GUI mode only

setColorBackground("N/#f4edbe") 
set color to 
setpos(16,0)
wait

/* -------------- page 2 --------------
 * diferent behavior of boxes in GUI
 */
setColorBackground("N/W")                 // - reset standard GUI background
set color to "W+/B,N/W,GR+/B,GR+/B,R/W"   // - colors for Terninal i/o
cls
@ 1,1,6,35 gui BOX RAISED GUICOLOR "N/#FF6464"  // GUI only
if AppIoMode() == "G"
   @ 3,3 say '@..GUI BOX RAISED GUICOLOR "N/#FF6464"' GUICOLOR "W+/#FF6464"
endif
@ 5,3 say '(displayed in GUI only)' COLOR "R+/B" GUICOLOR "GR+/#FF6464"

@ 1,41,6,75 BOX B_DOUBLE COLOR "GR+/B" ;
            SUNKEN GUICOLOR "N/#64FF64"      // combi options Terminal + GUI
if AppIoMode() == "G"
   ?? '@..BOX SUNKEN GUICOLOR "N/#64FF64"'  GUICOLOR "N/#64FF64"
else
   ?? '@..BOX B_DOUBLE COLOR "GR+/B"' 
endif

@ 9,1,14,35 BOX B_SINGLE COLOR "W+/B" LINEWIDTH 3 ;
            SUNKEN GUICOLOR "N/#6464FF"         // combi opt Terminal + GUI  
if AppIoMode() == "G"
   @ 11,3 say '@.. BOX  LINEWIDTH 3 ;'        GUICOLOR "GR+/#6464FF"
   @ 12,6 say 'SUNKEN GUICOLOR "N/#6464FF"'   GUICOLOR "GR+/#6464FF"                
else
   @ 11,3 say '@.. BOX B_SINGLE COLOR "W+/B"' COLOR "GR+/B"
endif

@ 9,41,14,75 BOX B_PLAIN COLOR "G+/B" LINEWIDTH 4 ;
             SUNKEN FRAMEONLY GUICOLOR "N/#6464FF" // combi opt Terminal + GUI          
if AppIoMode() == "G"
   @ 11,43 say '@.. BOX  LINEWIDTH 4  SUNKEN ;'
   @ 12,46 say 'FRAMEONLY GUICOLOR "N/#6464FF"'                      
   @ 13,43 say '(note: background is not filled)'  GUICOLOR "N+"                    
else
   @ 11,43 say '@.. BOX B_PLAIN COLOR "G+/B"'      COLOR "G+/B"
endif

@ 17,1,22,35 BOX B_PLAIN COLOR "W+/B" ;
             PLAIN LINEWIDTH 1 GUICOLOR "N/#f4edbe" // combi opt Terminal + GUI         
if AppIoMode() == "G"
   @ 19,3 say '@.. BOX  PLAIN LINEWIDTH 1 ;'    GUICOLOR "N/#F4EDBE"
   @ 20,6 say 'GUICOLOR "N/#F4EDBE"'            GUICOLOR "N/#f4edbe"                
else
   @ 19,3 say '@.. BOX B_PLAIN COLOR "W+/B"' 
endif

@ 17,41,22,75 BOX B_DOUBLE_SINGLE COLOR "R+/B" ;
              PLAIN LINEWIDTH 3 FRAMEONLY        // combi opt Terminal + GUI  
if AppIoMode() == "G"
   @ 19,43 say '@.. BOX  PLAIN  LINEWIDTH 3'     
else
   @ 19,43 say '@.. BOX B_DOUBLE_SINGLE COLOR "R+/B"' 
endif

setpos(22,0)
wait

