* For FlagShip 4.4 and 5 
* Copyright (c) 1998..2003 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2005/09/27 13:05:39 $
*
* -----------------------------------------------------------------------
* FSADRESS     : very simple adress program to test FlagShip         
*                                                                    
* Databases    : fsadress.dbf, Index: adr_name, adr_plz, adr_nr      
*                fsadress.dbt                                        
* Compile      : FlagShip fsadress.prg                               
* -----------------------------------------------------------------------

#include "box.fh"
// #define MENU_VIA_PROMPT

* -------------------------
* Command-Line: /M /Unn
* -------------------------
parameters comm_1, comm_2, comm_3
command_ln = ""
for ii = 1 to 3
   dummy = "COMM_" + str(ii,1)
   if type(dummy) == 'C'
      command_ln = command_ln + &dummy. + ' '
   endif
next
command_ln = upper(command_ln)

/* set German sorting table
 */
FS_SET ("loadLanguage", 1, "FSsortab.ger")
FS_SET ("setLanguage", 1)
FS_SET ("mapping", "FSchrmap.def")

if AppIoMode() == "T"
   ? "Your terminal is " , FS_SET("terminal")
else   
   set font to "courier", 12
   set guitransl ASCII on     // PC8 -> ISO in GUI mode
   set guitransl TEXT  on     // display semi-graphic chars in GUI
   set guitransl LINES on     // display semi-graphic chars in GUI
// set guitransl BOX   on     // display semi-graphic chars for @..BOX
// set guicolor on            // enable standard colors in GUI
endif

set exclusive off

* -------------------------
* Mono, Color          
* -------------------------
color_vers = iscolor()
if "/M" $ command_ln
   color_vers = .F.
endif
if color_vers
   color1 = "W+/B,B/W"                                     // while/blue
   color2 = "GR+/B,B/W"                                    // yelow/blue
   color3 = "R+/B,B/W"                                     // red/blae
else
   color1 = "W,/W"                                         // normal
   color2 = "W+,/W"                                        // intensive
   color3 = "W+,/W"                                        // intensive
endif

* -------------------------
* User-No.             
* -------------------------
user_nr := UsersActive()
if user_nr == 1
   ? "There are currently no other users logged in" 
else
   ? "There are currently", ltrim(user_nr -1), "other users logged in" 
endif
wait timeout 5

Esc_key  = 27
PgUp_key = 18
PgDn_key = 3
F3_key   = -2
plus_key = asc("+")
minus_key= asc("-")

xtext    = ""
save_memo= .F.
act_order= 1

* -------------------------
* open databases       
* -------------------------
select 1
* do open_dbf with .F.

set deleted off
set exact on

* -------------------------
* Main menu            
* -------------------------
choice    = 0
first_out = .T.
do while .T.
   begin sequence
      sequence_ok = .F.
      set color to &color1
      clear
      if AppIoMode() == "G"
         StatBarMsg("Use Cursor-Up and Cursor-Down to select, press ENTER to choose")
      else
         saycenter (18, "use  to select, press  to choose")   
      endif
      set color to &color3

#ifndef FS_WIN32
      saycenter (4, "Address management for MS-Windows", "R+/W")
#else
      saycenter (4, "Address management for UNIX", "R+/W")
      set color to &color1
      if first_out .and. AppIoMode() == "T"
         dummy := if (getenv("TERM") $ "console|fslinux","fslinux","FSansi")
         saycenter (20, "---------------------------------------------------------------------------")
         saycenter (21, "If the menu bar is not visible: start with fsadress /M ")
         saycenter (22, "If the display is b/w only on a color monitor, or the boxes are not printed")
         saycenter (23, "with IBM-PC8 char set, invoke 'newfscons " + execname() + "' or set 'TERM="+dummy+"'")
         saycenter (24, "being on console; see 'man fsman' and the RELease notes for other modes.")
         first_out = .F.
      endif
#endif
      close data

      set color to &color1
      if AppIoMode() != "G"
         @  7,31 to 16,48
      endif
      set color to (color2)
      
#ifdef MENU_VIA_PROMPT
      @  8,34 prompt "Display    "
      @  9,34 prompt "Browse &all "
      @ 10,34 prompt "Change     "
      @ 11,34 prompt "New entry  "
      @ 12,34 prompt "Delete     "
      @ 13,34 prompt "Print      "
      @ 14,34 prompt "Index      "
      @ 15,34 prompt "End, &quit  "
      menu to choice
#else
      choice := achoice( 8, 33, 15, 45, ;
                        {"Display","Browse &all", "Change","New entry", ;
                         "Delete","Print","Index","End, &quit"} ) 
#endif
      if AppIoMode() == "G"
         StatBarMsg("")
      endif
      
      if choice # 0
         do open_dbf with .F.
      endif

      do case
      case choice = 0 .or. choice = 8                      // interrupt, exit
exit
      case choice = 1                                      // display
         do show_adr
      case choice = 2                                      // browse
         do browse_adr
      case choice = 3                                      // change
         do adr_new with .F.
      case choice = 4                                      // new entry
         do adr_new with .T.
      case choice = 5                                      // delete/restore
         do adr_del
      case choice = 6                                      // print
         do ADR_LIST
      case choice = 7                                      // index
         do open_dbf with .T.
      endcase
      sequence_ok = .T.
   end
   if !sequence_ok                                         // interrupted ?
      ?? chr(7)
      new_open = .T.                                       // open DBF
   endif
enddo

set color to
@ 24,0 clear

return

* -----------------------------------------------------------------------
* Procedure OPEN_DBF : open ADRESSEN.DBF, inedex it if neccessary    
*                                                                    
* Input: p1 (L) = .T. = must index                                   
* -----------------------------------------------------------------------
function OPEN_DBF(must_idx)
   local new_time
   if !file("adr_name" + indexext()) .or. ;
          !file("adr_nr"   + indexext()) .or. ;
          !file("adr_plz"  + indexext()) .or. must_idx
      @ 24,0 clear
      new_time = seconds()
      use
      MY_USE ("fsadress", .T.)                           // USE ... EXCLUSIVE
      saycenter (24, "Indexing fsadress.dbf ...")
      index on NAME + substr(VORNAME,1,5) to adr_name
      index on PLZ + upper(NAME)          to adr_plz
      index on ADR_NR                     to adr_nr
      ?? "done, any key"
      inkey (max(1, 5 - (seconds() - new_time)))         // Wait total 5 sec.
      @ 24,0 clear
      USE
   endif
   MY_USE  ("fsadress", .F.)                             // USE ...
   MY_IDX  ("adr_name","adr_plz","adr_nr")               // SET INDEX TO ...
return

* -----------------------------------------------------------------------
* Very simple network utilities for USE (excl), SET INDEX, RLOCK     
* with checking the actual status.                                   
* More comfortable routines see ClipLIST program from multisoft      
* -----------------------------------------------------------------------
function MY_USE (cDbfName, lExcl)
   do while .T.
      if lExcl
         use (cDbfName) EXCLUSIVE
      else
         use (cDbfName) SHARED
      endif
      if used() .and. !neterr()
         exit
      else
         ?? chr(7)
         @ 0,0 say "Waiting to access database exclusive. Wait (Y) or back to menu (M) ? "
         if upper(chr(inkey(10))) == "M"
            break
         endif
         @ 0,0
         inkey (3)
      endif
   enddo
return .T.

function MY_IDX
   parameters p1, p2, p3

   set index to &p1, &p2, &p3
   if neterr()
      @ 23,0
      ? "Error opening indexes (permission ?)"
      quit
   endif
return (.F.)

function MY_RLOCK
   do while !rlock()
      ?? chr(7)
      @ 0,0 say "Waiting to lock this record. Wait (Y) or back to menu (M) ? "
      if upper(chr(inkey(10))) == "M"
         break
      endif
      @ 0,0
      inkey (5)
   enddo
return .T.

function MY_APPEND
   append blank
   do while neterr ()
      ?? chr(7)
      @ 0,0 say "Waiting to add a new record. Wait (Y) or back to menu (M) ? "
      if upper(chr(inkey(10))) == "M"
         break
      endif
      @ 0,0
      inkey (5)
      append blank
   enddo
return .T.

* -----------------------------------------------------------------------
* Procedure MASK_OUT : output mask and textes                        
*                                                                    
* -----------------------------------------------------------------------
procedure mask_out
parameters status_line

local ii

*02 ----------------------------------------------
*03 Adr type : x                     Memo : Y 
*04                                           
*05 Name     : xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 
*06 Surname  : xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 
*07                                           
*08 Country  : xxxx                           
*09 ZIP, City: xxxx xxxxxxxxxxxxxxxxxxxxxxxxx 
*10 Telephone:(xxxx)xxxxxx - xxxxxxxxxxxxxxxx 
*11 ----------------------------------------------
*13 ----------------------------------------------
*14                                           
*15 User no. : xx                             
*16                                           
*17 Adress no: xxxx                           
*18                                           
*19 Status   : xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx 
*20                                           
*21 ----------------------------------------------

set color to &color1
clear

@  2,16 to 11,62
@  3,18 say 'Adr type :'
@  5,18 say 'Name     :'
@  6,18 say 'First,Mid:'
@  8,18 say 'Country  :'
@  9,18 say 'ZIP, City:'
@ 10,18 say 'Telephone:(    )       -'
@ 15,18 say 'User no. :'
@ 17,18 say 'Adress no:'
@ 19,18 say 'Status   :'
@  3,53 say 'Memo :'

set color to &color3
@ 13,16 to 21,62
if AppIoMode() == "T"
   @ 22,18 say replicate(chr(177),45)
   for ii = 14 to 22
      @ ii, 63 say chr(177) + chr(177)
   next
endif

set color to &color2
@ 15,29 say ltrim(str(user_nr))

set color to &color1
if status_line = 1
   saycenter (24, "[PgDn][+] next, [PgUp][-] prev.data, [M] Note, [F3] options, [Esc] Menue", .T.)
elseif status_line > 0
   saycenter (24, "[F2] or [Memo=Y] Note,  [PgDn] save,  [Esc] Exit", .T.)
endif

return

* -----------------------------------------------------------------------
* Procedure BROWSE_ADR : show all data with edit, append                        
* -----------------------------------------------------------------------
procedure browse_adr

local aFldNames := {"Name","First","State","ZIP","City","Id","Type", ;
                    "Phone country", "Phone city", "Phone", "vers", ;
                    "changed", "Notes"}

local c1 := 1, c2 := maxcol() -2
local r1 := 2, r2 := maxrow() -2
local cFontName := set(_SET_FONTNAME), nFontSize := set(_SET_FONTSIZE)

set(_SET_FONTNAME, "Helvetica")  // apply for GUI mode only
set(_SET_FONTSIZE, 10)           // apply for GUI mode only

CLS
SetColor(color1)

/* Note: The @..BOX is not displayed in GUI, unless
 * SET GUITRANSL BOX ON is set
 */
@ r1-1,c1-1,r2+1,c2+1 box B_SINGLE color ("gr+/b")

/* Create Tbrowse database object and
 * add columns = all database fields.
 * Note: These few lines is the only work required 
 *       in your application :-)
 */
oBr := TbrowseDb(r1,c1, r2,c2, NIL, NIL, "My Browse") 
  oBr:Trim       := .T.    // to trim displayed data of type 'C'
* oBr:ReadOnly   := .T.    // if editing not desired
* oBr:CanAppend  := .F.    // if append data not desired
  oBr:IncrSearch := .T.    // if search desired and index is used

for ii := 1 to min(Fcount(), aFldNames)
// oBr:AddColumn( TbColumnNew(FieldName(ii), FieldBlock(FieldName(ii)) ))
   oBr:AddColumn( TbColumnNew(aFldNames[ii], FieldBlock(FieldName(ii)) ))
   if ii%2 == 0
      oBr:GetColumn(ii):HeadColor := "gr+/b"
   endif
   if ii%5 == 0
      oBr:GetColumn(ii):HeadColor := "r+/b"
   endif
   if FieldName(ii) == "TEXT"
      oBr:GetColumn(ii):MemoPos := Rectangle{9,8,17,57}  // optional
   endif
// if FieldName(ii) == "DBF_VERS"
//    oBr:GetColumn(ii):ReadOnly := .T.                  // optional
// endif
next

* oBr:Handler := {|obj| TbrDbHandler(obj) }  // default setting in TbrowseDb()
oBr:Exec()                                   // calls UDF assigned by :Handler

set(_SET_FONTNAME, cFontName)
set(_SET_FONTSIZE, nFontSize)
return

* -----------------------------------------------------------------------
* Procedure SHOW_ADR : show actual data, page                        
*                      check in 1 sec. interval, if changes are done 
*                      by other users                                
* -----------------------------------------------------------------------
procedure show_adr

private status, key, akt_rec, dummy, clear_msg

do mask_out with 1                                         // output mask
set color to &color2

select 1
status = -1                                                // output
clear_msg = .T.

set cursor off
do while .T.
*  -------------------------
*  recognise buffering  
*  -------------------------
   commit
*  -------------------------
*  Output data          
*  -------------------------
   if eof()
      @ 19, 29 say "No data available"
      @ 3,29 clear to 10,60
   else
      if status # DBF_VERS
         if clear_msg
            @ 19,29 say space(30)
         endif
         @ 3,29 clear to 8,60
         setcolor (color1)
         @  3,53 say 'Memo :'
         setcolor (color2)
         @  3, 29 say ADR_TYP
         @  3, 60 say if(empty(TEXT), "N", "Y")
         @  5, 29 say NAME
         @  6, 29 say VORNAME
         @  8, 29 say LAND
         @  9, 29 say PLZ pict '99999'
         @  9, 35 say ORT
         @ 10, 29 say substr(TEL_LAND,1,4)
         @ 10, 35 say TEL_VORW
         @ 10, 44 say TELEFON
         @ 17, 29 say ltrim(str(ADR_NR)) + space(4)
*        -------------------------
*        Changes by others ?  
*        -------------------------
         if deleted()
            @ 19, 29 say "Deleted, last user was " + ltrim(str(DBF_USER))
         else
            if status # -1
               ?? chr(7)
               @ 19, 29 say "Changed by user " + ltrim(str(DBF_USER))
            endif
         endif
         status = DBF_VERS
      endif
   endif
   clear_msg = .T.
*  -------------------------
*  PgUp, PgDn, Esc, F3  
*  -------------------------
   key = inkey (1)                                         // wait 1 sec.

   do case
   case key = 0                                            // nothing
loop
   case key = Esc_key                                      // menue
exit
   case key = PgUp_key  .or. key = minus_key               // previous data
      @ 19, 29 say space(30)
      skip -1
      if bof()
         @ 19, 29 say "first record"
         goto top
         clear_msg = .F.
      endif
      status = -1
   case key = PgDn_key .or. key = plus_key                 // next data
      @ 19, 29 say space(30)
      skip
      if eof()
         @ 19, 29 say "last record"
         goto bottom
         clear_msg = .F.
      endif
      status = -1
   case upper(chr(key)) == "M"                             // Memo
      xtext = TEXT
      if empty(xtext)
         @ 19, 29 say "Note not available"
      else
         @ 14,17 clear to 20,61
         set cursor on
         if AppIoMode() == "G"
            memoedit (xtext, 13,17,21,61, .F.)
         else
            memoedit (xtext, 14,17,20,61, .F.)
         endif
         do mask_out with 1                                // Mask out
         set cursor off
      endif
      status = -1
   case key = F3_key                                       // Options
      set color to &color3
      @  8,31 clear to 15,46
      @  8,31 to 15,46 double
      set color to &color2
      new_wahl = 0

      @ 10,34 prompt "Change    "
      @ 11,34 prompt "New entry "
      @ 12,34 prompt if (act_order = 1, "sort: ZIP ", "sort: Name")
      @ 13,34 prompt if (deleted(),     "Recall    ", "Delete    ")
      menu to new_wahl
      set cursor on
      do case
      case new_wahl = 1
         do adr_new with .F.
      case new_wahl = 2
         do adr_new with .T.
      case new_wahl = 3
         act_order = if (act_order = 1, 2, 1)
         set order to (act_order)
      case new_wahl = 4
         do adr_del
      endcase

      set cursor off
      do mask_out with 1                                   // Mask out
      status = -1                                          // output
   endcase
   set color to &color2
enddo
set cursor on

return

* -----------------------------------------------------------------------
* Procedure ADR_NEW : new entry + change                             
*                                                                    
* Note: changes are allowed from only one user at a time             
*                                                                    
* In : .T. = new, .F. = changes                                      
* Out: -                                                             
* -----------------------------------------------------------------------
procedure adr_new
parameters p1_new

private xname, xvorname, xland, xplz, xort, xadr_nr, xdbf_vers
private xadrtyp, xtelland, xtelvorw, xtelefon
private akt_rec, isek, ok

if eof() .and. !p1_new
   ?? chr(7)
   return
endif

do mask_out with 2                                         // Mask out

set color to &color1

do while .T.
   select 1

   save_memo = .F.
   xtext     = ""
   xmemo     = "N"

   if p1_new
      set order to 3
      goto bottom
      xadr_nr  = ADR_NR + 1
      set order to (act_order)
      xadrtyp  = " "
      xname    = space(30)
      xvorname = space(30)
      xland    = space(4)
      xplz     = space(5)
      xort     = space(25)
      xtelland = space(6)
      xtelvorw = space(6)
      xtelefon = space(16)
      xdbf_vers= 0
      xtext    = ""
   else
      xadrtyp  = ADR_TYP
      xname    = NAME
      xvorname = VORNAME
      xland    = LAND
      xplz     = PLZ
      xort     = ORT
      xtelland = TEL_LAND
      xtelvorw = TEL_VORW
      xtelefon = TELEFON
      xadr_nr  = ADR_NR
      xdbf_vers= DBF_VERS
      xtext    = TEXT
   endif

   @ 17, 29 say ltrim(str(xADR_NR)) + space(10)

   @  3, 29 get xadrtyp pict '!' valid !empty(xadrtyp)
   @  5, 29 get xname   pict '!' + replicate('X',29) ;
        valid (len(trim(xname)) > 0)
   @  6, 29 get xvorname pict '!' + replicate('X',29)
   @  8, 29 get xland pict '!!!!'
   @  9, 29 get xplz  pict '99999'  valid (val(xplz) >= 1)

   @  9, 35 get xort pict '!' + replicate('X',24) valid (len(trim(xort)) > 0)
   @ 10, 29 get xtelland pict '@S4 ######'
   @ 10, 35 get xtelvorw pict '@!'
   @ 10, 44 get xtelefon pict '@!'
   @  3, 60 get xmemo    pict "!" valid xmemo $ "YN"

   if !p1_new
*     -------------------------
*     Edit possible ?      
*     -------------------------
      isek = seconds() + 2
      ok   = .T.
      unlock all
*     -------------------------
*     RLOCK possible ?     
*     -------------------------
      if !rlock()                                          // not possible,
         ok = .F.
         do while (isek - seconds()) > 0                   // try again
            akt_rec = recno()                              // through 2 sec
            goto akt_rec
            if rlock()
               ok = .T.
         exit
            endif
         enddo
      endif
      if !ok
         clear gets
         ?? chr(7)
         set color to &color2
         @ 19, 29 say "Currently changed by user " + ltrim(str(DBF_USER)) + " !"
         @ 24,0 clear
         inkey (5)
         unlock all                                        // free rlock
exit
      endif
   endif

   @ 19,29 say space(30)
   if !p1_new .and. !empty(TEXT)
      @ 19, 29 say "Note available"
   endif
*  -------------------------
*  READ                 
*  -------------------------
   set key -1 to memo_in
   read
   set key -1 to

   if lastkey() = esc_key
      unlock all                                           // free rlock
exit
   endif

   if p1_new
      set order to 3
      goto bottom
      set order to (act_order)
      if ADR_NR # (xadr_nr -1)
         ?? chr(7)
         xadr_nr  = ADR_NR + 1
         @ 17, 29 say ltrim(str(xADR_NR)) + ' changed'
         inkey(5)
      endif
      MY_APPEND ()                                         // append blank
      replace ADR_NR with xadr_nr
      unlock
   else
      if xdbf_vers # DBF_VERS
         ?? chr(7)
         @ 19, 29 say "Changed from user " + ltrim(str(DBF_USER)) + space(3)
         unlock
loop
      endif
   endif

   if xmemo == "Y"
      do memo_in with procname(), procline(), ""
   endif

   MY_RLOCK ()

   replace NAME with xname, VORNAME with xvorname
   replace LAND with xland, PLZ with xplz, ORT with xort
   replace ADR_TYP with xadrtyp
   replace TEL_LAND with xtelland, ;
           TEL_VORW with xtelvorw, ;
           TELEFON  with xtelefon
   if save_memo
      replace TEXT with trim(xtext)
   endif
   replace DBF_VERS with if (DBF_VERS < 99, DBF_VERS +1, 1)
   replace DBF_USER with user_nr
   unlock

*  -------------------------
*  flush buffers        
*  -------------------------
   commit

   @ 19,29 say space(30)
   @ 19,29 say "Stored"
   inkey(5)
   @ 19,29 clear to 20,60
   if !p1_new
exit
   endif
enddo
return

* -----------------------------------------------------------------------
* Procedure memo_in: using <F2> or directly                          
*                                                                    
* e/o: save_memo                                                     
* out: xtext                                                         
* -----------------------------------------------------------------------
procedure memo_in
local scr_buff1, scr_buff2, act_color

act_color = setcolor()
scr_buff1 = savescreen (13,16,21,62)
scr_buff2 = savescreen (24, 0,24,79)
setcolor (color1)
// @ 13,16 clear to 21,62
@ 24,0 clear
saycenter (24, "[^W] save,  [Esc] Exit w/o saving", .T.)

set cursor on
xtext = xtext + "  "
if AppIoMode() == "G"
   xtext = memoedit (xtext, 13,17,21,61, .T.)
else
   @ 13,16 to 21,62
   xtext = memoedit (xtext, 14,17,20,61, .T.)
endif
if lastkey() # 27
   save_memo = .T.
endif

// @ 13,16 clear to 21,62
saycenter  (24, "", .T.)
restscreen (13,16,21,62, scr_buff1)
restscreen (24, 0,24,79, scr_buff2)
setcolor (act_color)
return

* -----------------------------------------------------------------------
* Procedure ADR_DEL : Delete or Recall record                        
* -----------------------------------------------------------------------
procedure adr_del
   local answer

   set color to &color2

   if eof()
      @ 19, 29 say "No data available"
      inkey (10)
      return
   endif

   answer = "N"

   @ 24,0 clear
   if deleted()
      saycenter (24, "Recoll deleted record (Y/N) ?  ")
   else
      saycenter (24, "Delete record - are you sure (Y/N) ?  ")
   endif
   set color to &color1

   @ 24, col() -1 get answer pict "!" valid (answer $ "YN")
   read
   if answer == "Y"
      MY_RLOCK ()
      if deleted()
         recall
      else
         delete
      endif
      replace DBF_VERS with if (DBF_VERS < 99, DBF_VERS +1, 1)
      replace DBF_USER with user_nr
      unlock
   endif
return

* -----------------------------------------------------------------------
* Procedure ADR_LIST : Printer output                                
*                                                                    
* -----------------------------------------------------------------------
procedure ADR_LIST
local   line, max_line, ii, lines, dummy
private my_file

max_line = 60

@ 24,0 clear
saycenter (24, "Printer output in progress, please wait")

set print on
set console off

line = 0
goto top
do while !eof()
   if line > max_line .or. line = 0
      if line > 0
         eject
      endif
      ? "Adr  Name                           ZIP  City"
      ? "     Surname                             Telephone"
      ?
      line = 4
**       x    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx xxxx xxxxxxxxxxxxxxxxxxxxxxxxx
**       nn   xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx      (xxxxxx) xxxxxx xxxxxxxxxxxxxxxx
**            xxxxxxxxxxxxxxxmemoxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   endif
   ?  ADR_TYP + space(4)
   ?? NAME, PLZ, ORT
   nn = ltrim(str(ADR_NR))
   ?  nn + space(5 - len(nn)) + VORNAME + space(6)
   if !empty(TEL_LAND)
      ?? "(" + trim(TEL_LAND) + ") "
   endif
   ?? trim(TEL_VORW), trim(TELEFON)
   line = line + 2
   if !empty(TEXT)
      lines = mlcount (TEXT, 60)
      for ii = 1 to lines
         ? memoline (TEXT, 60, ii)
         line = line + 1
      next
   endif
   ?
   line = line + 1

   skip
enddo
eject

set console on
set print off

@ 23,0 clear
if Clipper
   saycenter (24,"Printout ready")
elseif FlagShip
   my_file = FS_SET ("print")
   dummy = "N"
   @ 23,0 say "Output file &my_file created. Print it (Y/N) ? "
   @ row(), col() get dummy pict "!" valid dummy $ "YN"
   read
   if dummy == "Y"
      @ 24,0 clear
      dummy = space(14)
      @ 0,0 say "Enter printer name:" get dummy
      read
      if lastkey() # 27
         RUN lp -d &dummy -m -s &my_file
      endif
   endif
endif
inkey (5)
return

* -----------------------------------------------------------------------
* Function SAYCENTER : Output text, center it in line                
*                                                                    
* p1 (N) = line no.                                             
* p2 (C) = Text                                                 
* p3 (L) = optional: if .T., display text in status bar in GUI    
*    (C) = optional: GUI color                                        
* -----------------------------------------------------------------------
function saycenter(p1, p2, p3)
   if valtype(p3) == "L" .and. p3 .and. AppIoMode() == "G"
      StatBarMsg(p2)
   else
      if valtype(p3) == "C" .and. AppIoMode() == "G"
         @ p1, max(int((80-len(p2)) /2),0) ;
               SAY substr(p2, 1, min(len(p2),80)) GUICOLOR (p3)
      else
         @ p1, max(int((80-len(p2)) /2),0) ;
               SAY substr(p2, 1, min(len(p2),80))
      endif
   endif
return NIL


*** eof ***

