// Example of simple input/output by @..GET / READ
// 
// Compile: FlagShip getread1.prg -o getread1     # compile for hybrid mode
// Execute: getread1  (or ./getread1)             # GUI mode (auto detect)
//      or: getread1 -io=t                        # Terminal mode
//      or: newfswin ./getread1                   # Unix/Linux Terminal mode 
//
// -> see also: getread2.prg, getread3.prg, keyboard.prg, umlauts.prg
// ->    fsman: FSC, CMD, REL, LNG.9

#include "fspreset.fh"        // see <FlagShip_dir>/include directory

local cName, cAddress, cCity, nZip, nNum, lMale, dDate, dBirth
local aAnyData := array(3)   
local ii, ok := .T.

cName := cAddress := space(40)
cCity := space(30)
nZip  := nNum := 0
lMale := .T.
dDate := date()               // today's date
dBirth:= ctod("")             // empty date
AFILL(aAnyData, space(40))    // set all array elements to 40 spaces

SET CENTURY ON                // display year of date with 4 digits 
// SET DATE GERMAN            // you may specify your date format
// set font "courier"         // enable for fixed fonts in GUI

@ 1,0 SAY "Enter your data or exit by ESC" COLOR "R+" GUICOLOR "R+"

while ok
   @ 3,0 SAY  "Your name " GET cName 
   @ 4,0 SAY  "Address   " GET cAddress
   @ 5,0 SAY  "Zip, City " GET nZip PICTURE "999999" 
   @ 5,col()+4             GET cCity 
   @ 6,0 SAY  "Male      " GET lMale
   @ row(), col()+2 SAY "(T, F)"
   @ 7,0 SAY  "Birth date" GET dBirth PICTURE "@D"
   for ii := 1 to len(aAnyData)
      @ ii+7, 0 SAY "Any Data " + ltrim(ii) GET aAnyData[ii]
   next

   READ                    // process data input, see ../system/getread.prg 

   if lastKey() == K_ESC   // ESC pressed?
      ok := .F.            // yes, terminate the endless loop
   endif

   @ 12,2 say "--- Variable content after READ ---" COLOR "R+" GUICOLOR "R+"
   @ 13,2 SAY "cName    = '" + cName + "'"
   @ 14,2 SAY "cAddress = '" + cAddress + "'"
   @ 15,2 SAY "nZip     = " + ltrim(nZip)
   @ 16,2 SAY "cCity    = '" + cCity  + "'"
   @ 17,2 SAY "lMale    = " + if(lMale, ".T.", ".F.")
   @ 18,2 SAY "dBirth   = " + dtoc(dBirth) 
   for ii := 1 to len(aAnyData)
      @ ii+18, 2 SAY "aAnyData[" + ltrim(ii) + "] = '" + aAnyData[ii] + "'"
   next
enddo

setpos(maxrow() -1, 0)
wait "Done, press any key to exit..."
quit
      
* eof *
