* Example of using GET and GUI objects via @...GET / READ
* in GUI or Terminal mode in different, common combinations
*
* For FlagShip 5 and 6
* Copyright (c) 2002..05 by multisoft GmbH, Munich, Germany 
* You may freely modify this source according to your needs and/or
* re-use any parts of it in your source code.
* Release $Date: 2006/06/23 13:50:39 $
*--------------------------------------------------------------------------
* Compile: FlagShip getread3.prg                     ; a.out 
*      or: FlagShip getread3.prg [-io=g|t]           ; newfswin a.out [-io=g|t]
*      or: FlagShip getread3.prg -DNOFSWIN [-io=g|t] ; ./a.out -io=t
*
* MS-Windows: FlagShip getread3.prg [-io-a|g|t|b] [-DNOFSWIN]
* Run:        getread3  -or-  getread3 -io=t
*
* -> see also: getread[1-4].prg, keyboard.prg, umlauts.prg
* ->    fsman: FSC, CMD, REL, LNG.9

#include "box.fh"

// #define NOFSWIN            /* enable (comment out) if required */
// #define USE_STATUSBAR      /* enable (comment out) if required */

local cVar1, lVar2 := .T., nVar3, objGet2, nListb1 := 3, cVar4
local lCheck1 := .T., lCheck2, lRadio1, lRadio2
local nRadgr1, nRadgr2, aobjRadgr1, aobjRadgr2, objPushb2
local lPushb1 := .F., lPushb2 := .T.
local cPushb2_style := B_SINGLE  // style of PushButton 2 = box

// fs_set("devel",.T.)

#ifdef NOFSWIN
   /* If running in terminal mode directly in X11, i.e. not via 
    * 'newfswin a.out', you may prefer to use plain ASCII chars for boxes.
    * To do so, simply redefine the constants set in initio.prg by:
    */
   _aGlobSetting[GSET_T_C_ERRBOX      ] := B_PLAIN    // RTE and errormsg frame  
   _aGlobSetting[GSET_T_C_ALERTBOX    ] := B_PLAIN    // Alert(), MessageBox{}, InfoBox{} frame
   _aGlobSetting[GSET_T_C_COLDBOX     ] := B_PLAIN    // Listbox, RadioGroup w/o focus 
   _aGlobSetting[GSET_T_C_HOTBOX      ] := B_PLAIN    // Listbox, RadioGroup w/  focus 
   _aGlobSetting[GSET_T_C_COMBOMARK   ] := "v"        // Combo dropdown mark  
   _aGlobSetting[GSET_T_C_MENUBORDER  ] := B_PLAIN    // PopUp Menu border 
*  _aGlobSetting[GSET_T_C_AT_TO_SINGLE] := B_PLAIN    // @..TO.. SINGLE 
*  _aGlobSetting[GSET_T_C_AT_TO_DOUBLE] := B_PLAIN    // @..TO.. DOUBLE 
*  _aGlobSetting[GSET_T_C_PUSHB_STYLE ] := "<>"       // PushButton default style
*  _aGlobSetting[GSET_T_C_CHBOX_STYLE ] := "[ X]?"    // CheckBox default style
*  _aGlobSetting[GSET_T_C_RADBUT_STYLE] := "( *)"     // RadioButton default style

   cPushb2_style := B_PLAIN   // style of PushButton 2 = box in ASCII chars
#else
   /* otherwise you may probably prefer to set also error-boxes
    * to semi-graphical caracters simply via:
    */
# include "fspreset.fh"
#endif

set color to "W/B,N/W,GR+/B,R+/B,GB+/B"   // terminal only if not GUICOLOR ON
cls

set message to 23 center                  // apply for terminal only
#ifdef USE_STATUSBAR
if !m->_oStatusBar:Enabled                // default: enabled in GUI, 
   m->_oStatusBar:Show()                  //    disabled in Terminal i/o
endif                                     // instantiated in initio.prg
#endif

for ii := 0 to 79
   @ 0,ii SAY if(ii%10==0, ":", if(ii%5==0, ",", ".")) color "b+/b"
next

  
objGet2 := GetNew()

objPushb2 := PushButton{5,60,"Button &2"}
objPushb2:Sblock := {|press,obj| if(press, alert(obj:Caption + " pressed"), NIL)}

aobjRadgr1 := {}
aobjRadgr2 := {}
for ii := 1 to 4
// - either absolute RadioButton coordinates for RadioGroup's
*  aadd(aobjRadgr1, RadioButton(8+ii, 35, "Item " + ltrim(ii)) )
*  aadd(aobjRadgr2, RadioButton(8+ii, 56, "group2 Item &" + ltrim(ii)) )

// - or relative coordinates (negative) to RadioGroup :Top,:Left
   aadd(aobjRadgr1, RadioButton(-ii, -1, "Item " + ltrim(ii)) )
   aadd(aobjRadgr2, RadioButton(-ii, -1, "group2 Item &" + ltrim(ii)) )
next

* SET GUIALIGN OFF   // ON is the default

@ 1,2  SAY "Character" ;
       GET cVar1 DEFAULT space(20) MESSAGE "first GET item"
@ 2,2  SAY "Logical  " ;
       GET lVar2 using objGet2
@ 3,2  SAY "Num > 5  " ;
       GET nVar3 DEFAULT 5 VALID nVar3 > 5 ;
               ERRORVALID {|obj| StatusMessage("Value greater than 5 required","R+/B","R+/GR+")} ;
               MESSAGE "numeric value greater than 5" ;
               TOOLTIP "Value > 5 required"

@ 1,40 SAY "CheckBox" ;
       GET lCheck1 CHECKBOX ;
               MESSAGE "single Check Box, press space or X to flip or Y,T/N,F to set/unset"

@ 1,60 GET lCheck2 CHECKBOX CAPTION "CheckBox2" DEFAULT .F.

@ 3,40 SAY "RadioButon" ;
       GET lRadio1 RADIOBUTTON  DEFAULT .T. ;
               MESSAGE "The second Radio button is modifiable only if this button is ON" ;
               VALID if(nVar3 > 10, lRadio1, .T.) ;
               ERRORVALID "This switch must be set ON when Num field is > 10"

@ 3,60 GET lRadio2 RADIOBUTTON CAPTION "RadioButton2" DEFAULT .F. ;
               MESSAGE "Available only when Radio Button 1 is ON" ;
               TOOLTIP "Availabilty depends on" + chr(10) + "state of RadioButton 1" ;
               WHEN lRadio1 

@ 5,40 GET lPushb1 PUSHBUTTON CAPTION "PushButton 1" ;
               DEFAULT .F. TOOLTIP "Pushbutton 1" ;
               STATE {|press,obj| setpos(obj:row +1, obj:col), ;
                        devout(obj:Caption + ": " + ;
                              if(press,"pressed","released")+space(10) ) } ;
               FOCUS {|focus,obj| _Message(obj:Caption + ": " + ;
                                  if(focus,"receiving","loosing")+" focus") }

@ 5,60 GET lPushb2 PUSHBUTTON USING objPushb2 STYLE cPushb2_style

@ 7,2, 11,15  GET nListb1 LISTBOX {"first","second","third","fourth"} 

@ 8,25,13,45  GET nRadgr1 RADIOGROUP aobjRadgr1 ;
                  DEFAULT 2 MESSAGE "First radio group"
* @ 8,55,13,72 GET nRadgr2 RADIOGROUP {"Item &1","Item &2","Item &3","Item &4"} ;
*                          DEFAULT 3 CAPTION "Radio Group 2"
@ 8,55,13,73 GET nRadgr2 RADIOGROUP aobjRadgr2 ;
                  DEFAULT 3 CAPTION "Radio Group 2"

@ 13,2  SAY "Last" ;
        GET cVar4 DEFAULT " " MESSAGE "Last GET item"

/* add ToolTip (considered in GUI only) for all items
 */
for ii := 1 to len(GetList)
   obj := GetList[ii]
   if empty(obj:ToolTip)
      obj:ToolTip := "READ/GetList item# " + ltrim(ii)
   endif
next 
           
// enable one of:
READ                 // default READ: skip over, no check at exit
* READ NOSKIP        // don't skip over unsatisfied VALID fields via mouse
* READ EXITCHECK     // check all VALID clauses before exiting READ
* READ NOSKIP EXITCHECK // combinatuon of above

/* display results
 */
SET GUITRANSL LINES ON
SET GUICOLOR ON
@ 15,0 TO 15,maxcol() color "R+/B"
@ 15,10 SAY " Results: " COLOR if(AppIoMode() == "T", "R+/B", "R+/W")
SET GUICOLOR OFF
? "cVar1='"+cVar1+"', lVar2=",lVar2, ", nVar3=",ltrim(nVar3)
? "Checkbox_1=",lCheck1, "Checkbox_2=", lCheck2, "Radiobutt_1=",lRadio1,"Radiobutt_2=",lRadio2
? "Pushbutt  =",lPushb1, "Listbox=",ltrim(nListb1)
? "Radiogroup_1=",ltrim(nRadgr1),"Radiogroup_2=",ltrim(nRadgr2)
? "Last='" + cVar4 + "'"

wait

* eof *

