* Example of using GET and GUI objects (mainly LISTBOX) via @...GET / READ
* in GUI or Terminal mode in different, common combinations
*
* For FlagShip 6
* Copyright (c) 2002..06 by multisoft GmbH, Munich, Germany
* You may freely modify this source according to your needs and/or
* re-use any parts of it in your source code.
* Release $Date: 2006/07/28 08:15:09 $
*--------------------------------------------------------------------------
* Linux   : FlagShip getread4.prg [-io-a|g|t|b] -o getread4
* Run GUI : ./getread4
* Run Term: newfswin ./getread4 [-io=g|t]
*
* MS-Windows: FlagShip getread4.prg [-io-a|g|t|b]
* Run GUI   : getread4
* Run Term  : getread4 -io=t
*
* -> see also: getread[1-4].prg, keyboard.prg, umlauts.prg
* ->    fsman: FSC, CMD, REL, LNG.9

test1()
test2()
quit

Procedure test1
   local ii, aItem, oBox, nListb1, nListb2, cTxt := "any text    "
#ifdef FS_WIN32
   local cGuiColor := "N/#ECE9D8,N/#C4C2B0,N/W+,W+/#316AC3"
// local cGuiColor := "N/#ECE9D8,N/#D2D0C6,N/W+,W+/#316AC3"
#else
   local cGuiColor := "N/#DEDEDE,W+/#A0A0A0,N/W+,W+/#085D8B"
#endif

   set font "courier", 10

   aItem  := {}
   nListb1 := 4
   nListb2 := 2
   for ii := 1 to 20
      aadd(aItem, "Listbox (array) line#" + ltrim(ii))
   next
   @ 2,5  get nListb1
   @ 2,45 get nListb2
   @ 4, 5, 11,35 GET nListb1 LISTBOX aItem  ;
                 GUICOLOR (cGuiColor) ;
                 valid(myReport(1,11.5,5))
   getlist[len(getlist)]:Fblock := {|obj,on| showFocus(obj,on)}
   
   @ 4, 45,11,60 GET nListb2 LISTBOX {"one","two","three", ;
                                      "four","five","six"} ;
                 GUICOLOR (cGuiColor) ;
                 valid(myReport(1,11.5,45))
   oBox := getlist[len(getlist)]
   oBox:Fblock := {|obj,on| showFocus(obj,on)}
   oBox:SelectBySpace := .F.        // disable space selection
   oBox:SelectBySingleClick := .T.  // MMB and RMB same as LMB
   
   @ 13,5 get cTxt
   read
   wait
return

Procedure test2
   local ii, oLBox, nListb, cTxt := "any text    "
   local cGuiColor := ",N/#C0C0C0,,"    // or  ",W+/#A0A0A0"

   cls
   oLBox  := Listbox{}     // instantiate object
   for ii := 1 to 20
      oLBox:AddItem("Listbox (object) line#" + ltrim(ii))
   next
   @ 2,5 get cTxt
   @ 4,5, 11,35 GET nListb LISTBOX USING oLBox ;
                           GUICOLOR (cGuiColor) ;
                           WHEN myReport(0,10,40) VALID myReport(1,10,40)
   //                      STATE {|obj,selected| myReport(2,10,40) }
   @ 12,5 get cTxt
   read
   wait
return

Function myReport(mode,row,col)
   local rr := row(), cc := col(), obj := getactive()
   if mode == 0               // clear
      @ row,col say space(30)
   else                       // display curr. selection
      @ row,col say "Return: " + ltrim(obj:Buffer) + space(5)
   endif
   setpos(rr, cc)
return .T.

function showFocus(obj, OnOff)
   if OnOff
      @ obj:top -1, obj:left say "SELECTED     "
   else
      @ obj:top -1, obj:left say "unselected     "
   endif
return
      