/* For FlagShip 5 and 6 
 * Copyright (c) 2003 by multisoft GmbH, Munich, Germany 
 *
 * You may freely modify this source according to your needs and/or
 * re-use any parts of it in your source code.
 * Release $Date: 2004/02/16 14:02:37 $
 *--------------------------------------------------------------------------
 * This program demonstrates SET GUICURSOR... commands and
 * Set(_SET_GUICURSOR*), SetGuiCursor(), MsetCursor() functions.
 *
 * Compile/run: FlagShip guicursor.prg [-io=a|g] ; ./a.out
 *
 * MS-Windows: FlagShip guicursor.prg [-io=a|g]
 *             guicursor.exe
 */

#include "mouse.fh"

aCurs := {{CURSOR_ARROW       , "arrow"}, ;          // -1     
          {CURSOR_SIZE_VER    , "vertical"},;        // -2     
          {CURSOR_SIZE_HOR    , "horizontal"},;      // -3     
          {CURSOR_SIZE_LDIAG  , "left diagonal"},;   // -4     
          {CURSOR_SIZE_RDIAG  , "right diagonal"},;  // -5     
          {CURSOR_SIZE_ALL    , "sizeall"},;         // -13    
          {CURSOR_UPARROW     , "up-arrow"},;        // -12    
          {CURSOR_CROSS       , "cross"},;           // -8     
          {CURSOR_WAIT        , "wait"},;            // -9     
          {CURSOR_IBEAM       , "i-beam"},;          // -11    
          {CURSOR_SPLITVER    , "split vertical"},;  // -14    
          {CURSOR_SPLITHOR    , "split horiz"},;     // -15    
          {CURSOR_HAND        , "hand"},;            // -6     
          {CURSOR_FORBIDDEN   , "forbidden"},;       // -16    
          {CURSOR_INVISIBLE   , "invisible"},;       // -17    
          {CURSOR_BOX         , "box"},;             // -22
          {CURSOR_UNDERSCORE  , "underscore"},;      // -21
          {CURSOR_DEFAULT     , "(default mouse)"}, ; 
          {CURSOR_DEFAULT_TEXT, "(default text)"} }   


set font to "courier", 12

if AppIoMode() != "G"
   @ 0,0 say "--- Full GUIGURSOR functionality is available in GUI mode ---" ;
         color "r"
endif
@ 1,0 say "AbcdefgHijk" guicolor "r+"
@ 2,0 say "AbcdefgHijk" guicolor "r+"
@ 3,0 say "AbcdefgHijk" guicolor "r+"

SET GUICURSOR ON
@ 15,0 say "output (delayed) with SET GUICURSOR ON"
str := "Abcdefghijklmnopqrstuvwxyz"
for ii := 1 to len(str)
   @ 4,ii-1 say substr(str,ii,1) guicolor "r+" 
   inkey(0.5)
next
SET GUICURSOR OFF

// @ 15,0 say "output (delayed) with alternated SET GUICURSOR"
// Set(_SET_GUICURSOR, .T.)
// iCursPos := 1
// str := "Abcdefghijklmnopqrstuvwxyz"
// for ii := 1 to len(str)
//    if iCursPos > len(aCurs)
//       iCursPos := 1
//    endif
//    SET GUICURSOR TO (aCurs[iCursPos,1])
//    @ 4,ii-1 say substr(str,ii,1) guicolor "r+" 
//    inkey(0.5)
//    iCursPos ++
// next
// Set(_SET_GUICURSOR, .F.)

SetGuiCursor(2,3)   
mywait("blinking underline at 'd' in second line")

SetGuiCursor(3,0, CURSOR_BOX)    
mywait ("blinking box at 'A' in third line")

SetGuiCursor(3,7, , .F.)    
mywait ("non-blinking box at 'H' in third line")

SetGuiCursor(1,7, CURSOR_CROSS)    
mywait ("non-blinking cross at 'H' in first line")


@ 100,260 draw to 100,300 pixel color "b+"
@  80,280 draw to 120,280 pixel color "b+"

SetGuiCursor(100,280, CURSOR_WAIT, .T., .T.)    
mywait ("blinking wait-cursor at cross")

SetGuiCursor(100,280, CURSOR_ARROW, .T., .T.)    
mywait ("blinking arrow-cursor at cross")

SetGuiCursor(100,280, CURSOR_HAND, .F., .T.)    
mywait ("non-blinking hand-cursor at cross")

oldCurs := Set(_SET_GUICURSOR, .T.)       // SET GUICURSOR ON
for ii := 1 to len(aCurs)
   set(_SET_GUICURSORTYPE, aCurs[ii,1])   // text cursor
   MsetCursor(aCurs[ii,1])                // mouse cursor
   mywait (aCurs[ii,2] + " text and mouse cursor ")
next
MsetCursor(CURSOR_DEFAULT)                // set default mouse
Set(_SET_GUICURSOR, oldCurs)              // restore SET GUICURSOR

wait "done..."

FUNCTION myWait(txt)
   @ 15,0 
   @ 15,0 say txt
   inkey(5)
return NIL

