* tbrowse_ar.prg: Tbrowse with arrays incl. edit and append. 
* See also tbrowse_db.prg for Tbrowse example with database.

* This example demonstrates the features of FS5 and FS6 (VFS) including a
* simple programming (with default input handler) and example of use the 
* Tbrowse class. Some parts here will therefore not run with FlagShip 4 and 
* Clipper - although FS4 and Clipper('87..5.3) applications remains backward 
* compatible to FS5 and FS6.
* Release $Date: 2007/01/03 10:11:16 $
*
* MS-Windows : FlagShip [-io=t|g] tbrowse_ar.prg ; tbrowse_ar.exe
* Compile/run: FlagShip [-io=t|g] tbrowse_ar.prg ; ./a.out

#ifndef FlagShip5
   wait "Sorry, this example uses the extended VFS functionality"
   quit
#endif

#include "tbrclass.fh"
#include "box.fh"

/* enable additional features or options by commenting out:
 */
// #define WITH_FIXFONT
#define INCREASE_CACHE

local ii, oTbcol

/* create the used array displayed by Tbrowse
 */
local myArray := {}
local aHeader := {"ID", "Name", "Address", "Zip", "City", "Male" }

for ii := 1 to 100
   aadd(myArray, {ii, ;
                  padr("name",30), ;
                  padr("address",50), ;
                  ii + 1000, ;
                  padr("city",40) , ;
                  if(ii % 2 == 0, .T., .F.) } )
next       

if AppIoMode() == "G"   // meaningful for GUI mode only
#  ifdef WITH_FIXFONT
   m->oApplic:Font:FontName("courier")
   m->oApplic:Font:SizePoint(12)
#  endif
endif

/* Note: Colors are ignored in GUI, unless
 * SET GUICOLOR ON is set
 */
set color to "W/B,gr+/r,gr+/b,gr+/b,w+/b"

clear screen

/* Note: The @..BOX is not displayed in GUI, unless
 * SET GUITRANSL BOX ON is set
 */
@ 5,4,21,61 box B_PLAIN color ("gr+/b")

/* Create Tbrowse object via TbrowseArr() and add all array columns.
 * Note: Only the following few lines is the all work required 
 *       in your application to use Tbrowse with arrays, including
 *       edditing and append :-)
 */
oBr := TbrowseArr(6,5, 20,60, NIL, NIL, "My Browse") 
oBr:UserArray := myArray        
* oBr:ReadOnly := .T.      // enable if editing is not desired
oBr:CanAppend := .F.       // enable if append  is not desired
* oBr:Trim       := .T.    // to trim displayed data of type 'C'

for ii := 1 to len(myArray[1])
   oTbcol := TbColumnNew(aHeader[ii], .T.)   // use default array block
   * Note: the default Tbcolumn:block for TbrowseArr is similar to 
   *  oTbcol:Block := {|data| if(data == NIL, ;
   *                    oBr:UserArray[oBr:UserArrayPos,oTbcol:ColPos], ;
   *                    oBr:UserArray[oBr:UserArrayPos,oTbcol:ColPos] := data) }
   if ii == 1
      oTbcol:Picture := "9999"
      oTbcol:ReadOnly := .T.                 // 1st column not editable
   elseif ii == 4
      oTbcol:Picture := "999999"
   endif   
   oBr:AddColumn(oTbcol)
next

#ifdef INCREASE_CACHE   /* if enabled at the top: */
   /* increase the table slice (default = visible rows), i.e.
    * allow movement/browsing by vertical scrollbar (in GUI only)
    * through the whole array 
    */
   oBr:RowCache := len(myArray)
#endif

/* Note: instead of invoking this convenient :Exec() method used here, 
 * you also may use the usual keyboard handler, same as in FS4 and Clipper.
 * The here used TbrHandler() is available in source code and is
 * replaceable by your own UDF using the :Handler instance, e.g.:
 * oBr:Handler := {|obj| TbrHandler(obj) } // this is the default for array
 */
oBr:Exec()                                 // calls UDF assigned by :Handler

/* reset cursor position
 */
setpos(21,60)
wait

** eof

