#ifdef COMMENT_ONLY
/* For FlagShip 6. Copyright (c) 1994..2007 by multisoft GmbH, Munich, Germany
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the
 * modified source code when your application is distributed in source,
 * but may not remove the copyright notice.
 *
 * Release $Date: 2007/03/05 16:11:13 $
 */
#endif

/****************************************************************************
 * FlagShip Header File                                                     *
 *                                                                          *
 * Release 6.0 (backward compatible to 5.x and 4.48)                        *
 *                                                                          *
 * WARNING: do NOT change anything here unless you REALLY know what you     *
 *          are doing. Otherwise unpredictable errors will occur.           *
 ****************************************************************************/

#ifndef FH_FROM_C
#define FH_FROM_C
#endif

#ifndef  __FGS_FLAGSHIP__     /* process rest of .h only once */
# define __FGS_FLAGSHIP__

#ifndef FGS_LARGEFILE
# if defined(FGSLINUX)        \
   || defined(FGSLINUXELF)    \
   || defined(FGS_LINUX_GLIBC232) \
   || defined(FS_GCC33)       \
   || defined(FS_GCC34)       \
   || defined(FS_GCC40)       \
   || defined(FGS_AIX64)      \
   || defined(FS_WIN32) 
#  define FGS_LARGEFILE
# endif
#endif

#ifdef FGS_LARGEFILE
# ifdef _FILE_OFFSET_BITS
#   undef  _FILE_OFFSET_BITS
#   define _FILE_OFFSET_BITS 64
# endif
# ifndef   _LARGEFILE64_SOURCE
#   define _LARGEFILE64_SOURCE
# endif
# ifndef   _LARGE_FILES
#   define _LARGE_FILES
# endif
# ifndef   __USE_LARGEFILE64 
#   define __USE_LARGEFILE64 
# endif
#endif

#ifdef __cplusplus
  extern "C" {
# define FGS_STDARGS_PROTO
#endif

#if defined(FS_WIN32)
# include <windows.h>
#endif

#include <stdio.h>

#if   defined (FGS_INTERACTIVE) \
   || defined(FGSAVIION)        \
   || defined(FGSM6832)         \
   || defined(FGSMV8832)        \
   || defined(FGSNSCSinix)      \
   || defined(FGSSUNOS)         \
   || defined(FGSEURIX)         \
   || ( defined(FGSHPUX) && !defined(FGSHPUX11) )
# define FGS_ANSI(x) ()
#else
# define FGS_ANSI(x) x
# define FGS_ISANSI
#endif

#if   defined (FGS_INTERACTIVE) \
   || defined(FGSAVIION)        \
   || defined(FGSM6832)         \
   || defined(FGSMV8832)        \
   || defined(FGSNSCSinix)      \
   || defined(FGSSUNOS)         \
   || defined(FGSEURIX)         \
   || ( defined(FGSHPUX) && !defined(FGSHPUX11) )
# define _FGS_CCNAME_CONV2
#endif

#if defined (FGSSINIXRM545)
#   define _FGS_EXTERN_EXTERN
#endif

/* most C compilers & libs can use the more
 * portable varargs.h instead of stdarg.h
 */
#if   defined(FGSLINUXELF)    \
   || defined(FGSLINUXMIPS)   \
   || defined(FS_GCC33)       \
   || defined(FS_GCC34)       \
   || defined(FS_GCC40)       \
   || defined(FGS_LINUX_GLIBC232)  \
   || defined(FS_WIN32)       \
   || defined(FS_BCC32)       \
   || defined(_WIN32_)        \
   || defined(__OPENNT)       \
   || defined(__CYGWIN32__)
# define FGS_USE_STDARG
#endif

#if defined(FGS_AIX64) || defined(FS_AIX64) || defined(FGS_LARGEFILE)
#  define FGS_USE_STDARG
#  define MUST_PROTOTYPE
#endif
#if defined(FGSLINUXMIPS) || defined(FGSLINUXELF)
# ifndef FGS_STDARGS_PROTO
#  define FGS_STDARGS_PROTO
# endif
#endif

/* Curses is required only with FS compiler
 * switch -io=t or -io=a
 */
#if defined(FSIO_TERM) || defined(FSIO_ALL)
#  if defined(FGS_NCURSES)
#    include "ncurses.h"
#  else 
#    if defined(FGSAIX)
#      if defined(FS_AIX64)
#        include <curses.h>
#      else
#        include <cur00.h>
#        include <cur01.h>
#        include <cur02.h>
#      endif
#    else
#      if defined(FGSncurs52)
#        include <ncurs52/curses.h>
#      else
#        if defined(FGSLINUX)
#           if defined(FGS_NO_WRITSTR) || defined(FGS_NCURSES55)
#              ifndef FGS_NCURSES55
#                 define FGS_NCURSES55
#              endif
#              include <ncurses55/ncurses_vfs.h>
#              ifdef DISPLAY_NCURSES_VERSION
#                 warning "... using ncurses55/ncurses_vfs.h = ncurses 5.5"
#              endif 
#           else
#              if defined(FGSLINUXELF)
#                 include <ncur194/curses.h>
#                 ifdef DISPLAY_NCURSES_VERSION
#                    warning "... using ncur194/curses.h = ncurses 1.9.4"
#                 endif 
#              else
#                 include <ncur181/curses.h>
#                 ifdef DISPLAY_NCURSES_VERSION
#                    warning "... using ncur181/curses.h = ncurses 1.8.1"
#                 endif 
#              endif
#           endif
#        else
#          if defined(FGSHPUX11)
#             include <sys/termio.h>
#             include <curses_colr/curses.h>
#          else
#             if defined(FS_WIN32) || defined(FS_BCC32)
#                 include <curses_win.h>
#             else
#                 include <curses.h>
#             endif
#          endif
#        endif
#      endif
#    endif
#  endif
#endif

/* Some systems does not declare all Curses functions
 * in the header files
 */
#if !defined(FGS_PROTOCURSES) && !defined(FGS_NCURSES)
# if defined(FGSHPUX) && !defined(FGSHPUX11)
#   define FGS_PROTOCURSES
# endif
# if defined(FGSAIX) && !defined(FGS_NCURSES)
#   if !defined(FGSncurses) && !defined(FS_AIX64)
#     define FGS_PROTOCURSES
#   endif
# endif
# if defined(FGSTru64)
#   if !defined(FGSncurses)
#      define FGS_PROTOCURSES
#   endif
# endif
#endif

#include <setjmp.h>
#include <ctype.h>
#include <math.h>

#if defined(FGSAIX) && !defined(FGS_NCURSES)
# ifndef FS_AIX64
#   define AIX_EXTRA_CURSES
# endif
#endif
#ifdef bell    /* FS_AIX64 */
# undef bell
#endif
#ifdef tone    /* FS_AIX64 */
# undef tone
#endif

/* On problems with incorrect color representation, you
 * may re-define the color attributes here and re-link.
 * Considered in Terminal/Curses mode only.
 */
#define IBM_COLORS

#if !defined(COLOR_BLACK)
#   if defined(FS_WIN32) || defined(FS_BCC32)
/* from curses_win.h */
#     ifndef FOREGROUND_BLUE
#       define FOREGROUND_BLUE  0x0001
#     endif
#     ifndef FOREGROUND_GREEN
#       define FOREGROUND_GREEN 0x0002
#     endif
#     ifndef FOREGROUND_RED
#       define FOREGROUND_RED   0x0004
#     endif
#     ifndef FOREGROUND_INTENSITY
#       define FOREGROUND_INTENSITY   0x0008      /* BOLD */
#     endif
#     ifndef BACKGROUND_BLUE
#       define BACKGROUND_BLUE  0x0010
#     endif
#     ifndef BACKGROUND_GREEN
#       define BACKGROUND_GREEN 0x0020
#     endif
#     ifndef BACKGROUND_RED
#       define BACKGROUND_RED   0x0040
#     endif
#     ifndef BACKGROUND_INTENSITY
#       define BACKGROUND_INTENSITY   0x0080      /* BLINK */
#     endif
#     define COLOR_BLACK		0
#     define COLOR_BLUE		   FOREGROUND_BLUE
#     define COLOR_RED		   FOREGROUND_RED
#     define COLOR_GREEN		FOREGROUND_GREEN
#     define COLOR_CYAN		   FOREGROUND_BLUE | FOREGROUND_GREEN
#     define COLOR_MAGENTA		FOREGROUND_RED | FOREGROUND_BLUE
#     define COLOR_YELLOW		FOREGROUND_RED | FOREGROUND_GREEN
#     define COLOR_WHITE		FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE
#   else
#     define FGS_CURSES_DEFS
#     define COLOR_BLACK        0
#     define COLOR_RED          1
#     define COLOR_GREEN        2
#     define COLOR_YELLOW       3
#     define COLOR_BLUE         4
#     define COLOR_MAGENTA      5
#     define COLOR_CYAN         6
#     define COLOR_WHITE        7
#   endif
#endif
#ifdef IBM_COLORS
#   define FS_COLOR_BLACK     COLOR_BLACK
#   define FS_COLOR_RED       COLOR_RED
#   define FS_COLOR_GREEN     COLOR_GREEN
#   define FS_COLOR_YELLOW    COLOR_YELLOW
#   define FS_COLOR_BLUE      COLOR_BLUE
#   define FS_COLOR_MAGENTA   COLOR_MAGENTA
#   define FS_COLOR_CYAN      COLOR_CYAN
#   define FS_COLOR_WHITE     COLOR_WHITE
#else
#   define FS_COLOR_BLACK     0
#   define FS_COLOR_RED       4
#   define FS_COLOR_GREEN     2
#   define FS_COLOR_YELLOW    6
#   define FS_COLOR_BLUE      1
#   define FS_COLOR_MAGENTA   5
#   define FS_COLOR_CYAN      3
#   define FS_COLOR_WHITE     7
#endif
#if defined(FGS_NCURSES55) && defined(FGS_CURSES_DEFS)
# undef FGS_CURSES_DEFS
#endif

/* some commonly used defines
 */
#if !defined(BELL) && !defined(TAB) && !defined(LF)
#  define BELL    7
#  define BS      8
#  define TAB     9
#  define LF      10
#  define NL      10
#  define FF      12
#  define CR      13
#  define ESC     27
#endif

#ifndef TRUE
#   define TRUE    1
#endif
#ifndef FALSE
#   define FALSE   0
#endif
#ifndef ON
#   define ON      1
#endif
#ifndef OFF
#   define OFF     0
#endif

#define EXPLEN 4096         /* expressio length as defined in exp_eval */


/* Types to be used in normal programming 
 */
#ifndef _FS_TYPEDEFS_
#define _FS_TYPEDEFS_
#endif

#if defined(FGSDECAlpha) && !defined(FGSTru64)
# define long int
#endif  
/* defined(FGSDECAlpha) && !defined(FGSTru64) */

typedef short           FSshort  ;
typedef unsigned short  FSushort ;
typedef int             FSint    ;
typedef unsigned int    FSuint   ;
typedef long            FSlong   ;
typedef unsigned long   FSulong  ;
typedef char            FSchar   ;    /* signed character type (unused ?)   */
typedef unsigned char   FSuchar  ;    /* normal character type              */
typedef float           FSfloat  ;    /* short double value   (unused ?)    */
typedef double          FSdouble ;    /* normal double value                */
typedef void            FSvoid   ;    /* void type                          */
typedef void *          FSvoidptr;    /* void ptr, pointer to nothing       */

#ifndef FSvar
#define FSvar variable
#endif

#ifndef byte
#   define byte FSuchar
#endif
#ifndef word
#   define word FSushort
#endif
#ifndef dword
#   define dword FSuint
#endif

/* large files */
#ifdef FS_WIN32
typedef __int64         FSlonglong;
#else
typedef long long       FSlonglong;
#endif
#ifdef FGS_LARGEFILE
 typedef FSlonglong     FSoffset ;
#else
 typedef long           FSoffset  ;
#endif

/*  Special Key Codes as for Clipper                                        
 */
#define RightArrow      4
#define LeftArrow       19
#define UpArrow         5
#define DownArrow       24
#define CtrlRightArrow  2
#define CtrlLeftArrow   26
#define Ins             22
#define Del             7
#define Home            1
#define End             6
#define PgUp            18
#define PgDn            3
#define CtrlHome        29
#define CtrlEnd         23
#define CtrlPgUp        31
#define CtrlPgDn        30
#define Help            28
#define Backspace       8
#define Return          13


/*  -------------- structure for handling working areas ------------------- */
typedef struct fgsWorkArea
{
    FSuchar              cFlags;
    FSuchar              iLinks;
    FSushort             iNumber;
    FSchar             * cAlias;
    struct mv_data     * oObject;
    struct mv_data     * (* fpQuickGetMethod)();
    struct mv_data     * (* fpQuickSetMethod)();
    struct fgsWorkArea * oNext;
} fgsWorkArea;

extern FSchar ** fgsKnownAlias;

/* used for database structures, must be of fix sizes 
 */
typedef char            FSDBFchar   ;  /* 1 byte */
typedef unsigned char   FSDBFuchar;    /* 1 byte */
typedef int             FSDBFint    ;  /* 4 bytes */
#if defined(FS_AIX64)
typedef int             FSDBFlong   ;  /* 4 bytes */
typedef unsigned int    FSDBFulong;    /* 4 bytes */
#else
typedef long            FSDBFlong   ;  /* 4 bytes */
typedef unsigned long   FSDBFulong;    /* 4 bytes */
#endif
typedef unsigned short  FSDBFushort ;  /* 2 bytes */
typedef double          FSDBFdouble ;  /* 8 bytes */

/*  ------------------ structure defining memory variable ----------------- */
typedef struct mv_data    FSvar;
typedef struct array_stru FSarr;

struct array_stru
{
    FSushort    links;
    FSushort    component_count;
    FSvar    ** components;
//    FSvar    ** linked_vars;
};

struct mv_data
{
    FSchar type;                    /* var type C,N,I,i,D,E,L,A,S,b,B,O,U,*,# */
    FSchar mode;                    /*  C - constant both user & privelidged
                                     *  F/f - field, spec. handling
                                     *        lowercase - late contents
                                     *        uppercase - cont. always suppl.
                                     *  G/g - translated field
                                     *  L/l - normal soft local (in cb's)
                                     *  N/n - normal
                                     *  M/m - unassignable
                                     *  P/p - permanent (const) in user mode
                                     *  S/s - fixed type
                                     *  T/t - temporary
                                     *  U - never defined.
                                     *  V/v - normal passed by value
                                     * In case of lowercase, the variable
                                     * contains a string constant not to be
                                     * released via free                      */
    FSuchar  dec;                   /* number of decimal places or CB param   */
    FSuchar  ctIsNil;               /* signals if typed var is assignd w/NIL,
                                     * alternatively carries subtype          */
    FSulong  len;                   /* total nuber of bytes occupied by var   */
    FSushort links;                 /* no of logical links from names (def=1) */
    FSushort fldidx;                /* field ordinal/index                    */
                                    /* or index in var table for autoprivate  */
    union
    {
        fgsWorkArea  * w_area;      /* working area in case of field var.     */
        FSint          decl_depth;  /* depth of declaration when var          */
    } fov;

    union {
        FSuchar   schr[sizeof(FSdouble)]; /* short char stored inplace type=E */
        FSdouble  fnum;             /* float number value,           type=N,F */
        FSint     inum;             /* integer number value,           type=I */
        FSuint    uinum;            /* unsigned int number value,      type=i */
        FSlong    date;             /* date (converted to long int)    type=D */
        FSuchar * chr;              /* pointer to character string buffer  =C */
        FSvoid  * scr;              /* screen variable holder pointer      =S */
        struct {
            FSarr * buff;           /* array vars (references in cb) type=A,O */
            FSvar * (* block)();    /* codeblock (function pointer)  type=B,b */
        } cb;
        struct
        {
            FSlong  val1;           /* object instance index                  */
            FSshort val2;           /* object access handler                  */
            FSshort val3;           /* object assign handler                  */
        } gp;
        void *intern_data;          /* internal FS data storage type=?        */
    } val;
    FSvar *attachVar;               /* if mode=='Gg': field, 'Ff':transl var  */
};

struct mv_name
{             /* structure for array of mem var names             */
    FSuchar   name[11];     /* variable name (10 chars + 0 del.)  */
    FSulong   next;         /* next mem var name in linked list   */
    FSarr   * f;            /* pointer to array of field vars     */
    FSvar   * v;            /* pointer to actual variable struct  */
};

extern struct mv_name *mv_names;

extern FSvar *NIL_VAR,   *NULLSTR_VAR, *NULLDATE_VAR, *TRUE_VAR, *FALSE_VAR;
extern FSvar *ERROR_VAR, *ZERO_VAR,    *ONE_VAR,      *MINONE_VAR;
extern FSvar *TRUCB_VAR, *NILCB_VAR,   *IZERO_VAR,    *UIZERO_VAR;

extern FSint glob_depth;


/*  ------ structure keeping info for known alias names -----------------   */

struct f_ali_tab {
    FSchar * name;                     /* pointer to alias name      */
    FSint  * idx;                      /* index in known alias table */
};

struct g_ali_tab {
    FSchar identifier[12];
    struct f_ali_tab *f_ali_tab;
};

/*  ------ structure keeping info for user defined functions  -----------   */

typedef struct f_sym_tab {
    FSchar * name;                     /* pointer to function name */
    FSvar  * (*ptr)();                 /* function module address  */
} f_sym_tab;

typedef struct f_sym_tab2 {   // with FGS_NOWRITABLESTRINGS
    FSchar   name [20];                /* function name */
    FSvar  * (*ptr)();                 /* function module address  */
} f_sym_tab2;

typedef struct g_sym_tab {
    FSchar identifier[12];
    struct f_sym_tab *f_sym_tab;
} g_sym_tab;

/* ------- structure for locating a single fun to be accessable by macro -- */
struct fsuFuncLocate
{
   FSchar     f_locator[12];
   FSchar   * f_name;
#ifdef __cplusplus
   FSvar    * (* f_ptr)(int argc, FSvar *argv[]);
#else
   FSvar    * (* f_ptr)();
#endif
};

struct fsuFuncLocate2      // with FGS_NOWRITABLESTRINGS
{
   FSchar     f_locator[12];
   FSchar     f_name[20];
#ifdef __cplusplus
   FSvar    * (* f_ptr)(int argc, FSvar *argv[]);
#else
   FSvar    * (* f_ptr)();
#endif
};

/*  ------ structure keeping info for user defined variables  -----------   */

struct f_deb_tab {
    FSchar    * name;                  /* pointer to variable name */
    FSvar    ** idx;                   /* variable structure       */
};

struct f_var_tab {
    FSchar * name;                     /* pointer to variable name */
    FSint  * idx;                      /* variable structure index */
};

struct g_var_tab {
    FSchar identifier[12];
    struct f_var_tab *f_var_tab;
};

/*  ----- data structure keeping statuses of HW and SW environment ------   */

struct status {
    FSchar color,
         debugger,
         deb_stat,
         read_ex,
         read_ins,
         cancel;
};


/*  ------------------------ function stack ------------------------------  */

typedef struct fn_stack         /* one function stack entry                 */
{
    FSlong    lin_no;           /* line # in current function               */
    FSlong    tmv_now;          /* temporary variables for deletion mark    */
    FSlong    tmv_all;          /* temporary variables for deletion mark    */
    FSlong    seq_var_stack;    /* vars on stack for del. after BREAK mark  */
    FSlong    localupto;        /* variables on stack for deletion  mark    */
    FSvar   * rvalptr;          /* current return value                     */
    FSchar  * prg_name;         /* name of the prg where function is exec.  */
    FSchar  * module_name;      /* name of the current function             */
    FSshort   old_depth;        /* call depth -1 for this function          */
    FSshort   no_of_parameters; /* # of params passed in the cur. invocation*/
    FSvar   **parameters;       /* parameters passed to the cur. invocation */
    struct fn_stack  * old_fn_stack;/* backward ptr, stacking for gl. ref   */
    struct f_deb_tab * deb_info1;  /* debugger func local/statics table     */
    struct f_deb_tab * deb_info2;  /* debugger file statics table           */
    FSint     inh_level;        /* inheritance level for methods,
                                   super determination                      */
} fn_stack;

extern fn_stack *old_fn_stack;          /* function stack pointer of the    */
                                        /* calling function                 */

/*  ------------------------ objects structures --------------------------  
 * array of static xObject <class>Struct[] generated in .c with CLASS <class>
 * containing class properties, assigned at instantiation time to 
 *    VAR_SPECIAL(VAR_OBJ_INSTANCE(objVar,0)) 
 *    = objVar->val.cb.buff->components[0]->val.intern_data
 */
typedef struct xObject
{
    FSchar * pacName;      /* class/instance/method name */
    FSchar * pacAlias;     /* class-alias or 0 or "" */
    FSint    iPosition;
    FSint    iLevel;
    FSint    iWhat;        /* 'A':access,'=':assign, 'M':method */
} xObject;


/*  ------------------------ compiler data -------------------------------  */

extern FSchar __main_module[];  /* name of the main user module to start    */

extern FSuchar __core;          /* wether to trap seg.viol. signal or not   */

extern FSint __parc, __parc1;   /* parameter counters and parameter arrays  */

extern void *glob_sequencebuf;  /* long jump struct for BEGIN SEQUENCE END  */

extern FSint _sstep;            /* SINGLE STEP breakpoint flag              */

extern FSlong cur_var_stack;    /* counter to the top of the variable stack */

extern FSulong tmpvar_cnt;      /* temp vars counter                        */

extern struct status __status;  /* structure for status flags               */

extern FSint _tmp_1_, _tmp_2_;  /* temporaries during execution             */
extern FSvar *_vtmp_1_;         /* temporary variables during execution     */
extern int   _brkCount_;        /* BREAK count */

extern FSchar repdum[];         /* temporary scratch pad                    */

extern FSint fgs_release_50;    /* current version allowed with this comp.  */
/* extern FSint fgs_DEMO_50; */      /* THE DEMO VERSION                         */

extern FSvar *(*fgs_subscarr)();  /* function for array of subscripts    */


/*  ------------------------ functions called from the Open C API --------- */

extern FSvar * fgsMakeCB   FGS_ANSI((FSchar *));

/* -------- determine and specify if long long AND llseek() is available ---
 * FS_HAS_LONGLONG 1 = offset_t   llseek (fd, offset_t offll, int whence);
 * FS_HAS_LONGLONG 2 = int       _llseek (fd, ulong offhi, ulong offlow, loff_t *result, int whence);
 * FS_HAS_LONGLONG 3 = __int64 _lseeki64 (fd, __int64 offset, int whence);
 * ------------------------------------------------------------------------- */
#ifndef FS_HAS_LONGLONG
# if defined(SUNsolaris) || defined(FGSAIX)
#  define FS_HAS_LONGLONG 1   /* std Unix */
# elif defined (FGSLINUX)
#  define FS_HAS_LONGLONG 2   /* Linux specific */
# elif defined(FS_WIN32)
#  define FS_HAS_LONGLONG 3   /* Win32 specific */
# endif
#endif

#if defined(FGSAIX) || defined(SUNsolaris)  || defined(FGSLINUX)
# define FS_HAS_USLEEP_MS
#endif

#if defined(FGSAIX)
# define FS_HAS_GETTIMEOFDAY
#endif
#if defined(FS_WIN32) || defined(FS_BCC32)
# define FS_HAS_GETLOCALTIME
# define SLASH_CHAR '\\'
# define SLASH_STR  "\\"
#else
# define SLASH_CHAR '/'
# define SLASH_STR  "/"
#endif

/*  ------------------------ functions called by compiled prg code -------- */

extern FSvar       * autodec_u            FGS_ANSI((FSvar *));
extern FSvar       * autoinc_u            FGS_ANSI((FSvar *));
extern FSvar       * c_add_u              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * c_eequ_u             FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * c_equ_c              FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_equ_u              FGS_ANSI((FSchar *, FSvar*));
extern FSvar       * c_geq_c              FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_geq_u              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * c_gt_c               FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_gt_u               FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * c_in_u               FGS_ANSI((FSchar *, FSvar *));   
extern FSvar       * c_leq_c              FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_leq_u              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * c_lt_c               FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_neq_c              FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * c_neq_u              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * cpy_var              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * cpy_varf             FGS_ANSI((FSint, FSvar *));
extern FSvar       * cpy_varff            FGS_ANSI((FSint, FSint));
extern FSvar       * cpy_varfv            FGS_ANSI((FSint, FSint));
extern FSvar       * cpy_varpf            FGS_ANSI((FSvar *, FSint));
extern FSvar       * cpy_varpv            FGS_ANSI((FSvar *, FSint));
extern FSvar       * cpy_varv             FGS_ANSI((FSint, FSvar *));
extern FSvar       * cpy_varvf            FGS_ANSI((FSint, FSint));
extern FSvar       * cpy_varvv            FGS_ANSI((FSint, FSint));
extern FSvar       * cre_arra             FGS_ANSI((FSvar *, FSint, FSint, FSvar *[]));
extern FSvar       * cre_tmpvar           FGS_ANSI((void));
extern FSvar       * c_sub_u              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * d_equ_u              FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_geq_u              FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_gt_u               FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_leq_u              FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_lt_u               FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_neq_u              FGS_ANSI((FSulong, FSvar *));
extern FSvar       * d_sub_u              FGS_ANSI((FSulong, FSvar *));
extern void          del_tmpvars          FGS_ANSI((FSint));
extern int           del_var              FGS_ANSI((FSvar *));
extern FSvar       * dget_arr             FGS_ANSI((FSvar *, FSint   ));
extern FSvar       * dget_arrv            FGS_ANSI((FSvar *, FSvar * ));
extern void          _debugger            FGS_ANSI((void));
extern void          _debugsrc            FGS_ANSI((void));
extern FSvar       * exp_eval             FGS_ANSI((FSchar *));
extern FSvar       * fgsAddMethod         FGS_ANSI((FSvar *, FSint, FSvar *(*)(), FSint));
extern FSchar      * fgsCMxC              FGS_ANSI((FSchar *, FSint   ));
extern FSvar       * fgsCMxV              FGS_ANSI((FSchar *, FSint   ));
extern FSvar       * fgsDoInstance        FGS_ANSI((FSvar *, FSchar *, FSint, FSint, FSvar *));
extern FSvar       * fgsDoInit            FGS_ANSI((FSvar *, FSint, FSvar *[]));
extern FSvar       * fgsDoMethod          FGS_ANSI((FSchar *, FSint, FSint, FSint, FSvar *[]));
extern FSvar       * fgsDoSpecial         FGS_ANSI((FSvar *, FSint, FSint, FSint, FSint));
extern FSvar       * fgsGetAliasCField    FGS_ANSI((fgsWorkArea *, FSchar *));
extern FSvar       * fgsGetAliasField     FGS_ANSI((fgsWorkArea *, FSint   ));
extern FSvar       * fgsGetAliasVar       FGS_ANSI((fgsWorkArea *          ));
extern FSvar       * fgsGetCAliasCField   FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * fgsGetCAliasField    FGS_ANSI((FSchar *, FSint   ));
extern FSvar       * fgsGetCField         FGS_ANSI((FSchar *  ));
extern FSvar       * fgsGetCFieldOrNull   FGS_ANSI((FSchar *  ));
extern FSvar       * fgsGetField          FGS_ANSI((FSint     ));
extern FSvar       * fgsGetIAliasCField   FGS_ANSI((FSint   , FSchar *));
extern FSvar       * fgsGetIAliasField    FGS_ANSI((FSint   , FSint   ));
extern FSvar       * fgsGetLHSVar         FGS_ANSI((FSchar *  ));
extern FSvar       * fgsGetMemVar         FGS_ANSI((FSchar *  ));
extern FSvar       * fgsGetMemVarOrNull   FGS_ANSI((FSchar *  ));
extern FSvar       * fgsGetNAliasCField   FGS_ANSI((FSint   , FSchar *));
extern FSvar       * fgsGetNAliasField    FGS_ANSI((FSint   , FSint   ));
extern FSvar       * fgsGetVAliasCField   FGS_ANSI((FSvar * , FSchar *));
extern FSvar       * fgsGetVAliasField    FGS_ANSI((FSvar * , FSint   ));
extern FSvar       * fgsGetVar            FGS_ANSI((FSint  ));
extern FSint         fgsIntVar            FGS_ANSI((FSvar *));
extern FSuint        fgsUIntVar           FGS_ANSI((FSvar *));
extern FSint         fgsLockSelfVarBlockMeth FGS_ANSI((void));
extern FSint         fgsLogVar            FGS_ANSI((FSvar *));
extern FSvar       * fgsNoDoMethod        FGS_ANSI((FSchar *, FSint, FSint, FSvar *[]));
extern FSvar       * fgsNoDoMacroMethod   FGS_ANSI((FSchar *, FSint, FSint, FSvar *[]));
extern FSvar       * fgsNoIVar            FGS_ANSI((FSvar *, FSchar *, FSint, FSvar*));
extern FSdouble      fgsNumVar            FGS_ANSI((FSvar *));
extern FSchar      * fgsVMxC              FGS_ANSI((FSvar * , FSint));
extern FSvar       * fgsVMxV              FGS_ANSI((FSvar * , FSint));
extern fgsWorkArea * fgsPopArea           FGS_ANSI((fgsWorkArea * ));
extern fgsWorkArea * fgsPushArea          FGS_ANSI((fgsWorkArea * ));
extern fgsWorkArea * fgsPushCArea         FGS_ANSI((FSchar * ));
extern fgsWorkArea * fgsPushIArea         FGS_ANSI((FSint    ));
extern fgsWorkArea * fgsPushNArea         FGS_ANSI((FSint    ));
extern fgsWorkArea * fgsPushVArea         FGS_ANSI((FSvar *  ));
extern FSint         fgsSetConstant       FGS_ANSI((FSint, FSvar *, FSchar ));
extern FSvar       * fgsSetDefault        FGS_ANSI((FSvar *, FSint, FSchar, FSvar *));
extern FSint         fgsSetPermanent      FGS_ANSI((FSint, FSvar *, FSchar ));
extern void          fgs_after_break      FGS_ANSI((fn_stack *));
extern FSchar      * fgs_chararg          FGS_ANSI((FSvar *, FSchar *));
extern void          fgs_cleanup          FGS_ANSI((void *));
extern FSulong       fgs_ctod             FGS_ANSI((FSchar *));
extern FSint         fgs_declare          FGS_ANSI((FSint));
extern FSvar       * fgs_docall           FGS_ANSI((void (*)(), FSint, FSvar *[]));
extern FSvar       * fgs_fn_end           FGS_ANSI((fn_stack *, FSchar, FSchar *));
extern FSchar      * fgs_fn_start         FGS_ANSI((fn_stack *, FSchar *, FSchar *, FSint, FSint, FSvar *[]));
extern FSvar       * fgs_local_param      FGS_ANSI((FSint, FSint, FSvar *[], FSchar, FSchar *));
extern FSint         fgs_macro_declare    FGS_ANSI((FSchar *));
extern void          fgs_macro_param      FGS_ANSI((FSchar *, FSint, FSint, FSvar *[]));
extern FSint         fgs_macro_public     FGS_ANSI((FSchar *));
extern void          fgs_private_param    FGS_ANSI((FSint, FSint, FSint, FSvar *[]));
extern FSint         fgs_public           FGS_ANSI((FSint));
extern void          fs_break_error       FGS_ANSI((void));
extern FSvar       * set_Ov               FGS_ANSI((FSint, xObject [], FSvar *));
extern FSvar       * set_Iv               FGS_ANSI((FSint));
extern FSvar       * set_Ivar             FGS_ANSI((FSvar *, FSint));
extern FSvar       * set_Ivarv            FGS_ANSI((FSint, FSint));
extern FSvar       * set_Ivarf            FGS_ANSI((FSint, FSint));
extern FSvar       * set_UIv              FGS_ANSI((FSuint));
extern FSvar       * set_UIvar            FGS_ANSI((FSvar *, FSuint));
extern FSvar       * mak_var              FGS_ANSI((char, char));
extern void          _fgs_check_event     FGS_ANSI((int,int,int));
extern void          _fgs_ProcessUserEvents    FGS_ANSI((void));
extern void          _fgs_ProcessPendingEvents FGS_ANSI((FSint));
extern FSvar       * get_arr              FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * get_field            FGS_ANSI((FSchar *, FSchar *));
extern FSvar       * get_macroid          FGS_ANSI((FSchar *));
extern FSvar       * get_vfield           FGS_ANSI((FSvar *, FSchar *));
extern FSint         if_u                 FGS_ANSI((FSvar *));
extern FSvar       * (*instance_fun       FGS_ANSI((FSint, FSvar *)))();
extern FSvar       * (*instance_macrofun  FGS_ANSI((FSchar *, FSvar *)))();
extern FSvar       * instance_macrovar    FGS_ANSI((FSchar *, FSvar *));
extern FSvar       * instance_var         FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_and_u              FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_equ_u              FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_geq_u              FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_gt_u               FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_leq_u              FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_lt_u               FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_neq_u              FGS_ANSI((FSint, FSvar *));
extern FSvar       * l_or_u               FGS_ANSI((FSint, FSvar *));
extern FSvar       * (*macrofun           FGS_ANSI((FSchar *)))();
extern FSchar      * m_ex_c               FGS_ANSI((FSchar *, FSint));
extern FSvar       * minus_u              FGS_ANSI((FSvar *));
extern FSvar       * mk_var_cp            FGS_ANSI((FSvar *));
extern FSvar       * n_add_u              FGS_ANSI((double, FSint, FSvar *, FSint));
extern FSvar       * n_div_u              FGS_ANSI((double, FSvar *));
extern FSvar       * n_equ_u              FGS_ANSI((double, FSvar *));
extern FSvar       * nd_equ_u             FGS_ANSI((double, FSvar *));
extern FSvar       * ni_equ_u             FGS_ANSI((int,    FSvar *));
extern FSvar       * n_geq_u              FGS_ANSI((double, FSvar *));
extern FSvar       * nd_geq_u             FGS_ANSI((double, FSvar *));
extern FSvar       * ni_geq_u             FGS_ANSI((int,    FSvar *));
extern FSvar       * n_gt_u               FGS_ANSI((double, FSvar *));
extern FSvar       * nd_gt_u              FGS_ANSI((double, FSvar *));
extern FSvar       * ni_gt_u              FGS_ANSI((int,    FSvar *));
extern FSvar       * n_leq_u              FGS_ANSI((double, FSvar *));
extern FSvar       * nd_leq_u             FGS_ANSI((double, FSvar *));
extern FSvar       * ni_leq_u             FGS_ANSI((int,    FSvar *));
extern FSvar       * n_lt_u               FGS_ANSI((double, FSvar *));
extern FSvar       * nd_lt_u              FGS_ANSI((double, FSvar *));
extern FSvar       * ni_lt_u              FGS_ANSI((int,    FSvar *));
extern FSvar       * n_mod_u              FGS_ANSI((double, FSvar *));
extern FSvar       * n_mul_u              FGS_ANSI((double, FSint, FSvar *, FSint));
extern FSvar       * n_neq_u              FGS_ANSI((double, FSvar *));
extern FSvar       * nd_neq_u             FGS_ANSI((double, FSvar *));
extern FSvar       * ni_neq_u             FGS_ANSI((int,    FSvar *));
extern FSvar       * n_pow_u              FGS_ANSI((double, FSvar *));
extern FSvar       * n_sub_u              FGS_ANSI((double, FSint, FSvar *));
extern FSvar       * not_u                FGS_ANSI((FSvar *));
// extern FSvar *set_Ivar();
extern FSvar       * set_Svar();
extern FSvar       * set_Cvar             FGS_ANSI((FSvar *, char *, FSint));
extern FSvar       * set_cvar             FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * set_cvarf            FGS_ANSI((FSint,   FSchar *));
extern FSvar       * set_cvarv            FGS_ANSI((FSint,   FSchar *));
extern FSvar       * set_cv               FGS_ANSI((FSchar *));
extern FSvar       * set_cv_ptr           FGS_ANSI((FSchar *));
extern FSvar       * set_dvar             FGS_ANSI((FSvar *, FSulong));
extern FSvar       * set_dvarf            FGS_ANSI((FSint,   FSulong));
extern FSvar       * set_dvarv            FGS_ANSI((FSint,   FSulong));
extern FSvar       * set_dv               FGS_ANSI((FSulong));
extern FSvar       * set_lvar             FGS_ANSI((FSvar *, FSint));
extern FSvar       * set_lvarf            FGS_ANSI((FSint,   FSint));
extern FSvar       * set_lvarv            FGS_ANSI((FSint,   FSint));
extern FSvar       * set_lv               FGS_ANSI((FSint));
extern FSvar       * set_nvar             FGS_ANSI((FSvar *, FSdouble, FSint));
extern FSvar       * set_nvarf            FGS_ANSI((FSint,   FSdouble, FSint));
extern FSvar       * set_nvarv            FGS_ANSI((FSint,   FSdouble, FSint));
extern FSvar       * set_nv               FGS_ANSI((FSdouble, FSint));
extern FSvar       * set_svar             FGS_ANSI((FSvar *, FSvoid *));
extern FSvar       * u_add_c              FGS_ANSI((FSvar *, FSchar *, FSint));
extern FSvar       * u_add_u              FGS_ANSI((FSvar *, FSvar *, FSint));
extern FSvar       * u_and_u              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_autodec            FGS_ANSI((FSvar *));
extern FSvar       * u_autoinc            FGS_ANSI((FSvar *));
extern FSvar       * u_div_n              FGS_ANSI((FSvar *, double, FSint));
extern FSvar       * u_div_u              FGS_ANSI((FSvar *, FSvar *, FSint));
extern FSvar       * u_eequ_u             FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_equ_c              FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_equ_u              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_geq_c              FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_geq_u              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_gt_c               FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_gt_u               FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_in_c               FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_in_u               FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_leq_c              FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_leq_u              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_lt_c               FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_lt_u               FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_mod_n              FGS_ANSI((FSvar *, double, FSint));
extern FSvar       * u_mod_u              FGS_ANSI((FSvar *, FSvar *, FSint));
extern FSvar       * u_mul_u              FGS_ANSI((FSvar *, FSvar *, FSint));
extern FSvar       * u_neq_c              FGS_ANSI((FSvar *, FSchar *));
extern FSvar       * u_neq_u              FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_or_u               FGS_ANSI((FSvar *, FSvar *));
extern FSvar       * u_pow_n              FGS_ANSI((FSvar *, double , FSint));
extern FSvar       * u_pow_u              FGS_ANSI((FSvar *, FSvar *, FSint));
extern FSvar       * u_sub_c              FGS_ANSI((FSvar *, FSchar *, FSint));
extern FSvar       * u_sub_d              FGS_ANSI((FSvar *, FSulong, FSint));
extern FSvar       * u_sub_n              FGS_ANSI((FSvar *, double, FSint, FSint));
extern FSvar       * u_sub_u              FGS_ANSI((FSvar *, FSvar *, FSint));

extern int         ProcessEvents          ();
extern int         ProcessEventsClock     FGS_ANSI((FSint));

// extern void   _fgs_signal_n();
// extern void   _fgs_signal_l();
// extern void   _fgs_signal_d();
// extern void   _fgs_signal_a();

#if defined (FGS_ISANSI) 
extern FSvar * cre_arr           FGS_ANSI((FSvar *, int, int, ...));
extern FSvar * set_bvar          FGS_ANSI((FSvar *,FSvar *(*)(),int,...));
extern FSvar * set_bvar_inMeth   FGS_ANSI((FSvar *,FSvar *(*)(),int,...));
#elif defined(FGS_STDARGS_PROTO) || defined(FS_BCC32)
extern FSvar * cre_arr  (FSvar *, int, int, ...);
extern FSvar * set_bvar (FSvar *,FSvar *(*)(),int,...);
extern FSvar * set_bvar_inMeth (FSvar *,FSvar *(*)(),int,...));
#else
extern FSvar *cre_arr();
extern FSvar *set_bvar();
#endif

#ifdef __cplusplus
} /* End extern "C" */
#endif

#endif /* ifndef __FGS_FLAGSHIP__ */

/*** EOF FlagShip.h ***/
