#ifdef COMMENT_ONLY
/* For FlagShip 6. 
 * Copyright (c) 2005 by multisoft GmbH, Munich, Germany
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2005/09/27 17:49:10 $
 */
#endif

#if !defined(__FSGUIPRINTER_H__)
# define __FSGUIPRINTER_H__

# if defined ( __cplusplus )
#  include "FlagShip_cpp.h"
#  include "FSopenc.h"

  /* Note: forward decalaration is required here */
  class QPrinter;
  class QFont;
  class QString;

  extern "C" {

   UDF_PROT(_globsetti);    // _GlobSetting(...) = _aGlobSetting[...]

# else
  typedef void QPrinter ;
  typedef void QFont ;
  typedef void QPixmap ;
# endif

/* C interface functions to FS
 */
extern QPrinter   *FsGuiPrinter_Create();
extern int         FsGuiPrinter_Delete (QPrinter *);
extern int         FsGuiPrinter_Setup  (QPrinter *);
extern int         FsGuiPrinter_Aborted(QPrinter *);
extern int         FsGuiPrinter_SetValues(QPrinter *pr,  char *cOutputFile, 
                        int isLandscape, int iNumCopies, int iLastFirst,
                        int iFirstPage,  int iLastPage,  char *cPageSize,
                        int iColor);
extern const char *FsGuiPrinter_GetOutputFile(QPrinter *pr);
extern int         FsGuiPrinter_GetLandscape (QPrinter *pr); 
extern int         FsGuiPrinter_GetNumCopies (QPrinter *pr);
extern int         FsGuiPrinter_GetLastFirst (QPrinter *pr);
extern int         FsGuiPrinter_GetPageFirst (QPrinter *pr);
extern int         FsGuiPrinter_GetPageLast  (QPrinter *pr);
extern int         FsGuiPrinter_GetColor     (QPrinter *pr);
extern int         FsGuiPrinter_GetHmargin   (QPrinter *pr);
extern int         FsGuiPrinter_GetVmargin   (QPrinter *pr);
extern int         FsGuiPrinter_GetHldpi     (QPrinter *pr);
extern int         FsGuiPrinter_GetVldpi     (QPrinter *pr);
extern const char *FsGuiPrinter_GetPageSize  (QPrinter *pr);  
extern const char *FsGuiPrinter_GetDriver    (QPrinter *pr);
extern const char *FsGuiPrinter_GetExe       (QPrinter *pr);

extern int         FsGuiPrinter_PrintScreen  (QPrinter *pr, 
                                              int nLeftMargin,  int nTopMargin,
                                              int nRightMargin, int nBottMargin,
                                              int iAdapt);
extern int         FsGuiPrinter_PrintWindow(QPrinter *pr, QPixmap *pixmap,
                                              int nLeftMargin,  int nTopMargin,
                                              int nRightMargin, int nBottMargin, 
                                              int iAdapt );
extern int         FsGuiPrinter_PrintFormated(QPrinter * pr,  const char * pszFileName,
                                              int nLeftMargin,  int nTopMargin,
                                              int nRightMargin, int nBottMargin,
                                              const char *cHeadLeft,
                                              const char *cHeadMid,
                                              const char *cHeadRight,
                                              int *aiTabs, QFont * pFont) ;

# if defined ( __cplusplus )
};

/* C++ classes, functions, interface to Qt
 */
void _FsGuiPrinter_PrintLine(QPainter * paint, 
                int x, int y, int width, int height, const QString & str);
# endif
#endif 
/* eof */
