#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2001/07/30 14:04:55 $
 */
#endif

static char *fileID="@@#asciRdd:FieldGet() $Revision: 1.2 $";

#include "asgener.h"

#if defined(FGSICL600)
#   define FGSICLPRINTFSTR  "%*.*f"
#else
#   define FGSICLPRINTFSTR  "%*.*lf"
#endif


FSvar * asSelfFieldGet(ovSelf, vTmp)
FSvar * ovSelf;
FSvar * vTmp;
{   
    FSchar     tmp[64];
    FSlong     blok;
    FSulong    date = 0;
    FSint      ii       = VAR_ISFLDPOS(vTmp) - 1;
    
    AsAcMetObjPtr(pxSelf);

    if(AsFldUpdated(pxSelf)[ii]) return vTmp;

    AsFldUpdated(pxSelf)[ii] = 1;
    
    switch(AsFType(pxSelf, ii))
    {
    case 'C':
        VAR_LCHR(vTmp) = AsField(pxSelf, ii);
        break;
    case 'F':
    case 'N':
        VAR_NUM(vTmp) = msf_atof1((FSchar *) AsField(pxSelf, ii),
                                  0, AsFLen(pxSelf,ii));
        break;
    case 'D':
        memcpy(tmp, AsField(pxSelf, ii), AsFLen(pxSelf, ii));
        tmp[AsFLen(pxSelf, ii)] = 0;
 //     VAR_DATE(vTmp) = get_dat(tmp); /* convert date to  int */
        date = 0;
        if(strlen(tmp) > 0) {    
           /* date in YYYYMMDD format = dtos()
            */
           date = get_dat(tmp); 

           if(date == 0 ) {
              /*  date according to current SET DATE
               */
              date = fgs_ctod(tmp); 
           }
        } 
        VAR_DATE(vTmp) = date;
        break;
    case 'L':
        VAR_LOG(vTmp) = *(AsField(pxSelf, ii)) == 'T';
        break;
    default:
        rt_error (DTILLFL, "Unknown field type in ascirdd:fieldget()");
    }
    return vTmp;
}


AsMethod(quickfieldget)
{   
    return asSelfFieldGet(argv[0], argv[1]);
}


/*
 *  xx:FieldGet(nFieldNumber)
 */

AsMethod(fieldget)
{
    AsMethodObjPtr(pxSelf);
    
    FSint      fi;
    
    fgsStartMethod(fieldget);
    
    if(!ISNUMARG(1) && !ISCHRARG(1))
    {
        rt_error(RTILLTYP, "field name or number required");
        return fgsEndMethod(NIL_VAR);
    }
    
    switch(VAR_ISTYPE(argv[1]))
    {
    case 'C':
        argv[1] = AsMeName(fieldpos)(2, argv);
        /*FALLTHRU*/

    case 'N':
    case 'F': fi = VAR_INTNUM(argv[1]) - 1; break;
        
    case 'I': fi = VAR_INT(argv[1]) - 1;    break;
    }
             
    if((fi < 0) || (fi >= (FSint) AsFCount(pxSelf))) goto error_out;
    argv[1] = AsFldVar(pxSelf)[fi];
    
    return fgsEndMethod(AsMeName(quickfieldget)(2, argv));

 error_out:
    return fgsEndMethod(NIL_VAR);
}
/* EOF asfldget.c */
