#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2001/07/30 14:04:55 $
 */
#endif

/*--------------------------------------------------------------------------*
 | asmacros.h                macros for the entire asci   RDD               |
 *--------------------------------------------------------------------------*/

#if !defined(_AS_MACROS_H_)
#define _AS_MACROS_H_

/* #define FileVersion(x) */

#define AsAcMeName(name)     OBJ_METHNAMEACC(ascirdd,name)
#define AsAccessMethod(name) OBJ_DECL_METHACCESS(ascirdd,name)

#define AsAsMeName(name)     OBJ_METHNAMEASS(ascirdd,name)
#define AsAssignMethod(name) OBJ_DECL_METHASSIGN(ascirdd,name)

#define AsMeName(name)       OBJ_METHNAME(ascirdd,name)
#define AsMethod(name)       OBJ_DECL_METH(ascirdd,name)

#define AsAcMetObjPtr(name)  xAsciRdd * name = (xAsciRdd *)          \
                          VAR_SPECIAL(VAR_OBJ(ovSelf, AscirddReservedHidden))

#define AsMethodObjPtr(name) xAsciRdd * name = (xAsciRdd *)          \
                          VAR_SPECIAL(VAR_OBJ(argv[0], AscirddReservedHidden))


#define AsAcMetProto(name)   OBJ_PROT_METHACCESS(ascirdd,name)
#define AsAsMetProto(name)   OBJ_PROT_METHASSIGN(ascirdd,name)
#define AsMethodProto(name)  OBJ_PROT_METH(ascirdd,name)

#define fgsStartMethod(x)
#define fgsEndMethod(x)      x

#define DBF_OPEN        1              /* dbf file is opened                */
#define DBF_CLOSED      2              /* dbf file is closed                */

#define AsFldVar(x)         (x->fldvar)
#define AsRecord(x)         (x->rec_buf)
#define AsBuffer(x)         (x->pacBuffer)
#define AsDbStatus(x)       (x->stat)
#define AsFileSpec(x)       (x->name)
#define AsAlias(x)          (x->alias)
#define AsFh(x)             (x->fh)
#define AsDelimiter(x)      (x->acDelimiter)
        
#define AsIsDbUsed(x)       (AsDbStatus(x) & DBF_OPEN)
#define AsIsDbClosed(x)     (AsDbStatus(x) & DBF_CLOSED)

#define AsRecSize(x)        (x->reclen)
#define AsBufSize(x)        (x->iBuffSize)


#define AsFCount(x)         (x->fldcnt)

#define AsFldDefs(x)        (x->pxFldDefs)
#define AsFldPos(x,y)		(x->pxFldDefs[y].pos)
#define AsFType(x,y)		(x->pxFldDefs[y].type)
#define AsFName(x,y)		(x->pxFldDefs[y].name)
#define AsFLen(x,y)			(x->pxFldDefs[y].len)
#define AsFDec(x,y)			(x->pxFldDefs[y].dec)
#define AsFChrLen(x,y)		((AsFType(x,y) == 'C')                            \
                             ? (AsFLen(x,y) + AsFDec(x,y) * 256) : AsFLen(x,y))

#define AsField(x,y)        (&AsRecord(x)[AsFldPos(x,y)])

#define AsEof(x)            (x->eof)
#define AsCurRec(x)         (x->recno)
#define AsFldUpdated(x)     (x->updated_fields)

/* General Scoping */
#define AsForBlock(x)       (x->For_cond)
#define AsWhileBlock(x)     (x->Wh_cond)
#define AsScope(x)          (x->Sc_scope)
#define AsScRec(x)          (x->iRecord)

#define AsAll  -1
#define AsRest -2

#endif
/* EOF asmacros.h */
