#ifdef COMMENT_ONLY
/* For FlagShip 5 
 * Copyright (c) 2001 by multisoft GmbH, Munich, Germany 
 *
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2001/07/30 14:04:55 $
 */
#endif

static char *fileID="@@#asciRdd internal asReadBuff() $Revision: 1.2 $";

#include "asgener.h"
/*-----------------------------------------------------------------------*
 | asReadBuff : Asci File -> record buffer                               |
 | return     : 1 ok, 0 error                                            |
 *-----------------------------------------------------------------------*/
FSint      asReadBuff (pxSelf)

xAsciRdd * pxSelf;
{
	FSint    ii, jj;
	FSint    ok;
	FSint    len;
	FSint    ein;
	FSint    feld;
	FSint    offset;
	FSint    feldtyp;
	
	FSlong   istbuff;
	FSchar * str, komma, delichr;

	asClrRecord(pxSelf);                               /* clear all fields  */
	asInvalidateFields(pxSelf);
	
	/* -------------- read record from Asci File into buffer until \n    ---*/
	
	if (feof(AsFh(pxSelf)))
	{
		AsEof(pxSelf) = 1;
		return 0;
	}
	
	memset(AsBuffer(pxSelf), 0, AsBufSize(pxSelf));
	
	if (!fgets (AsBuffer(pxSelf), AsBufSize(pxSelf), AsFh(pxSelf)))
	{
		AsEof(pxSelf) = 1;
		return 0;
	}
	
	istbuff = strlen(AsBuffer(pxSelf));
	
	if (!istbuff) return 0;
	
	while ((istbuff > 0)
		   && ((AsBuffer(pxSelf)[istbuff-1]    == '\r')
			   || (AsBuffer(pxSelf)[istbuff-1] == '\n')
			   || (AsBuffer(pxSelf)[istbuff-1] == 0x1a)))
	{
		AsBuffer(pxSelf)[istbuff-1] = 0;
		istbuff--;
	}

	if (!istbuff) return 0;

	/* --------------- buffer --> select(from_wa) ---------------------------*/
	offset = 0;
	
	if (!AsDelimiter(pxSelf)[0] && !AsDelimiter(pxSelf)[1])
	{
		/*    -------- BLANK -------- */
		for (feld = 0; feld < (FSint) AsFCount(pxSelf) ; feld++)
		{
			offset += strspn(AsBuffer(pxSelf) + offset, " \t");
			str = (FSchar *) AsField(pxSelf, feld);
			len = AsFChrLen(pxSelf, feld);
			for (jj = 0;
				 (jj < len) && !strspn(AsBuffer(pxSelf) + offset, " \t");
				 jj++, offset++)
			{
				if (offset >= AsBufSize(pxSelf)) return 0;
				str[jj] = AsBuffer(pxSelf)[offset];
			}
		}
	}
	else if (!AsDelimiter(pxSelf)[1])
	{
		/*    -------- SDF -------- */
		for (ii=istbuff; ii < (FSint) AsRecSize(pxSelf); ii++)   /* 19.3.98 Bk */
			AsBuffer(pxSelf)[ii] = ' ';              /* 19.3.98 Bk */
	
		for (feld = 0; feld < (FSint) AsFCount(pxSelf) ; feld++)
		{
			str = (FSchar *) AsField(pxSelf, feld);
			len = AsFChrLen(pxSelf, feld);
			for (jj = 0; jj < len; jj++, offset++)
			{
				if (offset >= AsBufSize(pxSelf)) return 0;
				str[jj] = AsBuffer(pxSelf)[offset];
			}
		}
	}
	else
	{
		/*    -------- delimited -------- */
		for (feld = 0; feld < (FSint) AsFCount(pxSelf) ; feld++)
		{
			ein = 0;
			str = (char *) AsField(pxSelf, feld);
			len = AsFChrLen(pxSelf, feld);
			feldtyp = AsFType (pxSelf, feld);
			
			ok = 0;
			delichr = AsDelimiter(pxSelf)[0];
			komma   = AsDelimiter(pxSelf)[1];
			if ((feldtyp == 'C' || feldtyp == 'M') && delichr)
			{
				for (; (offset < istbuff); offset++) {
					if ((AsBuffer(pxSelf)[offset] == delichr)
						|| ((AsBuffer(pxSelf)[offset] != ' ')
							&& (AsBuffer(pxSelf)[offset] != '\t')))
					break;
				}
				if (AsBuffer(pxSelf)[offset] != komma) 
				{
					if (AsBuffer(pxSelf)[offset] == delichr) /* 1.char=Delim?*/
					offset++;
					else 
					delichr = 0;
					for (jj = 0; (jj < len) && (offset < istbuff); 
						 jj++, offset++) 
					{
						if ((delichr && (AsBuffer(pxSelf)[offset] == delichr))
							|| (!delichr
								&& (AsBuffer(pxSelf)[offset] == komma)))
						break;
						str[jj] = AsBuffer(pxSelf)[offset];
						ein ++;
					}
					if (delichr) {
						for (; (AsBuffer(pxSelf)[offset] != delichr) &&
							 (offset < istbuff); offset++); /* 2.delim */
						offset++;                           /* 2.delim weg */
					}
				}
			}
			else
			{	
				for (jj = 0; (jj < len) && (AsBuffer(pxSelf)[offset] != komma)
					 && (offset < istbuff); jj++, offset++)
				{
					str[jj] = AsBuffer(pxSelf)[offset];
					ein ++;
				}
			}
			for (;   (AsBuffer(pxSelf)[offset] != komma)  /* skip over   */
				 && (offset < istbuff); offset++);        /* bis comma   */
			offset++;                                     /* comma away  */
			
			if (ein < (len -1))
			{
				for (; ein < (len -1); ein++) str[ein] = ' ';
			}
		}
	}

	return 1;
}
/* EOF asrdtxtb.c */
