#!/bin/sh
# generate .h file with #define#s containing object properties
# use: gener_h.sh file.c file.h object file.prg 
#  eg: gener_h.sh _tbrowse.h  Tbrowse   otbrowse.c   ""
#  eg: gener_h.sh _gtbrowse.h _gtbrowse otbrowse_g.c otbrowse_g.prg

if [ $# -lt 3 ] ; then
   echo "*** gener_h.sh error, need 3 or 4 param"
   exit
fi

hfile=$1
object=$2
cfile=$3
prgfile=$4

if [ "$prgfile" = "" ] ; then
   prgfile=$cfile
else
   prgfile="$prgfile ($cfile)"
fi

echo '/*---------------------------------------------------------------'  > $hfile
echo " * $hfile"                                                         >> $hfile
echo ' *'          			                                              >> $hfile
echo " * DO NOT EDIT, generated from $prgfile"                           >> $hfile
echo " * via 'make' on `date`" 	                                        >> $hfile
echo ' *---------------------------------------------------------------' >> $hfile
echo ' */'          			                  >> $hfile
grep "# define $object" $cfile               >> $hfile
echo ' ' 				                        >> $hfile
echo '/* eof AUTO GENERATED */' 	            >> $hfile
echo ' ' 				                        >> $hfile
