#ifdef COMMENT_ONLY
* For FlagShip 6
* Copyright (c) 2007 by multisoft, Munich, Germany
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the
* modified source code when your application is distributed in source,
* but may not remove the copyright notice.
*
* Release $Date: 2007/08/23 16:12:14 $
*
* Standard box-functions similar to invoking the corresponding
* class method. You may modify this code according to your needs.
* Note that you will need all four function names unchanged, 
* to replace same named module in the FlagShip library.
*
* Compile: FlagShip -c -na -m boxfunct.prg
* Link Linux  : FlagShip  myapp*.prg boxfunct.o
* Link Windows: FlagShip  myapp*.prg boxfunct.obj
#endif

#include "dialog.fh"
#include "dialogclass.fh"
#include "set.fh"

*********************************************************************
* num := ErrBox(p1, [p2], [p3]) function
* same as/similar to ErrorBox{NIL,cMessage}:Show()
*
FUNCTION ErrBox (ctext as char, [cTitle as char], [nTimeOut as usual])
   local oBox := ErrorBox{NIL, ctext} as object
   if !empty(cTitle)
      oBox:Caption := cTitle
   endif 
   oBox:HotBox := _aGlobSetting[GSET_T_C_ERRBOX]
   if _GlobSetting(GSET_L_BOXES_POPUP, .F.) .and. !oBox:MoveKeysAvail
      oBox:MoveKeys := _aGlobSetting[GSET_A_BOXES_KEYS]
   endif
   if valtype(nTimeOut) == "N" .and. nTimeOut >= 0
      oBox:TimeOut := nTimeOut
   endif
   return oBox:show()

*********************************************************************
* num := InfoBox(p1, [p2], [p3]) function
* same as/similar to InfoBox{NIL,cHeader,cMessage}:Show()
*
FUNCTION InfoBox (ctext as char, [cTitle as char], [nTimeOut as usual])
   local oBox  := InfoBox{NIL, cTitle, ctext} as object
   oBox:HotBox := _aGlobSetting[GSET_T_C_INFOBOX]
   if _GlobSetting(GSET_L_BOXES_POPUP, .F.) .and. !oBox:MoveKeysAvail
      oBox:MoveKeys := _aGlobSetting[GSET_A_BOXES_KEYS]
   endif
   if valtype(nTimeOut) == "N" .and. nTimeOut >= 0
      oBox:TimeOut := nTimeOut
   endif
   return oBox:show()

*********************************************************************
* num := TextBox(p1, [p2], [p3]) function
* same as/similar to TextBox{NIL,cHeader,cMessage}:Show()
*
FUNCTION TextBox (ctext as char, [cTitle as char], [nTimeOut as usual])
   local oBox  := TextBox{NIL, cTitle, ctext} as object
   oBox:HotBox := _aGlobSetting[GSET_T_C_TEXTBOX]
   if _GlobSetting(GSET_L_BOXES_POPUP, .F.) .and. !oBox:MoveKeysAvail
      oBox:MoveKeys := _aGlobSetting[GSET_A_BOXES_KEYS]
   endif
   if valtype(nTimeOut) == "N" .and. nTimeOut >= 0
      oBox:TimeOut := nTimeOut
   endif
   return oBox:show()

*********************************************************************
* num := WarnBox(p1, [p2], [p3]) function
* same as/similar to WarningBox{NIL,cHeader,cMessage}:Show()
*
FUNCTION WarnBox (ctext as char, [cTitle as char], [nTimeOut as usual])
   local oBox := WarningBox{NIL, cTitle, ctext} as object
   if _GlobSetting(GSET_L_BOXES_POPUP, .F.) .and. !oBox:MoveKeysAvail
      oBox:MoveKeys := _aGlobSetting[GSET_A_BOXES_KEYS]
   endif
   if valtype(nTimeOut) == "N" .and. nTimeOut >= 0
      oBox:TimeOut := nTimeOut
   endif
   return oBox:show()
   
/* eof */
