* For FlagShip 5 
* Copyright (c) 2002 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2002/11/06 18:57:50 $
*
 
***************************************************************************
* Browse()  implementation based on dbedit()
*
* Copy the source to your working directory, and
* Compile: FlagShip -na -c -w -m [-FSintern] -io=b|g|t browse_gen.prg
* Link   : FlagShip myapp*.prg browse_gen.o [-io=a|g|t|b] [-o myapp]
*
* New in FS4.4: param5 (aColor) is new
*               edit is heavy changed, memoedit is new
* New in FS5.0: param 7..8 are new
*
***************************************************************************

#Cinline
static char *fileID="@@# general Browse() $Date: 2002/11/06 18:57:50 $";
#endCinline

/* ------------------------ .prg part ------------------------------- */
PROTO STATIC FUNC DisplStatus (                   )  AS String
PROTO STATIC FUNc EditField   (nColumn AS Intvar, ;
                               nRow    AS Numeric, ;
                               nCol    AS Numeric, ;
                               oTbr    AS object  )  AS Usual
PROTO STATIC FUNC EditMemo    (@fieldVal AS String)  AS Logical
PROTO STATIC FUNC fgs_brwk    (aa, bb, cc)           AS Usual
PROTO STATIC FUNC fgs_brwi    (aa, bb, cc)           AS Usual

#ifdef FSIO_GUI
PROTO FUNCTION _g_BrowUDF(nMode, nFldNum, oTbr) as usual
PROTO FUNC _g_DbEdit( [nTop      ], [nLeft     ], ;         
                     [nBott     ], [nRight    ], ;         
                     [axFields  ], [cbxUserUdf], ;         
                     [axPict    ], [axHeadTxt ], ;         
                     [axHeadSep ], [axColSep  ], ;         
                     [axFootSep ], [axFootTxt ], ;         
                     [cbForCond ], [cbWhiCond ], ;         
                     [nNext     ], [lInPixel  ]  ) AS Usua 
PROTO FUNC _gFsGet_ ( @nRow           AS Nume , ;
                      @nCol           AS Nume , ;
                       cVarName       AS Char , ;
                     [@bAssignBlock   AS Code], ;
                     [ cPicture       AS Char], ;
                     [@bPostCondBlock AS Code], ;
                     [@bPreCondBlock  AS Code], ;
                     [ cColorStr      AS Char], ;
                     [inPixel         AS Usua], ;
                     [nCaptRow        AS Usua], ;
                     [nCaptCol        AS Usua], ;
                     [nCaption        AS Usua], ;
                     [nCaptPict       AS Usua], ;
                     [obj             as usua], ;
                     [lDisplay        as logi]  ) AS Get
#endif
#ifdef FSIO_TERM
PROTO FUNCTION _t_BrowUDF(nMode, nFldNum, oTbr) as usual
PROTO FUNC _t_DbEdit( [nTop      ], [nLeft     ], ;         
                     [nBott     ], [nRight    ], ;         
                     [axFields  ], [cbxUserUdf], ;         
                     [axPict    ], [axHeadTxt ], ;         
                     [axHeadSep ], [axColSep  ], ;         
                     [axFootSep ], [axFootTxt ], ;         
                     [cbForCond ], [cbWhiCond ], ;         
                     [nNext     ], [lInPixel  ]  ) AS Usua 
PROTO FUNC _tFsGet_ ( @nRow           AS Nume , ;
                      @nCol           AS Nume , ;
                       cVarName       AS Char , ;
                     [@bAssignBlock   AS Code], ;
                     [ cPicture       AS Char], ;
                     [@bPostCondBlock AS Code], ;
                     [@bPreCondBlock  AS Code], ;
                     [ cColorStr      AS Char], ;
                     [inPixel         AS Usua], ;
                     [nCaptRow        AS Usua], ;
                     [nCaptCol        AS Usua], ;
                     [nCaption        AS Usua], ;
                     [nCaptPict       AS Usua], ;
                     [obj             as usua], ;
                     [lDisplay        as logi]  ) AS Get
#endif

#include "inkey.fh"
#include "FSerrmsg.h"

#ifndef _SET_SCOREBOARD
#  define _SET_SCOREBOARD 32
#  define _SET_CONFIRM    27
#endif

static sHelpCol, sHelpRow                  AS Numeric
static sFldNames                           AS Array
static sJustRead := .F.                    AS Logical
static sTop, sLeft, sBott, sRight          AS Numeric
static sIsNew, sIsTop, sIsBott             AS Logical
static sColors := {"","","","","",""}      AS Array
static sHelpLn := 0, sRecLen := 1          AS Intvar
static lPrompt                             AS Logical
static sAppendMode := .F.                  AS Logical
static slEditEmpty := .F.                  AS Logical

***************************************************************************
* Syntax: browse (top, left, bottom, right, [aColors], [lPrompt],
*                 [lAutoEdit], [inPixel] ) -> ok
*
* Browse a database the way dbedit() does it, incl. editing
*
* top, left     = top/left coordinates of Tbrowse, default = 0,0
* bottom, right = bottom/right coordinates. If not given, the size
*                 will be calculated from the record size or 
*                 the righmost coordinate whichever is smaller
* aColors       = array with color strings
* lPrompt       = .T. (default) prompts on exit
* lAutoEdit     = .T. enter edit mode on empty dbf, default = .F.
* inPixel       = .T. coord in pixel, .F. in usual coord, NIL (default) = 
*                 according to current SET PIXEL 
*
* Note: in the FS library, there is also function named Browse() but that 
*       fn is a dispatcher for _gBrowse(), _tBrowse() or _bBrowse() only.
*       If your application is compiled with -io=g|t|b, the stdio.fh 
*       translates Browse() directly to _<g|t|b>browse()  
*       If you don't want to use this mechanism, you need to define your
*       own function name and disable the #ifdef...#endif block below.
*
*********************** start of Browse() ******************************** 
#ifdef FSIO_GUI
   FUNC _g_Browse  ([Top            AS Numer], ;
                    [Left           AS Numer], ;
                    [Bottom         AS Numer], ;
                    [Right          AS Numer], ;
                    [aColors        AS Arra], ;
                    [lxPrompt       AS Logi], ;
                    [lAutoEdit      AS Logi], ;
                    [lInPixel       AS Usua]  ) AS Usua
   local cUdfName := "_g_BrowUDF" as char
#else
# ifdef FSIO_TERM
   FUNC _t_Browse  ([Top            AS Numer], ;
                    [Left           AS Numer], ;
                    [Bottom         AS Numer], ;
                    [Right          AS Numer], ;
                    [aColors        AS Arra], ;
                    [lxPrompt       AS Logi], ;
                    [lAutoEdit      AS Logi], ;
                    [lInPixel       AS Usua]  ) AS Usua
   local cUdfName := "_t_BrowUDF" as char
# else
#  ifdef FSIO_BASIC
   FUNC _b_Browse  ([Top            AS Numer], ;
                    [Left           AS Numer], ;
                    [Bottom         AS Numer], ;
                    [Right          AS Numer], ;
                    [aColors        AS Arra], ;
                    [lxPrompt       AS Logi], ;
                    [lAutoEdit      AS Logi], ;
                    [lInPixel       AS Usua]  ) AS Usua
                 
    _Rt_Error(DEVWARNING, "Browse() is not available in basic mode")
    return NIL
#  else
#    error Compiler switch -io=g or -io=b or -io=t required! See program note.
#  endif
# endif
#endif
***************************************************************************
#ifndef FSIO_BASIC
                       
local jj, ii := pcount()                      AS Intvar
local oldconfrm := set(_SET_CONFIRM   , .F.)  AS Logical
local oldscoreb := set(_SET_SCOREBOARD, .F.)  AS Logical
local dummy, oldColor := setcolor()           AS String
local the_screen                              AS Screen
local nHeadSize, nFactor, nSize, pix8, pix3   AS numeric
local isGuiMode                               AS Logic

if !used()
   alert("No database open to BROWSE()")
   return .F.
endif

/* Note: Browse() is not designed to be be used recursively
 * because it uses static variables. To avoid problems, we 
 * check the callstack for other occurences of this UDF
 */
dummy := ProcStack(1)
if (ProcName() $ dummy)
   alert("The BROWSE() cannot be called;recursively, use DBEDIT();or Tbrowse object")
   return .F.
endif
   
lPrompt := if (lxPrompt != NIL, lxPrompt, .T.)
if valtype(lAutoEdit) == "L" 
   slEditEmpty := lAutoEdit
endif

/* set colors
 */
for jj := 1 to 6
   if valtype(aColors) != "A" .or. ;                    // [1] output, get
      len(aColors) < jj .or. empty(aColors[jj])         // [2] border
      sColors[jj] := setcolor()                         // [3] get/read
   else                                                 // [4] status line
      sColors[jj] := aColors[jj]                        // [5] memoedit get
   endif                                                // [6] memoedit bord
next

keyboard chr(0)
inkey()

sJustRead := sIsNew := sIsTop := sIsBott := .F.
sAppendMode := .F. 

if lastrec() <= 50
   sRecLen := 2
elseif lastrec() <= 900
   sRecLen := 3
else
   sRecLen := len(ltrim(str(lastrec() + 100)))
endif
sHelpLn := 30 + (sRecLen * 2)

/* set default coordinates, if not specified
 */
sTop    := default (top,  1)
sBott   := default (bottom, maxrow())
sLeft   := default (left, 0)
sRight  := default (right,  maxcol())

if sLeft + 3 > sRight .and. !(right == NIL .or. right <= 0)
   sLeft  := 0
   sRight := maxcol()
endif
if sBott < sTop +4
   sTop  := 1
   sBott := maxrow()
endif

/* Calculate right column from the record size.
 * Apply only if <right> param is not given, or is <= 0
 * For GUI, we assume here filling factor of 60% for char fields and
 *   will count also trailing spaces, since oTbrowse:Trim is not set.
 *   Note, this is a rought calculation only without reading the data. 
 *   Tbrowse will make the proper final column adjustments and will 
 *   display horizontal scrollbar if required.
 */
if right == NIL .or. right <= 0
   isGuiMode := AppIoMode() == "G"
   nFactor := if (isGuiMode, 0.60, 1.0)   // GUI: assuming 60% of char fields
   pix8    := Pixel2Col(8)
   pix3    := Pixel2Col(3)
   right   := 0
   for ii := 1 to Fcount()
      nHeadSize := if(isGuiMode,Strlen2col(FieldName(ii))+pix8,len(FieldName(ii)))
      do case
      case Fieldtype(ii) == "M"
         right += max(nHeadSize, if(isGuiMode,Strlen2col("<MEMO>")+pix3,6))
      case Fieldtype(ii) == "D"
         if Set(_SET_CENTURY)
            right += max(nHeadSize, if(isGuiMode,Strlen2col("22/12/2222")+pix3,10) )
         else
            right += max(nHeadSize, if(isGuiMode,Strlen2col("22/12/22")+pix3,8) )
         endif
      case Fieldtype(ii) == "L"
         right += max(nHeadSize, if(isGuiMode,Strlen2col("T")+pix3,1))
      case Fieldtype(ii) $ "NFI"
         right += max(nHeadSize, ;
            if(isGuiMode,Strlen2col(repli("5",FieldLen(ii)))+pix3,FieldLen(ii)))
      otherwise
         if isGuiMode
            nSize := FieldLen(ii) * nFactor * Strlen2col("5") + ;
                     FieldLen(ii) * (1.0 - nFactor) * Strlen2col(" ") + pix3
            right += max(nHeadSize, nSize)
         else
            right += max(nHeadSize, FieldLen(ii))
         endif
      endcase
   next
   if isGuiMode
      right += Pixel2Col(20)  // scrollbar + frame
      if (valtype(lInPixel) == "L" .and. lInPixel) .or. Set(_SET_PIXEL)
         right := Col2Pixel(right)
      endif 
   else
      if Fcount() > 0
         right += Fcount() -1             // column separators
      endif
      right ++                            // left/right box
   endif
   sRight := min(right + sLeft, maxcol())
endif

/* other coordinates
 */
sHelpCol := max(0, sRight - sHelpLn)
if sLeft + 2 + sHelpCol > sRight
   sHelpCol := 0
endif

sFldNames := array(fcount())
afields(sFldNames)

the_screen := savescreen(sTop, sLeft, sBott, sRight)
if AppIoMode() == "T"
   sHelpRow := sTop + 1
   setcolor(sColors[2])
   @ sTop, sLeft, sBott, sRight box " "
   @ sTop + 3, sLeft  say ""
   @ sTop + 3, sRight say ""
   
   dbedit(sTop + 2, sLeft + 1, sBott - 1, sRight - 1, sFldNames, ;
         cUdfName, nil, nil, "", chr(255), lInPixel)
else
   sHelpRow := sTop 
   /*
    * Note: dbedit() source is available in .../system/dbedit.prg
    */
   dbedit(sTop + 1, sLeft, sBott, sRight, sFldNames, ;
         cUdfName, nil, nil, "", chr(255), lInPixel)
endif


setcolor(oldColor)
restscreen(sTop, sLeft, sBott, sRight, the_screen)
set(_SET_SCOREBOARD, oldconfrm)
set(_SET_CONFIRM   , oldscoreb)
 
return(.t.)

*----------------------------------------------------------------------
STATIC FUNCTION default (var, defvalue)
if valtype(var) != "N" .or. var < 0
   return defvalue
endif
return var

*----------------------------------------------------------------------
* _?_BrowUDF() UDF for DBEDIT call in BROWSE
*
* p1 (N) mode which dbedit is in:
*        0 idle, 1 bof bang, 2 eof bang, 3 dbf empty, 4 except, 5 start
* p2 (n) actual index of sFldNames
* Ret= 0: leave memoedit
*      1: continue
*      2: reread data
*      3: append a record
#ifdef FSIO_GUI
FUNCTION _g_BrowUDF(nMode, nFldNum, oTbr) as usual
#else
# ifdef FSIO_TERM
FUNCTION _t_BrowUDF(nMode, nFldNum, oTbr) as usual
# endif
#endif
local  nrow := row(), ncol := col()       AS Numeric
local  xColor                             AS String
local  oTc                                AS object   // tbColumn
local  lastkey := lastkey(), ii, nn := 0  AS Intvar
local  lOk                                as logic

sIsNew := sAppendMode
sIsTop := sIsBott := .F.

if valtype(oTbr) == "O" .and. nMode == 5
   xColor := oTbr:COLORSPEC + ","
   for ii := 1 to len(xColor)
      if substr(xColor,ii,1) == ","
         nn++
      endif
   next
   xColor += replicate(",", 5-nn) + sColors[1]
   oTbr:COLORSPEC := xColor
   for ii := 1 to oTbr:COLCOUNT
      oTc := oTbr:GETCOLUMN(ii)
      oTc:COLORBLOCK := {|| {6, 7}}
   next
endif

DisplStatus()

do case
case nMode == 0 .and. eof()           // DE_IDLE = in append
   keyboard chr(K_RETURN)             // force get/read

case nMode == 1                       // DE_HITTOP = bof bang
   sIsTop := .T.

case nMode == 3                       // DE_EMPTY 
   /* The dbf is empty.
    * Simulate K_DOWN = Cursor-Down key and return "Continue", 
    * DbEdit() will then detect DE_HITBOTTOM and re-enter this 
    * UDF with nMode == 2, i.e. append mode
    */
   sIsBott := .T.
   keyboard chr(K_DOWN)

case nMode == 2                       // DE_HITBOTTOM = eof bang 
   /* append mode:
    * - if the last key was K_DOWN = Cursor-Down, 
    *   returns "Append", DbEdit() will then re-enter 
    *   this UDF with nMode == 4, i.e. exception -> Edit
    * - otherwise returns "Continue" to ignore
    */
   sIsBott := .T.
   DisplStatus()
   
   if lastkey == K_DOWN .and. (slEditEmpty .or. reccount() > 0) 
      DisplStatus()
      sAppendMode := .T.
      return(3)                       // DE_APPEND = append
   endif

case nMode == 4                       // DE_EXCEPT = exception
   /* Exception mode. 
    * The UDF can decide what to do. Here: 
    * - if the last key was Delete, delete or recall current record
    * - if the last key was Escape, exit DbEdit() with/without prompt
    * - otherwise edit current field (which performs APPEND BLANK on
    *   eof() and if the edit was not aborted by Esc), 
    *   then force DbEdit() to refresh display
    */
   DisplStatus()
   do case
   case lastkey == K_DEL
      rlock()
      if deleted()
         dbrecall()
      else
         dbdelete()
      endif
      unlock
      
   case lastkey == K_ESC
      if !lPrompt
         return 0                // DE_ABORT = abort DbEdit()
      elseif alert ("Abort BROWSE", {"no","yes"}) == 2
         return 0
      endif
      
   otherwise
      setcursor(1)               // set cursor ON
      clear typeahead            // clear keyaboard buffer, but
      inkey()
      if lastkey != K_RETURN .and. lastkey >= 32
         keyboard chr(lastkey)   // re-use the last entered character key if any
      endif
      DisplStatus()
      lOk := EditField (nFldNum, nRow, nCol, oTbr)  // edit, append blank on eof()
      clear typeahead
      sJustRead := .t.
      
      sAppendMode := .F.
      setcursor(0)               // disable cursor

      if !lOk .and. reccount() = 0 
         return 0                // empty dbf + ESC = avoid re-entry
      endif
      return(2)                  // DE_REFRESH = force reread/refresh
   endcase

case nMode == 5                  // start-up mode
   sAppendMode := .F. 
   
endcase
DisplStatus()
return 1                         // DE_CONT = continue

*----------------------------------------------------------------------
* EditField() is used in MyDbedUdf()
*
STATIC FUNCTION EditField (nColumn AS Intvar,  ;
                           nRow    AS Numeric, ;
                           nCol    AS Numeric, ;
                           oTbr    AS Object )  AS Usual
LOCAL getlist := {}                              AS Array
LOCAL ok := .F., lReadExit := ReadExit (.T.)     AS Logical
LOCAL fieldVal, oldKeyUp, oldKeyDown, oldKeyIns  AS Usual
LOCAL fieldName, cPict, oldCol := setcolor()     AS String

set cursor on                                    // cursor visible
fieldName := fieldname(nColumn)                  // field name
fieldVal  := fieldget (nColumn)                  // field content

if type(fieldName) == "M"
   ok := editMemo (@fieldVal)                    // edit Memo field
else
   setcolor (sColors[3])
   oldKeyUp   := setkey(K_UP,   {|p1,p2,p3| fgs_brwk(p1,p2,p3)})
   oldKeyDown := setkey(K_DOWN, {|p1,p2,p3| fgs_brwk(p1,p2,p3)})
   oldKeyIns  := setkey(K_INS,  {|p1,p2,p3| fgs_brwi(p1,p2,p3)})

   do case
   case type(fieldName) $ "NFI"                 // numeric fileds?
      if fielddeci(nColumn) > 0
         cPict := replicate("#", fieldlen(nColumn) - ;
                    fielddeci(nColumn) - 1) + "." + ;
                  replicate("#",fielddeci(nColumn))
      else
         cPict := replicate("#", fieldlen(nColumn))
      endif
      @ nRow, nCol GET fieldVal PICTURE (cPict)
   case type(fieldName) == "C" .and. fieldlen(nColumn) > 77
      @ nRow, nCol GET fieldVal PICTURE "@S77"
   case type(fieldName) == "L"
      fieldVal := if (fieldVal, "T", "F")
      @ nRow, nCol + (oTbr:GETCOLUMN(nColumn):WIDTH) -1  ;
        GET fieldVal PICTURE "!" valid fieldVal $ "YNTF"
   otherwise
      @ nRow, nCol GET fieldVal
   endcase
   READ clear
   ok := UPDATED() .and. lastkey() != K_ESC

   setkey(K_UP,   oldKeyUp  )
   setkey(K_DOWN, oldKeyDown)
   setkey(K_INS,  oldKeyIns )
   setcolor (oldCol)
endif

if ok
   if type(fieldName) == "L"
      fieldVal := (fieldVal $ "TY")
   endif
   if eof()
      append blank
      sIsNew := .F.
   else
      rlock()
   endif
   FieldPut (nColumn, fieldVal)                  // replace
   unlock
endif
setpos (nRow, nCol)
set cursor off                                   // cursor invisible
ReadExit (lReadExit)                             // restore exit key
return ok

*----------------------------------------------------------------------
* EditMemo() is used in EditField()
*
STATIC FUNCTION EditMemo (@fieldVal AS String) AS Logical   // edit Memo field
Local xScr1                                   AS Screen
Local isColor := setcolor()                   AS String
Local ii                                      AS IntVar 
Local nRow1, nRow2, nCol1, nCol2, nMax        AS Numeric
Local cTxt                                    AS String
Local nCol := col(), nRow := row()            AS Numeric

nRow1 := sTop   + 6
nRow2 := sBott  - 3
nCol1 := sLeft  + 3
nCol2 := sRight - 3
if nRow2 < nRow1 + 3
   nRow2 := sBott -1
   while nRow2 < nRow1 + 3 .and. nRow1 > 0
      nRow1--
   enddo
endif
while nRow2 < nRow1 + 3 .and. nRow2 < maxrow()
   nRow2++
enddo
if nRow2 < nCol1 + 3
   nCol2 := sRight -1
   while nCol2 < nCol1 + 3 .and. nCol1 > 0
      nCol1--
   enddo
endif
while nCol2 < nCol1 + 3 .and. nCol2 < maxcol()
   nCol2++
enddo

xScr1 := SaveScreen(nRow1,nCol1, nRow2,nCol2)    // save screen

SET FUNCTION 10 TO chr(K_CTRL_W)                 // redirect F10 to ^W
setcolor(sColors[6])                             // memoedit border
@ nRow1,nCol1 CLEAR TO nRow2,nCol2
@ nRow1,nCol1       TO nRow2,nCol2

cTxt := replicate ("....5....0", int((maxcol()+10)/10))
@ nRow1,nCol1+1 say substr(cTxt, 1, nCol2 - nCol1 -1)
cTxt := "Edit memo field, save with <Ctrl-W> or <F10>, " + ;
        "abort with <ESC>"
nMax := nCol2 - nCol1 -1
if len(cTxt) > nMax
   cTxt := substr(cTxt,1,nMax)
endif
ii := max(1, int((nMax - len(cTxt)) / 2))
@ nRow2,nCol1+ii say cTxt
setcolor(sColors[5])                             // memoedit colors

fieldVal := MEMOEDIT (fieldval, ;
            nRow1+1, nCol1+1, nRow2-1, nCol2-1, ;
            .T., NIL, 255,NIL,NIL, ;
            NIL,NIL,NIL,.F.,NIL,.T.)             // edit the memo field
SET FUNCTION 10 TO                               // disable F10

setcolor(isColor)                                // restore colors
RestScreen(nRow1,nCol1, nRow2,nCol2, xScr1)      // restore screen
setpos (nRow, nCol)
return lastkey() != K_ESC

*----------------------------------------------------------------------
* fgs_brwk      build up statusline for browse
*                      ....5....0....5....0....5....0....5....0....
* sHelpRow, sHelpCol: "<Deleted><First><ins> Record xxxxxxx/xxxxxxx"
* sHelpRow, sHelpCol: "         <Last> <ins>
* sHelpRow, sHelpCol: "         <NEW>  <ins>
*
STATIC FUNCTION DisplStatus() AS String
local buffer                       AS String
local nCol := col(), nRow := row() AS Intvar

if sHelpCol == 0                               && not enough space
   return("")
endif

buffer := if(deleted(), "<Deleted>", space(9))
if sIsNew .or. eof()
   buffer += "<NEW>  "
elseif sIsTop
   buffer += "<First>"
elseif sIsBott .or. recno() >= lastrec()
   buffer += "<Last> "
else
   buffer += space(7)
endif
if readinsert()
   buffer += "<ins>"
else
   buffer += space(5)
endif
buffer += "Record " + str(recno(),sRecLen) + "/" + str(lastrec(),sRecLen)
if len(buffer) < sHelpLn
   buffer := padr (buffer, sHelpLn)
endif
@ sHelpRow, sHelpCol say buffer COLOR sColors[4]
setpos (nRow, nCol)
return buffer

*----------------------------------------------------------------------
* fgs_rwwk()                         Keybard-return function for BROWSE
* In -
*
STATIC FUNCTION fgs_brwk(aa, bb, cc)
memvar  fgs_keybkey
private fgs_keybkey

fgs_keybkey := lastkey()
keyboard chr(K_RETURN) + chr(fgs_keybkey)
sJustRead := .T.
return(nil)

*----------------------------------------------------------------------
* fgs_brwi                                  toggle insert mode in read
* In -
*
STATIC FUNCTION fgs_brwi(aa, bb, cc)

readinsert(!readinsert())
if sHelpCol == 0                               && not enough space
   return(nil)
endif
DisplStatus()
return(nil)

*----------------------------------------------------------------------
* FlagShip Functions, not available in Clipper
*
#ifndef FlagShip
// # include "dbstruct.ch"
// function FieldLen(pos)
//   return DbFieldInfo (DBS_LEN, pos)                // Clipper 5.3
// function FieldDeci(pos)
//   return DbFieldInfo (DBS_DEC, pos)                // Clipper 5.3
#endif

#endif  /* not for -io=b, i.e. FSIO_BASIC */
/* EOF bbbrowse.prg */
