***************************************************************************
* rddcb4.prg    common code of the RDD API and Class for the
*               CB4CDX, CB4FOX, CB4NDX, CB4MDX and CB4NTX driver
*               by using CodeBase 5.1, 6.1, 6.54 multiplatform version 
*               (not included in the FlagShip package, contact Sequiter Inc)
*
* This file creates the function CB4FOXNEW(), CB4CDXNEW(), CB4NDXNEW(),
* CB4MDXNEW() or CB4NTXNEW(), according to the defaults, set in the
* 'Makefile' file or given as FlaShip compiler flag -DCREATE_CB4xxx.
*
* (c) 1995..2004 multisoft Datentechnik GmbH, Munich. All rights reserved  
* Release $Date: 2004/10/27 10:04:42 $                                     
***************************************************************************
//
// Driver  Makefile define  .o file  IndexExt()    CB #define  CB lib
//
// CB4CDX   CREATE_CB4CDX  cb4cdx.o  .cdx (C5,Fox)  S4FOX      libcbfox.a
// CB4FOX   CREATE_CB4FOX  cb4fox.o  .idx (Fox)     S4FOX      libcbfox.a
// CB4NDX   CREATE_CB4NDX  cb4ndx.o  .ndx (dB3)     S4NDX      libcbndx.a
// CB4MDX   CREATE_CB4MDX  cb4mdx.o  .mdx (dB4)     S4MDX      libcbmdx.a
// CB4NTX   CREATE_CB4NTX  cb4ntx.o  .ntx (C5,C87)  S4CLIPPER  libcbntx.a

#define _FROM_RDDCB4_CREATOR  /* used only here                 */
#define _FROM_RDDCB4_METHOD   /* used in all rddcb*.prg methods */

#include "dataserv.fh"

#ifdef CREATE_CB4CDX          /* CB4CDX: FoxBase and Clipper 5.x .cdx index */
   ANNOUNCE CB4CDX
   CLASS CB4CDX INHERIT DataServer
#  include "cb4cdx.fh"        /* instances and properties of the class      */
#else
#ifdef CREATE_CB4FOX          /* CB4FOX: FoxBase .idx index                 */
   ANNOUNCE CB4FOX
   CLASS CB4FOX INHERIT DataServer
#  include "cb4fox.fh"        /* instances and properties of the class      */
#else
#ifdef CREATE_CB4NDX          /* CB4NDX: dBase3  .ndx index                 */
   ANNOUNCE CB4NDX
   CLASS CB4NTX INHERIT DataServer
#  include "cb4ndx.fh"        /* instances and properties of the class      */
#else
#ifdef CREATE_CB4MDX          /* CB4MDX: dBase4  .mdx index                 */
   ANNOUNCE CB4MDX
   CLASS CB4MDX INHERIT DataServer
#  include "cb4mdx.fh"        /* instances and properties of the class      */
#else
#ifdef CREATE_CB4NTX          /* CB4NTX: Clipper .ntx index                 */
   ANNOUNCE CB4NTX
   CLASS CB4NTX INHERIT DataServer
#  include "cb4ntx.fh"        /* instances and properties of the class      */
#else
#error *** Specify/define CREATE_CB4xxx first ***
#endif
#endif
#endif
#endif
#endif

** FUNCTION CB4xxxNEW ([p1,[p2...]]) ****************************************
// created here automatically by the FlagShip compiler, the body includes:
// CB4xxx:INIT (p1,p2....)
// return SELF

** eof rddcb4.prg **

