/***************************************************************************
 * rddcb4fs.h    RDD API for the CB4FOX, CB4CDX, CB4NDX, CB4MDX and CB4NTX
 *               by using CodeBase 5.1 or 6.1, 6.54 multiplatform version 
 *               (not included in the FlagShip package, contact Sequiter Inc.)
 *
 * (c) 1995..2004 multisoft Datentechnik GmbH, Munich. All rights reserved.
 * Release $Date: 2004/10/27 09:53:51 $                                     
 ****************************************************************************/

#ifndef  __RDD_CB4FS__
# define __RDD_CB4FS__

/* General settings available in cb4gener.fh containns #defines of
   CB4FS_MINIMAL_RDD,
   CB4FS_CBLOCK_SUPPORT,
   CB4FS_ERROUT_CSOURCE,
   TEST_ON,
   CREATE_CB4xxx
   ------------------------------------------------------------------------ */
#include "cb4gener.fh"

#include "FSopenc.h"                             /* Open C API              */
#include "FSerrors.h"                            /* defines error codes     */
#include "rddsys.fh"                             /* defines for DBserver    */
#include "d4all.h"                               /* CB5 CodeBase #include   */

extern FSint   rt_error();
extern FSint   io_error();

#define CB4FS_JULIAN_ADJUSTMENT  1721425L
#define PATHMAX 250
#ifndef LONG_MAX
#define LONG_MAX 2147483647L
#endif

#ifdef TEST_ON
# define CB4FS_DEBUG_BEGIN(text,var) \
   fprintf(stderr,"\n-> %s ...entering %s at line %d",text,__FILE__, __LINE__)
# define CB4FS_DEBUG_END(text,var) \
   (fprintf(stderr,"\n<- %s ...exiting %s at line %d", \
	  text,__FILE__, __LINE__), var)
#else
# define CB4FS_DEBUG_BEGIN(dummy,var)
# define CB4FS_DEBUG_END(dummy,var)    var
#endif

/* changes below this line are NOT required/recommended
   ------------------------------------------------------------------------ */
#ifdef _FGS_CCNAME_CONV2
#  define CB4FStmpName(obj,name)       _bb_/**/obj/**/_/**/name/**/_fn
#else
#  define CB4FStmpName(obj,name)       _bb_##obj##_##name##_fn
#endif

#ifndef S4UNIX
# error define 'S4UNIX' in 'd4all.h' first
#endif

// fix for bug in d4inline.h
#if S4VERSION == 6502
# define D4LOCK_TEST(a,b)  ( d4lockTest(a,b,lock4write) )
#else
# define D4LOCK_TEST(a,b)  ( d4lockTest(a,b) )
#endif

#ifdef CREATE_CB4CDX
# ifndef S4FOX
#   error define S4FOX in 'd4all.h' first
# endif
# if defined(CREATE_CB4FOX) || defined(CREATE_CB4NDX) || defined(CREATE_CB4MDX) || defined(CREATE_CB4NTX)
#   error Multiple driver CREATE_??? definition
# endif
# define CB4FSrddName              "CB4CDX"
# define CB4FSindexExt             ".cdx"
# define CB4FSdbfExt               ".dbf"
# define CB4FSdbtExt               ".fpt"
# define CB4FSrddVersion           4.40
# define CB4FScanUseIndexOrder     1
# define CB4FSudf(name)            CB4FStmpName(cb4cdx,name)
# define CB4FS_DECL_METH(name)     OBJ_DECL_METH(cb4cdx,name)
# define CB4FS_DECL_ACCESS(name)   OBJ_DECL_METHACCESS(cb4cdx,name)
# define CB4FS_DECL_ASSIGN(name)   OBJ_DECL_METHASSIGN(cb4cdx,name)
# define CB4FS_CALL_METH(name)     OBJ_METHNAME(cb4cdx,name)
# define CB4FS_CALL_ACCESS(name)   OBJ_METHNAMEACC(cb4cdx,name)
# define CB4FS_CALL_ASSIGN(name)   OBJ_METHNAMEASS(cb4cdx,name)
# define setCB4meth(name,pos)                     \
    { extern FSvar * OBJ_METHNAME(cb4cdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAME(cb4cdx,name)) ; }
# define setCB4access(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEACC(cb4cdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEACC(cb4cdx,name)) ; }
# define setCB4assign(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEASS(cb4cdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEASS(cb4cdx,name)) ; }
# define setCB4methNIL(pos) \
    SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1),0)
#endif

#ifdef CREATE_CB4FOX
# ifndef S4FOX
#   error define S4FOX in 'd4all.h' first
# endif
# if defined(CREATE_CB4CDX) || defined(CREATE_CB4NDX) || defined(CREATE_CB4MDX) || defined(CREATE_CB4NTX)
#   error Multiple driver CB4FS_??? definition
# endif
# define CB4FSrddName              "CB4FOX"
# define CB4FSindexExt             ".idx"
# define CB4FSdbfExt               ".dbf"
# define CB4FSdbtExt               ".fpt"
# define CB4FSrddVersion           4.40
# define CB4FScanUseIndexOrder     0
# define CB4FSudf(name)            CB4FStmpName(cb4fox,name)
# define CB4FS_DECL_METH(name)     OBJ_DECL_METH(cb4fox,name)
# define CB4FS_DECL_ACCESS(name)   OBJ_DECL_METHACCESS(cb4fox,name)
# define CB4FS_DECL_ASSIGN(name)   OBJ_DECL_METHASSIGN(cb4fox,name)
# define CB4FS_CALL_METH(name)     OBJ_METHNAME(cb4fox,name)
# define CB4FS_CALL_ACCESS(name)   OBJ_METHNAMEACC(cb4fox,name)
# define CB4FS_CALL_ASSIGN(name)   OBJ_METHNAMEASS(cb4fox,name)
# define setCB4meth(name,pos)                     \
    { extern FSvar * OBJ_METHNAME(cb4fox,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAME(cb4fox,name)); }
# define setCB4access(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEACC(cb4fox,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEACC(cb4fox,name)); }
# define setCB4assign(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEASS(cb4fox,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEASS(cb4fox,name)) ; }
# define setCB4methNIL(pos) \
    SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1),0)
#endif

#ifdef CREATE_CB4NDX
# ifndef S4NDX
#   error define S4NDX in 'd4all.h' first
# endif
# if defined(CREATE_CB4FOX) || defined(CREATE_CB4CDX) || defined(CREATE_CB4MDX) || defined(CREATE_CB4NTX)
#   error Multiple driver CB4FS_??? definition
# endif
# define CB4FSrddName              "CB4NDX"
# define CB4FSindexExt             ".ndx"
# define CB4FSdbfExt               ".dbf"
# define CB4FSdbtExt               ".dbt"
# define CB4FSrddVersion           4.40
# define CB4FScanUseIndexOrder     0
# define CB4FSudf(name)            CB4FStmpName(cb4ndx,name)
# define CB4FS_DECL_METH(name)     OBJ_DECL_METH(cb4ndx,name)
# define CB4FS_DECL_ACCESS(name)   OBJ_DECL_METHACCESS(cb4ndx,name)
# define CB4FS_DECL_ASSIGN(name)   OBJ_DECL_METHASSIGN(cb4ndx,name)
# define CB4FS_CALL_METH(name)     OBJ_METHNAME(cb4ndx,name)
# define CB4FS_CALL_ACCESS(name)   OBJ_METHNAMEACC(cb4ndx,name)
# define CB4FS_CALL_ASSIGN(name)   OBJ_METHNAMEASS(cb4ntx,name)
# define setCB4meth(name,pos)                     \
    { extern FSvar * OBJ_METHNAME(cb4ndx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAME(cb4ndx,name)) ; }
# define setCB4access(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEACC(cb4ndx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEACC(cb4ndx,name)) ; }
# define setCB4assign(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEASS(cb4ndx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEASS(cb4ndx,name)) ; }
# define setCB4methNIL(pos) \
    SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1),0)
#endif

#ifdef CREATE_CB4MDX
# ifndef S4MDX
#   error define S4MDX in 'd4all.h' first
# endif
# if defined(CREATE_CB4FOX) || defined(CREATE_CB4CDX) || defined(CREATE_CB4NDX) || defined(CREATE_CB4NTX)
#   error Multiple driver CB4FS_??? definition
# endif
# define CB4FSrddName              "CB4MDX"
# define CB4FSindexExt             ".mdx"
# define CB4FSdbfExt               ".dbf"
# define CB4FSdbtExt               ".dbt"
# define CB4FSrddVersion           4.40
# define CB4FScanUseIndexOrder     1
# define CB4FSudf(name)            CB4FStmpName(cb4mdx,name)
# define CB4FS_DECL_METH(name)     OBJ_DECL_METH(cb4mdx,name)
# define CB4FS_DECL_ACCESS(name)   OBJ_DECL_METHACCESS(cb4mdx,name)
# define CB4FS_DECL_ASSIGN(name)   OBJ_DECL_METHASSIGN(cb4mdx,name)
# define CB4FS_CALL_METH(name)     OBJ_METHNAME(cb4mdx,name)
# define CB4FS_CALL_ACCESS(name)   OBJ_METHNAMEACC(cb4mdx,name)
# define CB4FS_CALL_ASSIGN(name)   OBJ_METHNAMEASS(cb4mdx,name)
# define setCB4meth(name,pos)                     \
    { extern FSvar * OBJ_METHNAME(cb4mdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAME(cb4mdx,name)) ; }
# define setCB4access(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEACC(cb4mdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEACC(cb4mdx,name)) ; }
# define setCB4assign(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEASS(cb4mdx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEASS(cb4mdx,name)) ; }
# define setCB4methNIL(pos) \
    SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1),0)
#endif

#ifdef CREATE_CB4NTX
# ifndef S4CLIPPER
#   error define S4CLIPPER in 'd4all.h' first
# endif
# if defined(CREATE_CB4FOX) || defined(CREATE_CB4CDX) || defined(CREATE_CB4NDX) || defined(CREATE_CB4MDX)
#   error Multiple driver CB4FS_??? definition
# endif
# define CB4FSrddName              "CB4NTX"
# define CB4FSindexExt             ".ntx"
# define CB4FSdbfExt               ".dbf"
# define CB4FSdbtExt               ".dbt"
# define CB4FSrddVersion           4.40
# define CB4FScanUseIndexOrder     0
# define CB4FSudf(name)            CB4FStmpName(cb4ntx,name)
# define CB4FS_DECL_METH(name)     OBJ_DECL_METH(cb4ntx,name)
# define CB4FS_DECL_ACCESS(name)   OBJ_DECL_METHACCESS(cb4ntx,name)
# define CB4FS_DECL_ASSIGN(name)   OBJ_DECL_METHASSIGN(cb4ntx,name)
# define CB4FS_CALL_METH(name)     OBJ_METHNAME(cb4ntx,name)
# define CB4FS_CALL_ACCESS(name)   OBJ_METHNAMEACC(cb4ntx,name)
# define CB4FS_CALL_ASSIGN(name)   OBJ_METHNAMEASS(cb4ntx,name)
# define setCB4meth(name,pos)                     \
    { extern FSvar * OBJ_METHNAME(cb4ntx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAME(cb4ntx,name)) ; }
# define setCB4access(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEACC(cb4ntx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEACC(cb4ntx,name)) ; }
# define setCB4assign(name,pos)                      \
    { extern FSvar * OBJ_METHNAMEASS(cb4ntx,name)(); \
      SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1), OBJ_METHNAMEASS(cb4ntx,name)) ; }
# define setCB4methNIL(pos) \
    SET_VAR_BLOCK(VAR_ARRELEM(aMethPtr,pos+1),0)
#endif

#ifndef CB4FSrddName
# error Driver CREATE_CB4??? not specified (defined)
#endif

/* ------- Macros used in the rddcb4?.c sources --------------------------- */
#define CB4FS_GETDATA4PTR                                \
   ((IS_VAR_SPECIAL(VAR_OBJ(ovSelf,CB4OBJ_DATA4))) ?     \
     VAR_SPECIAL(VAR_OBJ(ovSelf,CB4OBJ_DATA4)) : NULL)

#define CB4FS_GETINDEXARR                                   \
   (((IS_VAR_ARR(VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR))) &&      \
     (VAR_ISDIM (VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR))  > 0)) ? \
     VAR_OBJ(ovSelf,CB4OBJ_INDEX4ARR) : NIL_VAR)


/* ------ Class and FlagShip Compiler dependent section -----------------
   Define's for INSTANCES of the RDD object used by Open C API, according
   to the FlagShip's include file cb4xxx.fh and cb4xxx_i.fh

   Note: Although the instances may be accessed directly by NAME, it would
   decrease the execution speed, since the addresses would be resolved at
   run-time (late binding). For a compile-time address resolution (early
   binding), the generated instance NUMBER (or the according #define symbol)
   must be used.

   Because of the ->common C code<- for all the FIVE different RDD drivers,
   general "CB4OBJ_xxx" defines are used here. These are simply mapped to
   the specific define's generated from the .prg source by the FlagShip
   compiler while compiling the rddcb4.prg module (or the application
   program). In any other RDD, you may directly use the internally
   created define-s of the instance number, for invoking e.g. the
   VAR_OBJ(oSelf,<InternalInstanceNumb>) macro according to FSopenc.h.

   Warning: you have to correspondingly change the internal instance name,
   when changing the instances in the cb4xxx.fh file.
   ------------------------------------------------------------------------ */

#ifdef CREATE_CB4CDX
#include "cb4cdxauto.h"    /* created from the rddcb4.prg file by Makefile  */

/*      used in "rddcb4?.c"    Intern.Instance name & pos.   .prg Instance  */
/*      --------------------   --------------------          -------------  */
#define CB4OBJ_CODE4           Cb4cdxPtrcode4Hidden       /* ptrCode4       */
#define CB4OBJ_CONCURRENCY     Cb4cdxIconcurrenProtect    /* iConcurrency   */
#define CB4OBJ_DATA4           Cb4cdxPtrdata4Hidden       /* ptrData4       */
#define CB4OBJ_DBF_EXT         Cb4cdxCddbf_extProtect     /* cDdbf_ext      */
#define CB4OBJ_DBT_EXT         Cb4cdxCdbt_extProtect      /* cDbt_ext       */
#define CB4OBJ_DELIMITER       Cb4cdxCdelimiterProtect    /* cDelimiter     */
#define CB4OBJ_DRIVERNAME      Cb4cdxCdrivernamProtect    /* cDriverName    */
#define CB4OBJ_ERROBJECT       Cb4cdxOerrobjectProtect    /* oErrObject     */
#define CB4OBJ_FIELDVARS       Cb4cdxPtrfieldvaHidden     /* ptrFieldVars   */
#define CB4OBJ_FILEFULLNAME    Cb4cdxCfilefullnProtect    /* cFileFullName  */
#define CB4OBJ_FILEINPNAME     Cb4cdxCfileinpnaProtect    /* cFileInpName   */
#define CB4OBJ_FILEOPENMODE    Cb4cdxIfileopenmHidden     /* iFileOpenMode  */
#define CB4OBJ_FILTERBLOCK     Cb4cdxBfilterbloProtect    /* bFilterBlock   */
#define CB4OBJ_FILTERSTRING    Cb4cdxCfilterstrProtect    /* cFilterString  */
#define CB4OBJ_FOR_COND        Cb4cdxUfor_condProtect     /* uFor_cond      */
#define CB4OBJ_FOUNDFLAG       Cb4cdxLfoundflagProtect    /* lFoundFlag     */
#define CB4OBJ_IDX_EXT         Cb4cdxCidx_extProtect      /* cIdx_ext       */
#define CB4OBJ_INDEX4ARR       Cb4cdxAindex4arrHidden     /* aIndex4arr     */
#define CB4OBJ_INDEXDESC       Cb4cdxLindexdescProtect    /* lIndexDesc     */
#define CB4OBJ_INDEXEFFECT     Cb4cdxLindexeffeProtect    /* lIndexEffect   */
#define CB4OBJ_INDEXFORBLK     Cb4cdxBindexforbProtect    /* bIndexForBlk   */
#define CB4OBJ_INDEXFORSTR     Cb4cdxCindexforsProtect    /* cIndexForStr   */
#define CB4OBJ_INDEXORDNUM     Cb4cdxIindexordnProtect    /* iIndexOrdNum   */
#define CB4OBJ_INDEXRECBLK     Cb4cdxBindexrecbProtect    /* bIndexRecBlk   */
#define CB4OBJ_INDEXRECNEXT    Cb4cdxIindexrecnProtect    /* iIndexRecNext  */
#define CB4OBJ_INDEXRECORD     Cb4cdxIindexrecoProtect    /* iIndexRecord   */
#define CB4OBJ_INDEXRECSTAR    Cb4cdxIindexrecsProtect    /* iIndexRecStar  */
#define CB4OBJ_INDEXREST       Cb4cdxIindexrestProtect    /* iIndexRest     */
#define CB4OBJ_INDEXSTEP       Cb4cdxIindexstepProtect    /* iIndexStep     */
#define CB4OBJ_INDEXWHIBLK     Cb4cdxBindexwhibProtect    /* bIndexWhiBlk   */
#define CB4OBJ_LOCATEBLOCK     Cb4cdxBlocatebloProtect    /* bLocateBlock   */
#define CB4OBJ_LOCATERECNO     Cb4cdxIlocaterecProtect    /* iLocateRecno   */
#define CB4OBJ_RELATIONS       Cb4cdxArelationsProtect    /* aRelations     */
#define CB4OBJ_RELCOUNT        Cb4cdxIrelcountProtect     /* iRelCount      */
#define CB4OBJ_SCOPE           Cb4cdxNscopeProtect        /* nScope         */
#define CB4OBJ_USED            Cb4cdxLusedProtect         /* lUsed          */
#define CB4OBJ_WHI_COND        Cb4cdxUwhi_condProtect     /* uWhi_cond      */
#endif

#ifdef CREATE_CB4FOX
#include "cb4foxauto.h"
#endif

#ifdef CREATE_CB4NDX
#include "cb4ndxauto.h"
#endif

#ifdef CREATE_CB4MDX
#include "cb4mdxauto.h"
#endif

#ifdef CREATE_CB4NTX
#include "cb4ntxauto.h"
#endif

/* Subarray of aIndex4arr[x,6] used in "rddcb4?.c"  */
/* see a description in the cb4cdx.fh file          */

#define CB4OBJ_INDEX_FNAME   1
#define CB4OBJ_INDEX_TNAME   2
#define CB4OBJ_INDEX_TNUMB   3
#define CB4OBJ_INDEX_I4NEW   4
#define CB4OBJ_INDEX_I4PTR   5
#define CB4OBJ_INDEX_T4PTR   6
#define CB4OBJ_INDEX_SIZE    6


/* --- Macros to translate codebase5 structure member and function names --- */
#ifdef CODEBASE6

                                   /* structure name changes */
#define add_condition addCondition
#define auto_open autoOpen
#define calc_list calcList
#define calc_memory calcMemory
#define calc_ptr calcPtr
#define code_base codeBase
#define create_error errCreate
#define data_tag dataTag
#define default_unique_error errDefaultUnique
#define error_action errorAction
#define error_code errorCode
#define exclusive accessMode
#define expr_error errExpr
#define expr_source exprSource
#define field_name_error errFieldName
#define fields_memo fieldsMemo
#define go_error errGo
#define is_changed isChanged
#define last_add_value lastAddValue
#define last_node lastNode
#define last_reset_value lastResetValue
#define len_max lenMax
#define lock_attempts lockAttempts
#define master_expr masterExpr
#define match_len matchLen
#define mem_expand_block memExpandBlock
#define mem_expand_data memExpandData
#define mem_expand_index memExpandIndex
#define mem_expand_tag memExpandTag
#define mem_size_block memSizeBlock
#define mem_size_buffer memSizeBuffer
#define mem_size_memo memSizeMemo
#define mem_size_memo_expr memSizeMemoExpr
#define mem_size_sort_buffer memSizeSortBuffer
#define mem_size_sort_pool memSizeSortPool
#define mem_start_block memStartBlock
#define mem_start_data memStartData
#define mem_start_index memStartIndex
#define mem_start_max memStartMax
#define mem_start_tag memStartTag
#define n_link nLink
#define num_parms numParms
#define num_reports numReports
#define off_error errOff
#define old_record oldRecord
#define open_error errOpen
#define optimize_write optimizeWrite
#define read_lock readLock
#define read_only readOnly
#define rec_num recNum
#define record_changed recordChanged
#define record_width recWidth
#define relate_error errRelate
#define relation_type relationType
#define reset_expression resetExpression
#define sort_source sortSource
#define sort_type sortType
#define tag_name_error errTagName
#define total_children totalChildren
#define total_list totalList
#define total_memory totalMemory
#define total_type totalType

                        /* for function name changes we use 
                           CodeBase's own include file       */
#define S4CB51
#include "d4inline.h"
#undef S4CB51

#endif                 /* CODEBASE6             */

#endif                 /* ifndef __RDD_CB4FS__  */

/* eof rddcb4fs.h */

