* For FlagShip 4.4 to 6
* Copyright (c) 2007 by multisoft, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2007/09/28 08:35:51 $
*
* -------------------------------------------------------------------------
* copy this file to your working directory,
* compile: FlagShip -c -m -na -w -io=g -DNOSTDFUNCT dbedit.prg -odbedit_g.o
*  and/or: FlagShip -c -m -na -w -io=t -DNOSTDFUNCT dbedit.prg -odbedit_t.o
* Link   : FlagShip myappl*.prg dbedit*.o [-io=a|g|t|b]  ...
* -------------------------------------------------------------------------

#include "inkey.fh"
#include "setcurs.fh"
#include "dbedit.fh"
#include "dbstruct.fh"
#include "tbrclass.fh"    
#include "tbrowse.fh"     
#include "errclass.fh"   
#include "error.fh"      
#include "FSerrmsg.h"

** #define ALERNATIVE_ERROR

#define TRUE        .T.
#define FALSE       .F.

#ifndef DE_APPEND
#define DE_APPEND    3
#endif

#ifndef DE_START
#define DE_START     5                     /* new in FS4.4            */
#endif

#ifndef RTARGVAL                           /* == FSerrors.h           */
#define RTARGVAL     313                   /* Wrong argument value    */
#define RTNODBF      322                   /* No database opened      */
#endif

#define RTEMSG1 "Wrong type/value of parameter "
#define RTEMSG2 "No open database in area "
#define RTEMSG3 "Field '"
#define RTEMSG4 "' not available"
#define RTEMSG5 "1 or 3"
#define RTEMSG6 "2 or 6"
#define RTEMSG7 "13 or 14"


PROTO STATIC FUNC defaultval (var, type, defval) AS Usual
PROTO STATIC FUNC RTError    (errVal AS Intvar, str AS String)    AS Usual
PROTO STATIC FUNC MyGoTop    (cbForCond, cbWhiCond,          ;
                              nNext, nStart, xFirst, iSkip)       AS Logical
PROTO STATIC FUNC MyGoBottom (lAppend, cbForCond, cbWhiCond, nNext, ;
                              nStart, xLast, xMax, xSkip, iSkip)  AS Logical
PROTO STATIC FUNC SkipDbedit (nMode, lAppend, ;
                              cbForCond, cbWhiCond, nNext, iSkip) AS Intvar
PROTO STATIC FUNC doRefreshAl(oTbr)                               AS Usual
PROTO FUNCT ErrorNew         ()                                   as object

#ifdef FSIO_GUI
   PROTO FUNCT _g_TBrowDB  (p1,p2,p3,p4)  as usual
#endif
#ifdef FSIO_TERM
   PROTO FUNCT _t_TBrowDB  (p1,p2,p3,p4)  as usual
#endif

/* ********************** dbedit.prg ****************************************
 * Additions to DBEDIT() functionality of FlagShip 4.x and Clipper 5.x:
 * - Fields may also be specified as "field1;field2;...;fieldN" string
 * - Optional parameters cForCond|bForCond, cWhiCond|bWhiCond, nNext
 * - Three (instead of two) parameters are passed to the UDF. The 3rd
 *   parameter is the TBrowse object itself.
 * - On start-up, the UDF is invoked with mode 5 (DE_START) to allow
 *   modify the Tbrowse object.
 *   
 * See compilation notes above.
 * Note: in the VFS library, there is also function named DbEdit() but that 
 *       fn is a dispatcher for _g_DbEdit(), _t_DbEdit() or _b_DbEdit() only.
 *       If your application is compiled with -io=g|t|b, the stdio.fh 
 *       translates DbEdit() directly to _<g|t|b>DbEdit()  
 *       If you don't want to use this mechanism, you need to define your
 *       own function name (or use DBEDIT to override the dispatcher) and 
 *       disable also the #ifdef...#endif block below.
 * 
 *********************** start of DBEDIT() ******************************** */
#ifdef FSIO_GUI
   FUNC _g_DbEdit( [nTop      ], [nLeft     ], ;            // par  1,  2 
                   [nBott     ], [nRight    ], ;            // par  3,  4 
                   [axFields  ], [cbxUserUdf], ;            // par  5,  6 
                   [axPict    ], [axHeadTxt ], ;            // par  7,  8 
                   [axHeadSep ], [axColSep  ], ;            // par  9, 10 
                   [axFootSep ], [axFootTxt ], ;            // par 11, 12 
                   [cbForCond ], [cbWhiCond ], ;            // par 13, 14 
                   [nNext     ], [lInPixel  ]  ) AS Usua    // par 15, 16 
#else
# ifdef FSIO_TERM
   FUNC _t_DbEdit( [nTop      ], [nLeft     ], ;         
                   [nBott     ], [nRight    ], ;         
                   [axFields  ], [cbxUserUdf], ;         
                   [axPict    ], [axHeadTxt ], ;         
                   [axHeadSep ], [axColSep  ], ;         
                   [axFootSep ], [axFootTxt ], ;         
                   [cbForCond ], [cbWhiCond ], ;         
                   [nNext     ], [lInPixel  ]  ) AS Usua 
# else
#  ifdef FSIO_BASIC
   FUNC _b_DbEdit( [nTop      ], [nLeft     ], ;         
                   [nBott     ], [nRight    ], ;         
                   [axFields  ], [cbxUserUdf], ;         
                   [axPict    ], [axHeadTxt ], ;         
                   [axHeadSep ], [axColSep  ], ;         
                   [axFootSep ], [axFootTxt ], ;         
                   [cbForCond ], [cbWhiCond ], ;         
                   [nNext     ], [lInPixel  ]  ) AS Usua 
                 
    _Rt_Error(DEVWARNING, "DbEdit() is not available in basic mode")
    return NIL
#  else
#    error Compiler switch -io=g or -io=b or -io=t required! See program note.
#  endif
# endif
#endif
***************************************************************************
#ifndef FSIO_BASIC  

LOCAL aFields, aHeadTxt, aPict, aHeadSep, aColSep, aFootSep, aFootTxt AS Usual
LOCAL aStruct                                                         AS Array
LOCAL cbUserUdf, xudfRet                                              AS Usual
LOCAL saveCurs, saveRow := ROW(), saveCol := COL()                    AS Numer
LOCAL bKeyBlck, block_NIL := {|| NIL}                                 AS usual
LOCAL nn, nRow, nCol                                                  AS Numer 
LOCAL udfRet, nKey                                                    AS Intvar
LOCAL lHasUDF := FALSE, lAppend := .F.                                AS Logica
LOCAL iSkip := 0, xSkip := 0, nStartRec := recno()                    AS Intvar
LOCAL xFirst := 0, xLast := 0, xMax := lastrec()                      AS Intvar
LOCAL CurRec := 0                                                     AS Intvar
LOCAL ii, iArrLen := 0                                                AS Int
LOCAL dummy, dummy2 as usual

#ifdef FSIO_GUI
 LOCAL oTbr  AS _gTBrowse             // prototyped for FlagShip 5
 LOCAL oTcol AS _gTBColumn            // for compile-time resolution
#endif
#ifdef FSIO_TERM
 LOCAL oTbr  AS _tTBrowse      
 LOCAL oTcol AS _tTbColumn     
#endif
#ifdef FSIO_ALL
 LOCAL oTbr, oTcol     
#endif

* ------------------------------------
* Parameter checking, set default
* ------------------------------------

nTop  := max (0, defaultval(nTop,  "N", 0))
nLeft := max (0, defaultval(nLeft, "N", 0))
nBott := min (defaultval(nBott, "N", maxrow()), maxrow())
nRight:= min (defaultval(nRight,"N", maxcol()), maxcol())

if nTop >= nBott
   RTError (RTARGVAL, RTEMSG1 + RTEMSG5)
   return NIL
endif
if nLeft >= nRight
   RTError (RTARGVAL, RTEMSG1 + RTEMSG6)
   return NIL
endif
if !used()
   RTError (RTNODBF, RTEMSG2 + ltrim(str(select())))
   return NIL
endif
cbUserUdf := cbxUserUdf
if empty(cbxUserUdf)
   cbUserUdf := NIL
endif

if !(valtype(cbForCond) $ "CMBU") .or. !(valtype(cbWhiCond) $ "CMBU")
   RTError (RTARGVAL, RTEMSG1 + RTEMSG7)
   return NIL
endif
if !(valtype(nNext) $ "NIFU")
   RTError (RTARGVAL, RTEMSG1 + "15")
   return NIL
endif

if valtype(cbForCond) $ "CM"
   cbForCond := &("{||" + cbForCond + "}")    // convert to code block
endif
if valtype(cbWhiCond) $ "CM"
   cbWhiCond := &("{||" + cbWhiCond + "}")    // convert to code block
endif

* ------------------------------------
* Fields
* ------------------------------------
aFields := {}
IF VALTYPE(axFields) == "C" .and. !empty(axFields)
   WHILE (ii := at(";", axFields)) > 0
      dummy := alltrim(upper(substr(axFields, 1, ii-1)))
      if !empty(dummy)
         aadd (aFields, dummy)
      endif
      axFields := substr(axFields, ii+1)
   ENDDO
   if !empty(axFields)
      aadd (aFields, alltrim(upper(axFields)))
   endif
elseif VALTYPE(axFields) == "A"
   FOR ii := 1 to LEN(axFields)
      IF VALTYPE(axFields[ii]) == "C" .and. !empty(axFields[ii])
         aadd (afields, upper(alltrim(axFields[ii])))
      ENDIF
   NEXT
else
   aStruct := DBSTRUCT()
   IF LEN(aStruct)  == 0       // default to all fields in current work area
      RETURN NIL               // error, nothing to work with
   ENDIF
   FOR ii := 1 TO LEN(aStruct)
      AADD(aFields,aStruct[ii,DBS_NAME])
   NEXT
endif
iArrLen := LEN(aFields)
if iArrLen == 0
   RTError (RTARGVAL, RTEMSG1 + "5")
   return NIL
endif
* -------------------------------------
* column headings, footings, separators
* -------------------------------------
IF VALTYPE(axHeadTxt) == "C"
   aHeadTxt := AFILL(ARRAY(iArrLen),axHeadTxt)
else                                             // create aHeadTxt[]
   aHeadTxt := ACLONE (if (VALTYPE(axHeadTxt) == "A", axHeadTxt, aFields))
   ASIZE(aHeadTxt,iArrLen)
   for ii := 1 to iArrLen
      if VALTYPE(aHeadTxt[ii]) != "C"
         aHeadTxt[ii] := aFields[ii]
      endif
   next
ENDIF
if VALTYPE(axFootTxt) == "C" .and. len(axFootTxt) > 0
   aFootTxt := AFILL(ARRAY(iArrLen),axFootTxt)
elseif valtype(axFootTxt) == "A"                 // create aFootTxt[]
   aFootTxt := ACLONE (axFootTxt)
   ASIZE(aFootTxt,iArrLen)
   for ii := 1 to iArrLen
      if VALTYPE(aFootTxt[ii]) != "C"
         aFootTxt[ii] := ""
      endif
   next
endif
if VALTYPE(axHeadSep) == "C"
   aHeadSep := axHeadSep
elseif valtype(axHeadSep) == "A"                 // create aHeadSep[]
   aHeadSep := ACLONE (axHeadSep)
   ASIZE(aHeadSep,iArrLen)
   for ii := 1 to iArrLen
      if VALTYPE(aHeadSep[ii]) != "C"
         aHeadSep[ii] := NIL
      endif
   next
else
   aHeadSep := NIL
endif

if VALTYPE(axColSep) == "C"
   aColSep := axColSep
elseif valtype(axColSep) == "A"                 // create aColSep[]
   aColSep := ACLONE (axColSep)
   ASIZE(aColSep,iArrLen)
   for ii := 1 to iArrLen
      if VALTYPE(aColSep[ii]) != "C"
         aColSep[ii] := NIL
      endif
   next
else
   aColSep := NIL
endif
if VALTYPE(axFootSep) == "C"
   aFootSep := axFootSep
elseif valtype(axFootSep) == "A"                 // create aFootSep[]
   aFootSep := ACLONE (axFootSep)
   ASIZE(aFootSep,iArrLen)
   for ii := 1 to iArrLen
      if VALTYPE(aFootSep[ii]) != "C"
         aFootSep[ii] := NIL
      endif
   next
else
   aFootSep := NIL
endif
if VALTYPE(axPict) == "C" .and. !empty(axPict)   // create aPict[]
   aPict := AFILL(ARRAY(iArrLen),axPict)
elseif valtype(axPict) == "A"
   aPict := ACLONE (axPict)
   ASIZE(aPict,iArrLen)
else
   aPict := array(iArrLen)
endif
for ii := 1 to iArrLen
   if VALTYPE(aPict[ii]) != "C" .or. empty(aPict[ii])
      aPict[ii] := NIL
   endif
next

* --------------------------------------------------------------------------
* Create Tbrowse object
* --------------------------------------------------------------------------
#ifdef FSIO_GUI
oTbr := _g_TBrowDB(nTop, nLeft, nBott, nRight)    // create Tbrowse object
#endif
#ifdef FSIO_TERM
oTbr := _t_TBrowDB(nTop, nLeft, nBott, nRight)    // create Tbrowse object
#endif
#ifdef FSIO_ALL
oTbr := TBrowDB(nTop, nLeft, nBott, nRight)    
#endif

if cbForCond != NIL .or. cbWhiCond != NIL .or. nNext != NIL
   oTbr:GoTopBlock    := {|| MyGoTop (cbForCond, cbWhiCond, nNext, ;
                             nStartRec, @xFirst, @iSkip) }
   oTbr:GoBottomBlock := {|| MyGoBottom(lAppend, cbForCond, cbWhiCond, nNext,;
                             nStartRec, @xLast, xMax, @xSkip, @iSkip)}
endif

oTbr:SKIPBLOCK := {|nn| ;
    SkipDbedit(nn, lAppend, cbForCond, cbWhiCond, nNext, @iSkip)}


* --------------------------------------------------------------------------
* Add a column to the object for each field specified in the array of fields
* --------------------------------------------------------------------------
FOR ii := 1 to iArrLen
#ifdef FSIO_GUI
   oTcol := _gTBColumn{aHeadTxt[ii], block_NIL}      // create TBcolumn object
#endif
#ifdef FSIO_TERM
   oTcol := _tTBColumn{aHeadTxt[ii], block_NIL}      // create TBcolumn object
#endif   
#ifdef FSIO_ALL
   oTcol := TBColumn{aHeadTxt[ii], block_NIL}      
#endif
   dummy := aFields[ii]
   if TYPE(dummy) == "M"
      oTcol:BLOCK := {|| IF(EMPTY(&dummy),"<memo>","<MEMO>")}
   elseif TYPE(dummy) == "U"
      RTError (RTARGVAL, RTEMSG3 + dummy + RTEMSG4)
      return NIL
   elseif valtype(aPict[ii]) == "C" .and. !empty(aPict[ii])
      dummy2:= "'" + aPict[ii] + "'"                   // corrected
      oTcol:BLOCK := {|| TRANSFORM(&dummy, &dummy2) }  // corrected
   else
      oTcol:BLOCK := {|| &dummy }
   endif

   if valtype(aHeadSep) == "A"
      if valtype(aHeadSep[ii]) == "C"
         oTcol:HEADSEP := aHeadSep[ii]
      endif
   endif
   if valtype(aColSep) == "A"
      if valtype(aColSep[ii]) == "C"
         oTcol:COLSEP := aColSep[ii]
      endif
   endif
   if valtype(aFootSep) == "A"
      if valtype(aFootSep[ii]) == "C"
         oTcol:FOOTSEP := aFootSep[ii]
      endif
   endif
   if valtype(aFootTxt) == "A"
      if valtype(aFootTxt[ii]) == "C"
         oTcol:FOOTING := aFootTxt[ii]
      endif
   endif
   oTbr:addColumn(oTcol)
NEXT

if aHeadSep == NIL
   oTbr:HEADSEP := ""
elseif valtype(aHeadSep) == "C"
   oTbr:HEADSEP := aHeadSep
endif
if aColSep == NIL
   oTbr:COLSEP := "  "
elseif VALTYPE(aColSep) == "C"
   oTbr:COLSEP := aColSep
endif
if VALTYPE(aFootSep) == "C"
   oTbr:FOOTSEP := aFootSep
endif
if VALTYPE(aFootTxt) == "C"
   oTbr:FOOTING := aFootTxt
endif

if VALTYPE(cbUserUdf) == "B"
   lHasUDF := TRUE
elseif VALTYPE(cbUserUdf) == "C"
   dummy := cbUserUdf
   cbUserUdf := {|x,y,z| &dummy (x,y,z)}  // turn user UDF into a code block
   lHasUDF := TRUE
endif

saveCurs := SETCURSOR(0)                 // set cursor off

* -----------------------------------------------------
* Everthing has been initialized, run the browse object
* -----------------------------------------------------
dbcommit()                               // flush dbf buffers
IF lHasUDF
   IF EVAL(cbUserUdf, DE_START, oTbr:colPos, oTbr) == DE_ABORT
      RETURN NIL
   ENDIF
ENDIF

* find first matching FOR condition, if WHILE is not given

if cbForCond != NIL .and. cbWhiCond == NIL
   while !eof() .and. !eval(cbForCond)
     if valtype(nNext) != "U"
        if iSkip >= (nNext -1)
           exit
        endif
     endif
     skip
     iSkip++
   enddo
endif
nStartRec := recno()

* main control loop

do while TRUE
   if ( oTbr:COLPOS <= oTbr:FREEZE )     // Don't allow cursor to
      oTbr:COLPOS := oTbr:FREEZE + 1     // move into frozen columns
   endif

   if !oTbr:stable
      while (NEXTKEY() == 0) .AND. (! oTbr:STABILIZE())       // stabilize
      enddo
   endif
   
   if oTbr:STABLE .and. lHasUDF
      nRow := ROW()
      nCol := COL()
      DEVPOS(nRow,nCol)

      nn := DE_IDLE           // 0
      if oTbr:HITTOP
         nn := DE_HITTOP      // 1
      elseif oTbr:HITBOTTOM
         nn := DE_HITBOTTOM   // 2
      elseif reccount() == 0
         nn := DE_EMPTY       // 3
      endif
      xudfRet := EVAL(cbUserUdf, nn, oTbr:COLPOS, oTbr)         // call UDF
      udfRet  := if (valtype(xudfRet) == "N", xudfRet, DE_CONT) // NIL => 1
         
      * The UDF may now GO to EOF() (GOTO BOTTOM, SKIP) and return DE_APPEND
      * to signal DBEDIT() appending new record

      DO CASE
      CASE udfRet == DE_ABORT                    // 0: perform quit
         EXIT
      CASE udfRet == DE_CONT                     // 1: continue
         oTbr:REFRESHCURRENT()
      CASE udfRet == DE_REFRESH                  // 2: repaint the screen
         lAppend := .F.
*        oTbr:REFRESHCURRENT()
         DoRefreshAll (oTbr)
      CASE udfRet == DE_APPEND                   // 3: append new
         if recno() <= lastrec() .or. !lAppend
            if !lAppend
               lAppend := .T.
            else
               oTbr:REFRESHCURRENT()
               oTbr:FORCESTABLE()
               go bottom
            endif
            oTbr:DOWN()
         endif
         oTbr:FORCESTABLE()

         * The .dbf is now on EOF, the UDF is entered with the DE_IDLE
         * mode. The UDF may now APPEND BLANK if required. If so,
         * the append mode is finished. Otherwise, the editing can be
         * done on exception key, by entering the UDF with DE_EXCEPT,
         * the UDF should perform "keyboard chr(K_ENTER)"

         xudfRet := EVAL(cbUserUdf, DE_IDLE, oTbr:colPos, oTbr)
         udfRet  := if (valtype(xudfRet) == "N", xudfRet, DE_CONT) // NIL => 1
         if !eof() .and. udfRet # DE_APPEND
            lAppend := .F.
*           oTbr:REFRESHCURRENT()
            DoRefreshAll (oTbr)
         endif
      OTHERWISE
         oTbr:REFRESHCURRENT()
         ?? chr(7)
      ENDCASE

      WHILE (NEXTKEY() == 0) .AND. (! oTbr:STABILIZE())    // stabilize
      ENDDO
   endif
*  ---------------------------
*  wait for key and process it
*  ---------------------------
   nKey := INKEY(0,INKEY_KEYBOARD)
*  nKey := InkeyTrap(0,INKEY_KEYBOARD)    // alternative: Inkey() + SET KEYs

   IF ((bKeyBlck := SETKEY(nKey)) != NIL )       // SET KEY function ?
      ii := 1
      while (upper(left(procname(ii),3)) == "CB_")
          ii++
      enddo
      if empty(procname(ii))
         ii--
      endif
      EVAL(bKeyBlck, PROCNAME(ii), PROCLINE(ii), "DBEDIT_C" + ltrim(str(oTbr:ColPos)))
   ENDIF

   DO CASE
   CASE  nKey == K_UP
      if lAppend
         lAppend := .F.
*        oTbr:REFRESHCURRENT()
         doRefreshAll (oTbr)
      else
         oTbr:UP()
      endif
   CASE  nKey == K_DOWN
      if lAppend
         oTbr:HITBOTTOM := .T.
      else
         oTbr:down()
         oTbr:ForceStable()
      endif
   CASE  nKey == K_LEFT
      oTbr:left()
   CASE  nKey == K_RIGHT
      oTbr:right()
   CASE  nKey == K_PGUP
      if lAppend
         lAppend := .F.
*        oTbr:REFRESHCURRENT()
         doRefreshAll (oTbr)
      else
         oTbr:PAGEUP()
      endif
   CASE  nKey == K_PGDN
      if lAppend
         oTbr:HITBOTTOM := .T.
      else
         oTbr:pageDown()
      endif
   CASE  nKey == K_HOME
      oTbr:home()
   CASE  nKey == K_END
      oTbr:end()
   CASE  nKey == K_CTRL_LEFT // .OR. nKey == K_SH_TAB
      oTbr:panLeft()
   CASE  nKey == K_CTRL_RIGHT // .OR. nKey == K_TAB
      oTbr:panRight()
   CASE  nKey == K_SH_TAB .and. !lHasUDF
      oTbr:ScrollLeft()
   CASE  nKey == K_TAB .and. !lHasUDF
      oTbr:ScrollRight()
   CASE  nKey == K_CTRL_HOME
      oTbr:panHome()
   CASE  nKey == K_CTRL_END
      oTbr:panEnd()
   CASE  nKey == K_CTRL_PGUP
      if lAppend
         lAppend := .F.
*        oTbr:REFRESHCURRENT()
         doRefreshAll (oTbr)
      else
         oTbr:GOTOP()
      endif
   CASE  nKey == K_CTRL_PGDN
      if lAppend
         lAppend := .F.
*        oTbr:REFRESHCURRENT()
         doRefreshAll (oTbr)
      else
         oTbr:GOBOTTOM()
      endif
   OTHERWISE
      IF lHasUDF
         oTbr:FORCESTABLE()

         * The UDF is now entered with the DE_EXCEPT mode. It has itself to
         * perform the edititing and APPEND BLANK + REPLACE -> DE_REFRESH
         * otherwise return DE_CONTINUE to remain in append mode

         xudfRet := EVAL(cbUserUdf,DE_EXCEPT,oTbr:colPos,oTbr)
         udfRet  := if (valtype(xudfRet) == "N", xudfRet, DE_CONT) // NIL => 1
         DO CASE
         CASE udfRet == DE_ABORT                    // 0: perform quit
            EXIT
         CASE udfRet == DE_REFRESH                  // 2: repaint the screen
            if lAppend .or. eof()
               lAppend := .F.
*             go bottom            
              oTbr:GoBottom()      
            endif
*           oTbr:REFRESHCURRENT()
            doRefreshAll (oTbr)
         OTHERWISE                                  // 1 or 3
            oTbr:REFRESHCURRENT()
         ENDCASE
      ELSE
         IF nKey == K_ENTER .OR. nKey == K_ESC
            EXIT
         ENDIF
      ENDIF
   ENDCASE
ENDDO

SETCURSOR(saveCurs)
SETPOS   (saveRow, saveCol)                      // restore cursor
RETURN NIL

******************************************
STATIC FUNCTION SkipDbedit(nMode, lAppend, ;
                cbForCond, cbWhiCond, nNext, iSkip) AS Intvar
******************************************      // called from skip block
LOCAL lFound := .T.                                  AS Logical
LOCAL nCount := 0, xSkip := iSkip, nLast  := recno() AS Intvar
Local isFor := valtype(cbForCond) == "B"             AS Logical
Local isWhi := valtype(cbWhiCond) == "B"             AS Logical
Local isNext:= valtype(nNext) != "U"                 AS Logical

if LASTREC() == 0
   RETURN 0
endif

DO CASE
CASE nMode == 0
   skip 0
CASE nMode < 0
   WHILE nCount > nMode
      if isNext .and. iSkip <= 0                 // consider NEXT
         exit
      endif
      SKIP -1
      if isWhi .and. !eval(cbWhiCond)            // consider WHILE
         exit
      endif
      if isFor                                   // consider FOR
         lFound := eval(cbForCond)
      endif
      if lFound
         nLast := recno()
      endif
      if BOF()
         exit
      endif
      iSkip--
      if lFound
         nCount--
         xskip := iskip
      endif
   ENDDO
   goto nLast
   iSkip := xSkip

CASE recno() <=  lastrec()
   while nCount < nMode
      if isNext .and. iSkip >= (nNext -1)        // consider NEXT
         exit
      endif
      SKIP 1
      if eof()
         if lAppend
            nCount++
            nLast := recno()
         else
            goto nLast
         endif
         exit
      endif
      if isWhi .and. !eval(cbWhiCond)            // consider WHILE
         goto nLast
         exit
      endif
      if isFor                                   // consider FOR
         lFound := eval(cbForCond)
      endif
      nLast := if (lFound, recno(), nLast)
      iSkip++
      if lFound
         nCount++
         xskip := iSkip
      endif
   enddo
   goto nLast
   iSkip := xSkip
ENDCASE
return (nCount)

******************************************
STATIC FUNCTION MyGoBottom(lAppend, cbForCond, cbWhiCond, nNext, ;
                           nStart, xLast, xMax, xSkip, iSkip)      AS Logical
LOCAL lFound := .T.                          AS Logical
LOCAL nLast := recno()                       AS Intvar
Local isFor := valtype(cbForCond) == "B", ;
      isWhi := valtype(cbWhiCond) == "B", ;
      isNext:= valtype(nNext) != "U"         AS Logical
LOCAL xxSkip := (iSkip)                      AS Intvar

if lastrec() = 0
   return .F.
elseif xlast > 0 .and. xMax == lastrec() .and. ;
   (isdbexcl() .or. indexord() == 0) .and. !lAppend
   goto xLast                                    // optimize:
   iSkip := xSkip                                // already found
elseif isNext
   while !eof() .and. iSkip < (nNext -1)         // NEXT given
      skip
      if isWhi .and. !eval(cbWhiCond)            // consider WHILE
         goto nLast
         exit
      endif
      if isFor                                   // consider FOR
         lFound := eval(cbForCond)
      endif
      iskip++
      if lFound
         nLast := recno()
         xxSkip := iSkip
      endif
   enddo
   goto nLast
   iSkip := xxSkip
   xSkip := iskip
elseif isWhi                                     // WHILE given
   while !eof() .and. eval(cbWhiCond)
      skip
      if isFor                                   // consider FOR
         lFound := eval(cbForCond)
      endif
      iskip++
      if lFound
         nLast := recno()
      endif
   enddo
   goto nLast
elseif isFor                                     // FOR given
   goto bottom
   while !bof() .and. !eval(cbForCond)
      skip -1
   enddo
else
   goto bottom
   xLast := recno()
   if lAppend
      skip
   endif
endif
if !lAppend
   xLast := recno()
endif
return .T.

******************************************
STATIC FUNCTION MyGoTop(cbForCond, cbWhiCond, ;
                        nNext, nStart, xFirst, iSkip)  AS Logical
LOCAL lFound := .T.                         AS Logical
LOCAL nLast := (nStart)                     AS Intvar
LOCAL isFor := valtype(cbForCond) == "B", ;
      isWhi := valtype(cbWhiCond) == "B", ;
      isNext:= valtype(nNext) != "U"        AS Logical

if lastrec() = 0
   return .F.
elseif xFirst > 0 .and. (isdbexcl() .or. indexord() == 0)  // optimize:
   goto xFirst                                             // already found
   iskip := 0
elseif isNext
   goto nStart
   iSkip := 0
elseif isWhi
   goto nStart
   while !bof() .and. eval(cbWhiCond)
      skip -1
      if isFor                                   // consider FOR
         lFound := eval(cbForCond)
      endif
      nLast := if (lFound, recno(), nLast)
   enddo
   goto nLast
elseif isFor
   goto top
   while !eof()
      if eval(cbForCond)
         exit
      endif
      skip
   enddo
else
   goto top
endif
xFirst := recno()

return .T.

***********************************
static FUNCTION doRefreshAll (oTbr)              // refresh all & index
***********************************
LOCAL oldrec := recno() AS Intvar

* oTbr:REFRESHCURRENT()
oTbr:REFRESHALL()
oTbr:FORCESTABLE()

if oldrec > lastrec()
   return NIL
endif

if recno() != oldrec 
   /* record# changed
    */
   if set(_SET_DELETED) 
      return NIL     // ok, record was deleted
   endif
   /* Note: you may disable the following 3 lines
    * if you wish to try to find the old record
    */ 
   if !empty(DbFilter()) 
      return NIL     // ok, filter is active  
   endif
endif

/* record# changed. Try to find the old record
 * by shipping backwards. This is only for convenience.
 * Note: You may disable the while..enddo section for higher performance
 */
while recno() != oldrec .and. !oTbr:HITTOP
   oTbr:UP()
   oTbr:FORCESTABLE()
enddo

return NIL

*******************************************
static FUNCTION defaultval (var, type, defval)      // set defaultval values
*******************************************
if valtype(type) == "C"
   return if (valtype(var) == upper(type), var, defval)
endif
return if (var == NIL, defval, var)

*************************************               // call error handler
static FUNCTION RTError (errVal AS Intvar, str AS String) AS Usual
*************************************
LOCAL errBlock AS CodeBlock
LOCAL oErr     AS Error

#ifndef ES_RTERR
#define ES_RTERR 2
#endif

#ifdef ALERNATIVE_ERROR
   if alert ("DBEDIT() " + str + ";in " + ;
             procname(2) + "/" + ltrim(str(procline(2))), ;
             {"Quit","Continue"}) == 1
      quit
   endif
#else
   errBlock := ErrorBlock()                  // default error handler block
   oErr     := ErrorNew()                    // new error object

   oErr:ARGS          := NIL
   oErr:CANDEFAULT    := .F.
   oErr:CANRETRY      := .F.
   oErr:CANSUBSTITUTE := .F.
   oErr:CARGO         := NIL
   oErr:DESCRIPTION   := "DBEDIT() " + str
   oErr:FILENAME      := PROCNAME(2) + "(" + LTRIM(STR(PROCLINE(2),5)) + ")"
   oErr:GENCODE       := errVal
   oErr:OPERATION     := ""
   oErr:OSCODE        := DOSERROR()
   oErr:SEVERITY      := ES_RTERR
   oErr:SUBCODE       := 0
   oErr:SUBSYSTEM     := "BASE"

   EVAL (errBlock, oErr)
#endif
return NIL

*************************************
#ifndef FlagShip
// static function isdbexcl()
// return .T.
#endif

#endif  /* not for -io=b, i.e. FSIO_BASIC */
*** EOF *** DBEDIT.PRG
