#ifdef COMMENT_ONLY
* For FlagShip 6 and 7
* Copyright (c) 2008 by multisoft, Munich, Germany
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the
* modified source code when your application is distributed in source,
* but may not remove the copyright notice.
*
* Release $Date: 2008/02/03 11:04:18 $
*
* FoxPro BROWSE interface for FlagShip 6 and 7, available in the FS library.
* Triggered from command BROWSE ... with -fox compiler switch 
*
* If you wish to modify this file,
*   Compile without (!) the -fox switch: FlagShip -c -na -m foxpro_browse.prg
*   Link on Linux/Unix: FlagShip myapp*.prg -fox foxpro_browse.o
*   Link in MS-Windows: FlagShip myapp*.prg -fox foxpro_browse.obj
#endif

static _fox_a_ronly := {}, _fox_a_edit := {}, ;
       _fox_a_pict  := {}, _fox_a_verif := {}, ;
       _fox_a_range := {}, _fox_a_head := {}, _fox_a_width := {} as array
static _fox_l_append := .T. as logic
static _fox_l_edit   := .T. as logic

PROTO STATIC FUNCTION fox_decodFields(aFields)

#include "dbedit.fh"

/* --------------------------------------------------------------------------
 * fox_Browse() -> NIL
 *    command BROWSE, triggers Browse() or DbEdit() function
 */
FUNCTION fox_Browse(capt, cbWin, acFields, fontName, fontSize,  ;
                    bFor, idxkey1, idxkey2, lNoGotop, lReadonly,  ;
                    lNogrid, lNowait, lNoAdd, nTimeOut)

   local lFields := .F., cFilter := NIL, ok := .F., aFields := {}

   if !used()
      alert("BROWSE -> fox_Browse();no database open in current WA#" + ltrim(select()) )
      return .F.                
   endif
   if pcount() == 0
      return Browse()               // no clauses/params: simple Browse()
   endif
   
   _aGlobSetting[GSET_A_TBROWSE_DISPLMSG] := {.T.,.T.}   // display {messages,deleted} in Tbrowse,DbEdit() 
   
   _fox_l_append := .T.
   _fox_l_edit   := .T.
   _fox_a_ronly  := {}
   _fox_a_edit   := {}
   _fox_a_pict   := {}
   _fox_a_verif  := {}
   _fox_a_range  := {} 
   _fox_a_head   := {} 
   _fox_a_width  := {} 
   _fox_a_ronly  := {}
   _fox_a_pict   := {}
   _fox_a_verif  := {}
     
   if valtype(cbWin) == "B"         // BROWSE clause IN [WINDOW] <win>
      eval(cbWin)                   
      if valtype(capt) == "C"       // BROWSE clause TITLE <capt>
         // unsupported yet
      endif
      if valtype(fontName) == "C"   // BROWSE clause FONT <fontName> 
         // unsupported yet
      endif
      if valtype(fontSize) == "N"   // BROWSE clause FONT <fontName>,<fontSize>
         // unsupported yet
      endif
   endif
   if valtype(acFields) $ "AC" .and. !empty(acFields)  // BROWSE clause FIELDS ... 
      aFields := fox_decodFields(acFields)
      if !empty(aFields) .and. len(aFields) > 0
         lFields := .T.
      endif
   endif
   if !(valtype(lNoGotop) == "L" .and. lNoGotop)      // BROWSE clause REST 
      GO TOP                                          // is not given
   endif
   if idxkey1 != NIL                // BROWSE clause KEY <idxkey1> [,<idxkey2>] 
      if indexord() < 1
         alert("BROWSE..KEY.. -> fox_Browse();no index open in alias " + alias() + ;
               ";KEY clause ignored")
      else  
         cFilter := DbFilter()      // save current SET FILTER, if any
         if idxkey2 != NIL
            if valtype(bFor) == "B"
               SET FILTER TO (&(indexkey()) >= idxkey1 .and. &(indexkey()) <= idxkey2) .and. eval(bFor)
            else           
               SET FILTER TO (&(indexkey()) >= idxkey1 .and. &(indexkey()) <= idxkey2)
            endif
         else
            if valtype(bFor) == "B"
               SET FILTER TO (&(indexkey()) >= idxkey1) .and. eval(bFor) 
            else
               SET FILTER TO (&(indexkey()) >= idxkey1)
            endif 
         endif
         SEEK (idxkey1)             // seek given key
         if !found()
            GO TOP                  // or use filter
         endif
      endif
   elseif valtype(bFor) == "B"      // BROWSE clause FOR
      cFilter := DbFilter()         // save current SET FILTER, if any
      SET FILTER TO eval(bFor) 
      GO TOP
   endif
   if valtype(lReadonly) == "L" .and. lReadonly // BROWSE clause NOEDIT,NOMODIFY 
      lReadonly   := .T.            
      _fox_l_edit := .F.
   else   
      lReadonly   := .F.            
      _fox_l_edit := .T.
   endif    
   if valtype(lNoAdd) == "L" .and. lNoAdd       // BROWSE clause NOAPPEND
      _fox_l_append := .F.
   endif
   
   /* execute DbEdit()
    */
   ok := DbEdit(1,0,NIL,NIL, if(lFields, aFields, NIL), NIL,  ;
                _fox_a_pict, _fox_a_head, NIL, NIL, NIL, NIL, ;
                NIL, NIL, NIL, NIL, ;
                _fox_a_edit , ;        // editable fields = not read-only
                .T., ;                 // may append records
                .T. )                  // may delete/undelete records
   
   if cFilter != NIL 
      if !empty(cFilter)
         SET FILTER TO (cFilter)    // restore SET FILTER
      else
         SET FILTER TO
      endif
   endif
   return ok         

/*---------------------------------------------------------------------------
 * helper for fox_Browse()
 */
STATIC FUNCTION fox_decodFields(acFields)
   local aSplit := {}
   local aFields := {}
   local cFld, cToken, cTmp, cTmp1, cTmp2, iVal, ii, iPos, iNext, cc, lForce
   local iSplit, iElem := 0

   if valtype(acFields) == "A"
      aSplit := aclone(acFields)
   elseif valtype(acFields) == "C"
      while !empty(cFields)               // split by comma to array
         cFields := alltrim(cFields)
         iPos := at(",", cFields)
         if iPos > 0
            aadd(aSplit, trim(left(cFields, iPos -1)))
            cFields := ltrim(substr(cFields, iPos +1))
         else
            aadd(aSplit, cFields)
            cFields := ""
         endif
      enddo
      if len(aSplit) == 0
         return aFields
      endif
   else
      return aFields
   endif
   
   iElem  := 0                         // size of field array
   iSplit := 1                         // element in aSplit array
   while iSplit <= len(aSplit)         // for all fields
      if empty(aSplit[iSplit])
         iSplit++
         loop
      endif    
      iElem++                          // next field element   
      aSize(aFields, iElem)
      cFld := alltrim(aSplit[iSplit])  // one field descriptions
      iPos := at(":", cFld)            // field marks available?
      if iPos = 0
         aFields[iElem] := strtran(alltrim(cFld), ".", "->") 
      else
         aFields[iElem] := strtran(alltrim(left(cFld, iPos -1)), ".", "->")  // field
         cFld := alltrim(substr(cFld, iPos +1)) // remove '<field> :'
         
         while !empty(cFld)            // for one field description
            cc := upper(left(cFld,1))  
            do case
            case cc >= "0" .and. cc <= "9" // field width ":1..9"
               iVal := val(cFld)
               if iVal > 0
                  aSize(_fox_a_width, iElem)
                  _fox_a_width[iElem] := iVal
               endif
               
            case cc == "R"                // read-only field ":R"
               aSize(_fox_a_ronly, iElem)
               _fox_a_ronly[iElem] := .T.
               
            case cc == "V"                // verify range ":V = <verif> [:F] [E: = <error>]
               iPos := at("=", cFld) 
               if iPos > 0
                  lForce := .F.
                  cFld := ltrim(substr(cFld,iPos +1)) 
                  iPos := at(":F", upper(cFld)) 
                  if iPos > 0 
                     lForce := .T.
                     cFld := left(cFld,iPos -1) + substr(cFld,iPos +2)
                  endif   
                  iPos := at(":E", upper(cFld)) // ignore
                  if iPos > 0 
                     iNext := at(":", cFld, iPos +1)  
                     cFld  := left(cFld,iPos -1) + ;
                                  if(iNext == 0, "", substr(cFld,iNext))
                  endif
                  iNext := at(":", cFld) 
                  cToken := if(iNext == 0, cFld, left(cFld, iNext -1))
                  if !empty(cToken)
                     aSize(_fox_a_verif, iElem)
                     _fox_a_verif[iElem] := alltrim(cToken)
                  endif   
               endif
               
            case cc == "P"                // field picture ":P = <pict>"
               iPos := at("=", cFld) 
               if iPos > 0
                  cFld  := ltrim(substr(cFld, iPos +1)) 
                  iNext := at(":", cFld)
                  cToken := if(iNext == 0, cFld, left(cFld, iNext -1))
                  if !empty(cToken)
                     aSize(_fox_a_pict, iElem)
                     _fox_a_pict[iElem] := alltrim(cToken)
                  endif
               endif
                  
            case cc == "B"                // bounds ":B = <bound1>,<bound2> [:F]"
               iPos := at("=", cFld) 
               if iPos > 0
                  cFld := ltrim(substr(cFld,iPos +1)) 
                  iPos := at(",", cFld) 
                  if iPos == 0 .and. iSplit < len(aSplit)   // was splitted, add next
                     iSplit++
                     cFld += "," + alltrim(aSplit[iSplit])
                  endif
                  lForce := .F.
                  iPos   := at(":F", cFld) 
                  if iPos > 0 
                     lForce := .T.
                     cFld := left(cFld, iPos -1) + ;
                                 substr(cFld, iPos +2)      // remove :F
                  endif   
                  iPos := at(",", cFld) 
                  if iPos > 0
                     cTmp1 := alltrim(left(cFld, iPos -1))
                     cToken := substr(cFld, iPos +1)
                     iNext := at(":", cFld)
                     cTmp2 := alltrim(if(iNext == 0, cToken, left(cFld, iNext -1)))
                     if len(cTmp1) > 0 .and. len(cTmp2) > 0
                        aSize(_fox_a_range, iElem)
                        _fox_a_range[iElem] := {cTmp1, cTmp2, lForce}
                     elseif lForce
                        aSize(_fox_a_range, iElem)
                        _fox_a_range[iElem] := {NIL, NIL, lForce}
                     endif
                  endif
               endif
            
            case cc == "H"                // header ":H = <cHeader>"
               iPos := at("=", cFld) 
               if iPos > 0
                  cFld := ltrim(substr(cFld,iPos +1)) 
                  iNext := at(":", cFld)
                  cToken := if(iNext == 0, cFld, left(cFld,iNext -1))
                  if !empty(cToken)
                     cTmp := alltrim(cToken)
                     if left(cTmp,1) $ ('"' + "'")
                        cTmp := strtran(cTmp, left(cTmp,1), "")
                     elseif left(cTmp,1) == "["
                        cTmp := substr(cTmp, 2, len(cTmp) -2)
                     endif
                     aSize(_fox_a_head, iElem)
                     _fox_a_head[iElem] := cTmp
                  endif
               endif
            
            case cc == "W"                // cursor movement (ignored)

            endcase
            iPos  := at(":", cFld)        // next mark in field description
            if iPos > 0                    
               cFld := alltrim(substr(cFld, iPos +1)) // remove "... :"
            else
               cFld := ""
            endif
         enddo    // for one field description
      endif
      iSplit++
   enddo          // for all fields  
   
   /* header names in lower case w/o alias
    */
   if len(aFields) > 0
      if len(_fox_a_head) != len(aFields)
         asize(_fox_a_head, len(aFields)) 
      endif
      if len(_fox_a_ronly) != len(aFields)
         asize(_fox_a_ronly, len(aFields)) 
      endif
      if len(_fox_a_edit) != len(aFields)
         asize(_fox_a_edit, len(aFields)) 
      endif
      
      for ii := 1 to len(aFields)
         if valtype(_fox_a_head[ii]) != "C"
            cFld := aFields[ii]
            iPos := at("->", cFld)
            if iPos > 0
               cFld := substr(cFld, iPos +2)
            endif
            cFld := upper(left(cFld,1)) + lower(substr(cFld,2))
            _fox_a_head[ii] := cFld
         endif  
         if valtype(_fox_a_ronly[ii]) != "L"
            _fox_a_ronly[ii] := .F.
         endif      
         _fox_a_edit := !_fox_a_ronly[ii]
      next 
   endif
   return aFields               

* eof *
