#ifdef COMMENT_ONLY
/* For FlagShip 4..6. Copyright (c) 2000..05 by multisoft GmbH, Munich, Germany
 * You may modify this source according to your needs and distribute the
 * object code freely with your executable. You may distribute also the 
 * modified source code when your application is distributed in source, 
 * but may not remove the copyright notice.
 * 
 * Release $Date: 2005/09/27 15:55:21 $
 */
#endif

/****************************************************************************
 * RDDSYS.PRG init procedure to invoke standard FlagShip RDD                *
 *            called automatically at program start                         *
 *                                                                          *
 * Compile :  FlagShip rddsys.prg -m -na -c                                 *
 * Link    :  FlagShip myappl*.prg rddsys.o                                 *
 *--------------------------------------------------------------------------*
 * Copyright (C) 1995..2005 multisoft Datentechnik GmbH                     *
 ****************************************************************************/

PROTO FUNC AnnNewRDD (cName AS String) AS Usual

STATIC aRddList := {} AS Array

ANNOUNCE RDDSYS

// announce the default DbfIdx RDD driver
//
INIT PROCEDURE RddInit
   REQUEST DBFIDXNEW              // force to link default driver
   AnnNewRdd ("DbfIdx")           // announce it for RddList()
   RddSetDefault ("DBFIDX")       // set default RDD driver
RETURN

// all user defined <myrdd> drivers (see e.g. smallrdd.prg) should include:
//
** INIT procedure _<myrdd>
**    REQUEST <myrdd>NEW
**    AnnNewRdd ("<myrdd>")
** RETURN

// this function is called from the INIT procedure of any RDD
//
FUNCTION AnnNewRDD (cName AS String) AS Usual
   LOCAL found := .F. AS Logical
   cName := left(upper(cName), 10)
   if len(aRddList) > 0
      found := ascan(aRddList, cName) > 0 
   endif
   if !found .and. !empty(cName)
      aadd (aRddList, cName)
   endif
RETURN NIL

// standard FlagShip function RddList()
//
FUNCTION RddList () AS Arra
RETURN aRddList

* EOF *
