#ifdef COMMENT_ONLY
* For FlagShip 6 
* Copyright (c) 2005..07 by multisoft GmbH, Munich, Germany 
*
* You may modify this source according to your needs and distribute the
* object code freely with your executable. You may distribute also the 
* modified source code when your application is distributed in source, 
* but may not remove the copyright notice.
* 
* Release $Date: 2007/03/20 15:01:23 $
*
#endif

/****************************************************************************
 * SCOR_MEM.PRG enables access to the scoreboard messages in memoedit       
 *                                                                          
 * Compile     : FlagShip scor_mem.prg -m -na  
 * Link Linux  : FlagShip myapp*.prg scor_mem.o
 * Link Windows: FlagShip myapp*.prg scor_mem.obj            
 ****************************************************************************/

#include "set.fh"
/* DEFINE MMSG_GERMAN */

// Scoreboard messages
// FlagShip: user defined messages taken from FSsortab.xxx,
//           if FS_SET("loadlang") and FS_SET("setlang") called.

// display coordinates for SCOREBOARD and Message for Escape

#define SCORE_ROW    0
#define SCORE_COL    60

#ifndef MMGS_GERMAN
#   define SCORE_ABORT  "Abort Edit (Y/N)?"
#else
#   define SCORE_ABORT  "Abbrechen  (J/N)?"
#endif
#define SCORE_ACLEAR "                 "

/*--------------------------------------------------------------------------*
 | Function MemoScoreEsc()      Serves to decide if ESC shall quit Memoedit |
 |                              Called after Escape is presses on a changed |
 |                              Text                                        |
 | In : -                                                                   |
 | Out: fn (L)  .T. : Memoedit will quit                                    |
 |              .F. : Memoedit will continue editing                        |
 *--------------------------------------------------------------------------*/
FUNC MemoScoreEsc ( ) AS Logi

local nRow, nCol, key   AS Intvar
local Answer := .T. AS Logical

   if ( Set(_SET_SCOREBOARD) )                        // SET SCOREBOARD ON ?
      nRow := Row()                                   // save actuall cursor
      nCol := Col()
      SetPos(SCORE_ROW, SCORE_COL)                    // see define
      DispOut(SCORE_ABORT)
      key  := inkey(0)
#ifndef MMGS_GERMAN
         Answer := chr(key) $ "Yy"
#else
         Answer := chr(key) $ "JjYy"                  // Clipper would expect Y
#endif
      SetPos(SCORE_ROW, SCORE_COL)                    // overwrite with
      DispOut(SCORE_ACLEAR)                           // Blanks
      SetPos(nRow, nCol)                              // restore cursor
   end
return Answer


/*--------------------------------------------------------------------------*
 | Function MemoScoreIns()      Serves to display Insert State in Memoedit  |
 |                              Called after Insert is presses              |
 | In p1(L):  Insertstate  The state of Insert mode                         |
 *--------------------------------------------------------------------------*/
FUNC memoScoreIns( @InsertState   AS Logi   ) AS Usua

local nRow, nCol             AS Intvar
local cMsg:= _LANGNAMES (1)  AS String                // see also GetSys.prg

   if ( Set(_SET_SCOREBOARD) )                        // SET SCOREBOARD ON ?
      nRow := Row()                                   // save actuall cursor
      nCol := Col()
      SetPos(SCORE_ROW, SCORE_COL)                    // see define
      DispOut( if(InsertState, cMsg, SPACE(LEN(cMsg)) ))
      SetPos(nRow, nCol)                              // restore cursor
   end
return

/*** eof ***/

