* Benchmark Clipper 5.x vs. FlagShip 4.x, 5.x or 6.x
*
* Compile: FlagShip bench.prg -obench ; ./bench
*      or: Clipper  bench.prg ; Blinker fi bench ; bench
*
* Release $Date: 2005/10/05 12:28:03 $

// Enable (uncomment) the following #define line if you want to display the
// overall time, i.e. the user+system and user+system+wait times. In this
// case, you will need the terminal set to approx. 85 columns. The time
// difference is notable when your data are accessed remotely, e.g. via NFS
*  #define DISPLAY_FULL
*  SET DEFAULT TO /my/mount/point

PARAMETERS cmd1                          // bench <filename>

#define WITH_DATABASES

#ifdef FlagShip
   FS_SET("lower", .T.)                  // convert file names to lowercase
*  FS_SET("pathlower", .T.)              // convert path names to lowercase
   FS_SET("translext", "ntx", "idx")     // search .idx instead of .NTX
#else
#  define LOCAL_LONG   LOCAL
#  define LOCAL_DOUBLE LOCAL
#  define STATIC_LONG  STATIC
#endif
#ifdef FlagShip5
   set font to "courier",10
#endif

private RECORDS := 10000
private RECORD2 := 1000
#define LOOPSIZE 1000000
#define LOOPSHOW "1,000,000"

#ifndef FlagShip
FlagShip := .F.
#endif

private EXCL   := .T.
private SHARE  := .F.

private txtBuff := {}
private dbf_fs5    := { 0.02,   1.37,  0.66,  2.87,  0.10, ;
                        0.11,   0.20,  0.19,  0.39,  0.45, ;
                       10.63,   0.32,  0.34,  0.35 }
private dbf_c53    := { 0.05,   0.39,  0.88,  0.65,  0.22, ;
                        0.16,   0.06,  0.05,  0.22,  0.55, ;
                      107.99,   0.55,  0.62,  0.43 }
private dbf_c53nov := {  0.05,  1.05, 53.50, 31.76,  8.34, ;
                         9.23,  3.47,  3.36, 16.42, 22.07, ;
                       120.31,  2.08,  5.47,  6.48 }

private lng_c53  := {1.59, 1.93, 1.97, 1.87, 1.92, ;
                     2.75, 2.75, 2.58, 2.58, 2.59, 2.59 }
private lng_gui  := {1.08, 2.69, 2.09, 3.50, 2.48, ;
                     3.64, 3.18, 3.59, 3.18, 3.60, 3.18 }
private lng_term := {0.12, 0.78, 0.20, 0.80, 0.19, ;
                     0.70, 0.29, 0.65, 0.27, 0.69, 0.31 }

col1 := IF (ISCOLOR(), "W+/B,N/W", "W/N,/W")
col2 := IF (ISCOLOR(), "GR+/B", "W+/N")      // terminal color
col3 := "B+/W"                               // gui color
dbfname = "benchmark"
index1  = "bench1"
index2  = "bench2"

print = .F.
if PCOUNT() > 0
   if !empty(cmd1)
      print := .T.
      ?
      ? "Printer output to file " + cmd1
      text = ""
      accept "Additional text:" to text
      SET PRINTER TO (cmd1)
      while !empty(text)
         SET CONSOLE OFF
         SET PRINTER ON
         ? text
         SET PRINTER OFF
         SET CONSOLE ON
         text = ""
         accept "Additional text:" to text
      enddo
      SET CONSOLE OFF
   endif
endif

SET COLOR TO &col1
clear screen

#ifdef WITH_DATABASES
center (1, VERSION() + " Benchmark", col2, col3)
line = 3
set console off

dbf_crea  (line++, " 1.Create database")
my_use (dbfname, EXCL)
dbf_app1  (line++, " 2.Append     " + xltrim(RECORDS) + " records, exclusive", RECORDS)
* dbf_zap   (line++)
ZAP
my_use (dbfname, SHARE)
dbf_app1  (line++, " 3.Append     " + xltrim(RECORDS) + " records, shared", RECORDS)
dbf_repl  (line++, " 4.Replace 2x " + xltrim(RECORDS) + " records, shared", 0, RECORDS)

* my_use (dbfname, EXCL)
dbf_ind1  (line++, " 5.Index      " + xltrim(RECORDS) + " records on character")
dbf_ind2  (line++, " 6.Index      " + xltrim(RECORDS) + " records on number")

my_use (dbfname, SHARE)
SET INDEX TO (index1), (index2)
dbf_seek1 (line++, " 7.Seek       " + xltrim(RECORD2) + "x shared on character")
SET ORDER TO 2
dbf_seek2 (line++, " 8.Seek       " + xltrim(RECORD2) + "x shared on numeric")

dbf_repl  (line++, " 9.Replace 2x " + xltrim(RECORD2) + "x records, shared w. 2 indices", 0, RECORD2)
dbf_repl  (line++, "10.Replace 2x " + xltrim(RECORD2) + "x records, shared w. 2 indices + COMMIT", 1, RECORD2)
dbf_repl  (line++, "11.Replace 2x " + xltrim(RECORD2) + "x records, shared w. 2 indices ea. COMMIT", 2, RECORD2)
dbf_app1  (line++, "12.Append     " + xltrim(RECORD2) + "x records, shared w. 2 indices", RECORD2)
dbf_app3  (line++, "13.Append     " + xltrim(RECORD2) + "x records, shared w. 2 indices + COMMIT", RECORD2)

my_use (dbfname, EXCL)
SET INDEX TO (index1), (index2)
dbf_pack  (line++, "14.Pack       " + xltrim(reccount()) + " records, shared w. 2 indices")
use
set console on
?
wait
?
? "Guideline values for identical HW (P3/700)"
? "Clipper 5.3 on DOS/Win-NT vs. FlagShip 5.0             Clipper    FS  = faster"
?
for ii := 1 to len(txtbuff)
   ? substr ((txtBuff[ii] + " " + repli(".", 52)), 1, 53) + ;
     str(dbf_c53[ii],6,2) + " vs." + str(dbf_fs5[ii],6,2) + " = "
#ifdef FlagShip5
   ?? str(dbf_c53[ii] / dbf_fs5[ii], 5,1) color "GB+/B" guicolor "R+"
#else
   xcolor := setcolor("GB+/B")
   ?? str(dbf_c53[ii] / dbf_fs5[ii], 5,1)
   setcolor(xcolor)
#endif
   ?? " x"
next
?
wait
?
? "Guideline values for identical HW (P3/700)"
? "Clipper 5.3 on DOS/Novell vs. FlagShip on Unix server  Clipper    FS  = faster"
?
for ii := 1 to len(txtbuff)
   ? substr ((txtBuff[ii] + " " + repli(".", 52)), 1, 53) + ;
     str(dbf_c53nov[ii],6,2) + " vs." + str(dbf_fs5[ii],6,2) + " = "
#ifdef FlagShip5
   ?? str(dbf_c53nov[ii] / dbf_fs5[ii], 5,1) color "GB+/B" guicolor "r+"
#else
   xcolor := setcolor("GB+/B")
   ?? str(dbf_c53nov[ii] / dbf_fs5[ii], 5,1)
   setcolor(xcolor)
#endif
   ?? " x"
next
?
wait

txtBuff := {}
cls
#endif

center (1, VERSION() + " Benchmark", col2, col3)
line = 3
set console off

test1 (line++, " 1.Empty loop     " + LOOPSHOW + " x",             0)
test1 (line++, " 2.Addition       " + LOOPSHOW + " x integer"  ,   10)
test1 (line++, " 3.Addition       " + LOOPSHOW + " x typed int",   11)
test1 (line++, " 4.Increment      " + LOOPSHOW + " x integer",     20)
test1 (line++, " 5.Increment      " + LOOPSHOW + " x typed int",   21)
test1 (line++, " 6.Multiplication " + LOOPSHOW + " x integer"  ,   30)
test1 (line++, " 7.Multiplication " + LOOPSHOW + " x typed int",   31)
test1 (line++, " 8.Multiplication " + LOOPSHOW + " x float",       32)
test1 (line++, " 9.Multiplication " + LOOPSHOW + " x typed float", 33)
test1 (line++, "10.Division       " + LOOPSHOW + " x float",       40)
test1 (line++, "11.Division       " + LOOPSHOW + " x typed float", 41)

line++
if print
   set printer on
   ?
   set printer off
endif

set console on
?
wait
?
? "Guideline values for identical HW (P3/700)"
? "Clipper 5.3 on DOS/Win-NT vs. FlagShip 5.0      Clipper   FS-GUI FS-Term faster"
?
for ii := 1 to len(txtbuff)
   ? substr ((txtBuff[ii] + " " + repli(".", 52)), 1, 47) + ;
     str(lng_c53[ii],6,2) + " vs." + str(lng_gui[ii],6,2) + str(lng_term[ii],6,2) + " = "
#ifdef FlagShip5
   ?? str(lng_c53[ii] / lng_term[ii], 5,1) color "GB+/B" guicolor "r+"
#else
   xcolor := setcolor("GB+/B")
   ?? str(lng_c53[ii] / lng_term[ii], 5,1)
   setcolor(xcolor)
#endif
   ?? " x"
next
?
wait

set printer to
quit

***************************************************************************
FUNCTION my_use (dbfname, exclus)
IF exclus
   USE (dbfname) EXCLUSIVE
ELSE
   USE (dbfname) SHARED
ENDIF
DO WHILE NETERR()
   @ 0,0 say "waiting for USE " + dbfname + ".dbf, " + ;
         IF (exclus, "EXCLUSIVE", "SHARED")
   inkey(2)
   if lastkey() = 27
      QUIT
   endif
   IF exclus
      USE (dbfname) EXCLUSIVE
   ELSE
      USE (dbfname) SHARED
   ENDIF
   @ 0,0
ENDDO
RETURN NIL

***************************************************************************
FUNCTION test1 (line, text, chk)
STATIC loop_time, string
LOCAL  act_time, temp
LOCAL_LONG   ii
LOCAL_LONG   sumLong  := 1
LOCAL_DOUBLE sumFloat := 1.0
LOCAL sumIntVar       := 1
LOCAL sumNumVar       := 1.0

output (line, text)
act_time = xSeconds()

DO CASE
CASE chk = 0
   FOR ii := 1 TO LOOPSIZE
   NEXT
CASE chk = 10
   FOR ii := 1 TO LOOPSIZE
      sumIntVar := sumIntVar + 1
   NEXT
CASE chk = 11
   FOR ii := 1 TO LOOPSIZE
      sumLong := sumLong + 1
   NEXT
CASE chk = 20
   sumIntVar = 1
   FOR ii := 1 TO LOOPSIZE
      sumIntVar++
   NEXT
CASE chk = 21
   sumLong = 1
   FOR ii := 1 TO LOOPSIZE
      sumLong++
   NEXT
CASE chk = 30
   FOR ii := 1 TO LOOPSIZE
      sumIntVar := 1
      sumIntVar *= 2
   NEXT
CASE chk = 31
   FOR ii := 1 TO LOOPSIZE
      sumLong := 1
      sumLong := sumLong * 2
   NEXT
CASE chk = 32
   FOR ii := 1 TO LOOPSIZE
      sumNumVar := 1.0
      sumNumVar *= 1.123
   NEXT
CASE chk = 33
   FOR ii := 1 TO LOOPSIZE
      sumFloat := 1.0
      sumFloat := sumFloat * 1.123
   NEXT
CASE chk = 40
   FOR ii := 1 TO LOOPSIZE
      sumNumVar := 30000.0
      sumNumVar /=  1.005
   NEXT
CASE chk = 41
   FOR ii := 1 TO LOOPSIZE
      sumFloat := 30000.0
      sumFloat := sumFloat / 1.005
   NEXT
ENDCASE
RETURN output (xSeconds() - act_time)


***************************************************************************
FUNCTION dbf_crea (line, text)
LOCAL stru := {{"char", "C", 10, 0}, ;
               {"num",  "N", 10, 0}}
output (line, text)
DBCREATE (dbfname, stru)
RETURN output ()

***************************************************************************
FUNCTION dbf_app1 (line, text, count)
LOCAL_LONG ii
output (line, text)
FOR ii := 1 to count
   APPEND BLANK
NEXT
COMMIT
RETURN output ()

***************************************************************************
FUNCTION dbf_app2 (line, text, count)
LOCAL_LONG ii
output (line, text)
FOR ii := 1 to count
   APPEND BLANK
   DbCommit()
NEXT
RETURN output ()

***************************************************************************
FUNCTION dbf_app3 (line, text, count)
LOCAL_LONG ii
output (line, text)
FOR ii := 1 to count
   APPEND BLANK
// SKIP 0
NEXT
COMMIT
RETURN output ()

***************************************************************************
FUNCTION dbf_zap  (line, text)
output (line, text)
ZAP
RETURN output ()

***************************************************************************
FUNCTION dbf_pack  (line, text)
go top
skip 100
while !eof()
   DELETE         // delete every 100th record
   skip 100
enddo
output (line, text)
PACK
RETURN output ()

***************************************************************************
FUNCTION dbf_repl (line, text, commit, count)
LOCAL first := "z", rec := 1
output (line, text)
GOTO TOP
DO WHILE !EOF() .and. rec <= count
   DO WHILE !RLOCK()
      @ 0,0 say "waiting for RLOCK"
      if INKEY(1) == 27
         QUIT
      ENDIF
      @ 0,0
   ENDDO
   REPLACE num  WITH RECNO() + 1
   REPLACE char WITH first + " text"
   first := IF (first == "A", "z", CHR(ASC(first) -1))
   UNLOCK
	if commit == 2
      COMMIT
   endif
   SKIP
   rec++
ENDDO
if commit == 1
	COMMIT
endif
RETURN output ()

***************************************************************************
FUNCTION dbf_ind1 (line, text)
output (line, text)
INDEX ON char to (index1)
RETURN output ()

***************************************************************************
FUNCTION dbf_ind2 (line, text)
output (line, text)
INDEX ON num to (index2)
RETURN output ()

***************************************************************************
FUNCTION dbf_seek1 (line, text)
LOCAL_LONG ii
LOCAL first, random, count := 0, col
output (line, text)
FOR ii := 1 to RECORD2
   random := ii % 56
   first = CHR(random + 65)
   SEEK first + " text"
   IF !FOUND() .and. val(first) > 0
      @ 0,0 SAY "[" + first + " text] not found (" + ltrim(STR(++count)) + ")"
      col := COL()
   ENDIF
NEXT
output ()
IF count > 0
   @ 0, col say "...any key..."
   INKEY(0)
   @ 0,0
ENDIF
RETURN NIL

***************************************************************************
FUNCTION dbf_seek2 (line, text)
LOCAL_LONG ii
LOCAL first := 4999, count := 0
LOCAL col
output (line, text)
FOR ii := 1 to RECORD2
   SEEK (first--)
   IF !FOUND() .and. first > 0
      @ 0,0 SAY "[" + STR(first,4) + "] not found (" + ltrim(STR(++count)) + ")"
      col := COL()
   ENDIF
NEXT
output ()
IF count > 0
   @ 0, col say "...any key..."
   INKEY(0)
   @ 0,0
ENDIF
RETURN NIL

***************************************************************************
FUNCTION center (line, text, color, guicol)
#ifdef FlagShip5
@ line, (min(79,MAXCOL()) - LEN(text)) / 2 SAY text COLOR color GUICOLOR guicol
#else
@ line, (min(79,MAXCOL()) - LEN(text)) / 2 SAY text COLOR color
#endif
if print
   set printer on
   ?
   ? text + " at "
   ?? date(), time()
   ?
   set printer off
endif
RETURN NIL

***************************************************************************
FUNCTION output (line, text)
STATIC time, time_sec, row, col, pcol
LOCAL ii, loctime
IF PCOUNT() > 1
   aadd (txtBuff, text)
   if print
      set printer on
      ? text
      pcol := PCOL()
      set printer off
   endif
   if line > MAXROW()
      scroll (0,0, MAXROW(), MAXCOL(), 1)
      line = MAXROW()
   endif
   @ line,0 say text
   time := xSeconds()
   time_sec := xSeconds()
   row  := ROW()
   col  := COL()
ELSE
   @ row, col+1 say ""
   SET CONSOLE ON
   FOR ii = col +1 TO 61
      ?? "."
   NEXT
   loctime := IF (PCOUNT() > 0, line, xSeconds() - time)
#ifdef FlagShip5
   @ row, 63 SAY loctime PICT "9999.999" COLOR col2 GUICOLOR col3
#else
   @ row, 63 SAY loctime PICT "9999.999" COLOR col2
#endif
#ifdef DISPLAY_FULL
   ii := xSeconds() - time_sec
   ?? " =" , str(ii, max(2, len(xltrim(ii))), 0)
#endif
   ?? " seconds"
   SET CONSOLE OFF
   if print
      SET PRINTER ON
      ?? " "
      FOR ii = pcol +1 TO 61
         ?? "."
      NEXT
      ?? str(loctime,7,3), "seconds"
      SET PRINTER OFF
   endif
ENDIF
RETURN NIL

***************************************************************************
function xSeconds()
#ifdef FlagShip
# ifdef FlagShip5
    return Seconds()       // Seconds() in FlafShip5 = 4 deci
# endif
  return SecondsCpu()      // get more accurate output in FlagShip 4.48
#endif
return Seconds()           // Seconds() in Clipper = 2 deci

function xltrim(p1)
#ifndef FlagShip
   if valtype(p1) == "N"      // required for Clipper only
      return ltrim(str(p1))
   endif
#endif
return ltrim(p1)

*** eof

