// -na compiler switch is required here,
// since file-wide static variable is used

// Note: w/o -na switch, 'PROCEDURE MYTEST1' is created here
// automatically from the file name; the static variable 
// is then located within this procedure instead of file-wide

static myVar := "static var"

/* We check here if there is a caller available. If not
 * so, this file/procedure is a main (should not be) and hence 
 * produces unexpected behavior - usually exits immediately -
 * we display here corresponding info.
 */
if empty(procname(1))   // caller available ?
   alert("Executing: " + procstack() + ;
         "; ;This PROCEDURE " + procname() + ;
         ";located in '" + procfile() + ;
         ".prg' file;is not the application's main/start-up," + ;
         ";use -Mtest compiler switch !")
endif

// test1() is called from mytest.prg
function test1
? "executing", procstack()
if valtype(myVar) == "C"
	?? " using", myVar
else
	?? " but 'myVar' is not available -> compiled w/o '-na' switch!"
endif
// x := myVar  // this will cause RTE 307 when compiled w/o -na
               // see mytest2.prg how to cleanly resolve this
return NIL
